import { Provider as b, useContextProps as E, useRenderProps as P } from "./ui-components-library119.js";
import { OverlayArrowContext as v } from "./ui-components-library99.js";
import { mergeProps as O } from "./ui-components-library123.js";
import { useLayoutEffect as T } from "./ui-components-library142.js";
import { useExitAnimation as R, useEnterAnimation as y } from "./ui-components-library174.js";
import { FocusableProvider as C } from "./ui-components-library101.js";
import n, { forwardRef as w, useRef as $, createContext as u, useContext as m, useState as h } from "react";
import { useTooltipTriggerState as p } from "./ui-components-library201.js";
import { useTooltipTrigger as S } from "./ui-components-library202.js";
import { useTooltip as A } from "./ui-components-library203.js";
import { OverlayContainer as B } from "./ui-components-library204.js";
import { useOverlayPosition as F } from "./ui-components-library205.js";
const d = /* @__PURE__ */ u(null), x = /* @__PURE__ */ u(null);
function J(e) {
  let r = p(e), t = $(null), { triggerProps: a, tooltipProps: i } = S(e, r, t);
  return /* @__PURE__ */ n.createElement(b, {
    values: [
      [
        d,
        r
      ],
      [
        x,
        {
          ...i,
          triggerRef: t
        }
      ]
    ]
  }, /* @__PURE__ */ n.createElement(C, {
    ...a,
    ref: t
  }, e.children));
}
const K = /* @__PURE__ */ w(function({ UNSTABLE_portalContainer: r, ...t }, a) {
  [t, a] = E(t, a, x);
  let i = m(d), l = p(t), f = t.isOpen != null || t.defaultOpen != null || !i ? l : i, o = R(a, f.isOpen) || t.isExiting || !1;
  return !f.isOpen && !o ? null : /* @__PURE__ */ n.createElement(B, {
    portalContainer: r
  }, /* @__PURE__ */ n.createElement(_, {
    ...t,
    tooltipRef: a,
    isExiting: o
  }));
});
function _(e) {
  let r = m(d), t = $(null), [a, i] = h(0);
  T(() => {
    t.current && r.isOpen && i(t.current.getBoundingClientRect().width);
  }, [
    r.isOpen,
    t
  ]);
  let { overlayProps: l, arrowProps: f, placement: o } = F({
    placement: e.placement || "top",
    targetRef: e.triggerRef,
    overlayRef: e.tooltipRef,
    offset: e.offset,
    crossOffset: e.crossOffset,
    isOpen: r.isOpen,
    arrowSize: a,
    arrowBoundaryOffset: e.arrowBoundaryOffset,
    shouldFlip: e.shouldFlip,
    onClose: () => r.close(!0)
  }), c = y(e.tooltipRef, !!o) || e.isEntering || !1, s = P({
    ...e,
    defaultClassName: "react-aria-Tooltip",
    values: {
      placement: o,
      isEntering: c,
      isExiting: e.isExiting,
      state: r
    }
  });
  e = O(e, l);
  let { tooltipProps: g } = A(e, r);
  return /* @__PURE__ */ n.createElement("div", {
    ...g,
    ref: e.tooltipRef,
    ...s,
    style: {
      ...l.style,
      ...s.style
    },
    "data-placement": o ?? void 0,
    "data-entering": c || void 0,
    "data-exiting": e.isExiting || void 0
  }, /* @__PURE__ */ n.createElement(v.Provider, {
    value: {
      ...f,
      placement: o,
      ref: t
    }
  }, s.children));
}
export {
  K as Tooltip,
  x as TooltipContext,
  J as TooltipTrigger,
  d as TooltipTriggerStateContext
};
