import { ButtonContext as B } from "./ui-components-library42.js";
import { useContextProps as I, useRenderProps as G, Provider as F, useSlottedContext as R } from "./ui-components-library119.js";
import { HeadingContext as V } from "./ui-components-library117.js";
import { TextContext as _ } from "./ui-components-library64.js";
import { createCalendar as A } from "./ui-components-library129.js";
import { endOfMonth as L, isSameMonth as T, isSameDay as O, getWeeksInMonth as U } from "./ui-components-library80.js";
import { mergeProps as j } from "./ui-components-library123.js";
import { filterDOMProps as x } from "./ui-components-library124.js";
import a, { createContext as v, forwardRef as C, useContext as m, useRef as q } from "react";
import { useLocale as M } from "./ui-components-library130.js";
import { useCalendarState as z } from "./ui-components-library131.js";
import { useCalendar as J } from "./ui-components-library132.js";
import { useCalendarGrid as K } from "./ui-components-library133.js";
import { useCalendarCell as Q } from "./ui-components-library134.js";
import { VisuallyHidden as H } from "./ui-components-library135.js";
import { useHover as X } from "./ui-components-library127.js";
import { useFocusRing as Y } from "./ui-components-library126.js";
const k = /* @__PURE__ */ v(null), Z = /* @__PURE__ */ v(null), y = /* @__PURE__ */ v(null), S = /* @__PURE__ */ v(null), Pe = /* @__PURE__ */ C(function(e, l) {
  [e, l] = I(e, l, k);
  let { locale: i } = M(), t = z({
    ...e,
    locale: i,
    createCalendar: A
  }), { calendarProps: n, prevButtonProps: d, nextButtonProps: s, errorMessageProps: f, title: c } = J(e, t), $ = G({
    ...e,
    values: {
      state: t,
      isDisabled: e.isDisabled || !1,
      isInvalid: t.isValueInvalid
    },
    defaultClassName: "react-aria-Calendar"
  });
  return /* @__PURE__ */ a.createElement("div", {
    ...$,
    ...n,
    ref: l,
    slot: e.slot || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-invalid": t.isValueInvalid || void 0
  }, /* @__PURE__ */ a.createElement(F, {
    values: [
      [
        B,
        {
          slots: {
            previous: d,
            next: s
          }
        }
      ],
      [
        V,
        {
          "aria-hidden": !0,
          level: 2,
          children: c
        }
      ],
      [
        y,
        t
      ],
      [
        k,
        e
      ],
      [
        _,
        {
          slots: {
            errorMessage: f
          }
        }
      ]
    ]
  }, /* @__PURE__ */ a.createElement(H, null, /* @__PURE__ */ a.createElement("h2", null, n["aria-label"])), $.children, /* @__PURE__ */ a.createElement(H, null, /* @__PURE__ */ a.createElement("button", {
    "aria-label": s["aria-label"],
    disabled: s.isDisabled,
    onClick: () => t.focusNextPage(),
    tabIndex: -1
  }))));
}), g = /* @__PURE__ */ v(null), De = /* @__PURE__ */ C(function(e, l) {
  let i = m(y), t = m(S), n = R(k), d = R(Z), s = i ?? t, f = s.visibleRange.start;
  e.offset && (f = f.add(e.offset));
  var c;
  let $ = (c = n == null ? void 0 : n.firstDayOfWeek) !== null && c !== void 0 ? c : d == null ? void 0 : d.firstDayOfWeek, { gridProps: p, headerProps: r, weekDays: b } = K({
    startDate: f,
    endDate: L(f),
    weekdayStyle: e.weekdayStyle,
    firstDayOfWeek: $
  }, s);
  var u;
  return /* @__PURE__ */ a.createElement(g.Provider, {
    value: {
      headerProps: r,
      weekDays: b,
      startDate: f,
      firstDayOfWeek: $
    }
  }, /* @__PURE__ */ a.createElement("table", {
    ...x(e),
    ...p,
    ref: l,
    style: e.style,
    className: (u = e.className) !== null && u !== void 0 ? u : "react-aria-CalendarGrid"
  }, typeof e.children != "function" ? e.children : /* @__PURE__ */ a.createElement(a.Fragment, null, /* @__PURE__ */ a.createElement(ae, null, (P) => /* @__PURE__ */ a.createElement(de, null, P)), /* @__PURE__ */ a.createElement(le, null, e.children))));
});
function ee(o, e) {
  let { children: l, style: i, className: t } = o, { headerProps: n, weekDays: d } = m(g);
  return /* @__PURE__ */ a.createElement("thead", {
    ...x(o),
    ...n,
    ref: e,
    style: i,
    className: t || "react-aria-CalendarGridHeader"
  }, /* @__PURE__ */ a.createElement("tr", null, d.map((s, f) => /* @__PURE__ */ a.cloneElement(l(s), {
    key: f
  }))));
}
const ae = /* @__PURE__ */ C(ee);
function te(o, e) {
  let { children: l, style: i, className: t } = o;
  return /* @__PURE__ */ a.createElement("th", {
    ...x(o),
    ref: e,
    style: i,
    className: t || "react-aria-CalendarHeaderCell"
  }, l);
}
const de = /* @__PURE__ */ C(te);
function re(o, e) {
  let { children: l, style: i, className: t } = o, n = m(y), d = m(S), s = n ?? d, { startDate: f, firstDayOfWeek: c } = m(g), { locale: $ } = M(), p = U(f, $, c);
  return /* @__PURE__ */ a.createElement("tbody", {
    ...x(o),
    ref: e,
    style: i,
    className: t || "react-aria-CalendarGridBody"
  }, [
    ...new Array(p).keys()
  ].map((r) => /* @__PURE__ */ a.createElement("tr", {
    key: r
  }, s.getDatesInWeek(r, f).map((b, u) => b ? /* @__PURE__ */ a.cloneElement(l(b), {
    key: u
  }) : /* @__PURE__ */ a.createElement("td", {
    key: u
  })))));
}
const le = /* @__PURE__ */ C(re), Ee = /* @__PURE__ */ C(function({ date: e, ...l }, i) {
  let t = m(y), n = m(S), d = t ?? n;
  var s;
  let { startDate: f } = (s = m(g)) !== null && s !== void 0 ? s : {
    startDate: d.visibleRange.start
  }, c = q(null), { cellProps: $, buttonProps: p, ...r } = Q({
    date: e
  }, d, c), { hoverProps: b, isHovered: u } = X({
    ...l,
    isDisabled: r.isDisabled
  }), { focusProps: P, isFocusVisible: h } = Y();
  h && (h = r.isFocused);
  let N = !T(f, e), D = !1, E = !1;
  "highlightedRange" in d && d.highlightedRange && (D = O(e, d.highlightedRange.start), E = O(e, d.highlightedRange.end));
  let W = G({
    ...l,
    defaultChildren: r.formattedDate,
    defaultClassName: "react-aria-CalendarCell",
    values: {
      date: e,
      isHovered: u,
      isOutsideMonth: N,
      isFocusVisible: h,
      isSelectionStart: D,
      isSelectionEnd: E,
      ...r
    }
  }), w = {
    "data-focused": r.isFocused || void 0,
    "data-hovered": u || void 0,
    "data-pressed": r.isPressed || void 0,
    "data-unavailable": r.isUnavailable || void 0,
    "data-disabled": r.isDisabled || void 0,
    "data-focus-visible": h || void 0,
    "data-outside-visible-range": r.isOutsideVisibleRange || void 0,
    "data-outside-month": N || void 0,
    "data-selected": r.isSelected || void 0,
    "data-selection-start": D || void 0,
    "data-selection-end": E || void 0,
    "data-invalid": r.isInvalid || void 0
  };
  return /* @__PURE__ */ a.createElement("td", {
    ...$,
    ref: i
  }, /* @__PURE__ */ a.createElement("div", {
    ...j(x(l), p, P, b, w, W),
    ref: c
  }));
});
export {
  Pe as Calendar,
  Ee as CalendarCell,
  k as CalendarContext,
  De as CalendarGrid,
  le as CalendarGridBody,
  ae as CalendarGridHeader,
  de as CalendarHeaderCell,
  y as CalendarStateContext,
  Z as RangeCalendarContext,
  S as RangeCalendarStateContext
};
