import { BuddhistCalendar as a } from "./ui-components-library304.js";
import { CopticCalendar as r, EthiopicAmeteAlemCalendar as c, EthiopicCalendar as n } from "./ui-components-library310.js";
import { GregorianCalendar as t } from "./ui-components-library299.js";
import { HebrewCalendar as d } from "./ui-components-library309.js";
import { IndianCalendar as f } from "./ui-components-library307.js";
import { IslamicUmalquraCalendar as o, IslamicTabularCalendar as i, IslamicCivilCalendar as $ } from "./ui-components-library308.js";
import { JapaneseCalendar as s } from "./ui-components-library303.js";
import { PersianCalendar as b } from "./ui-components-library306.js";
import { TaiwanCalendar as p } from "./ui-components-library305.js";
function q(e) {
  switch (e) {
    case "buddhist":
      return new a();
    case "ethiopic":
      return new n();
    case "ethioaa":
      return new c();
    case "coptic":
      return new r();
    case "hebrew":
      return new d();
    case "indian":
      return new f();
    case "islamic-civil":
      return new $();
    case "islamic-tbla":
      return new i();
    case "islamic-umalqura":
      return new o();
    case "japanese":
      return new s();
    case "persian":
      return new b();
    case "roc":
      return new p();
    case "gregory":
    default:
      return new t();
  }
}
export {
  q as createCalendar
};
