import { constrainValue as m, alignCenter as j, alignEnd as q, alignStart as S, isInvalid as W, constrainStart as z, previousAvailableDate as le } from "./ui-components-library364.js";
import { GregorianCalendar as se } from "./ui-components-library299.js";
import { toCalendar as g, toCalendarDate as Z } from "./ui-components-library300.js";
import { today as ie, startOfWeek as H, getDayOfWeek as ne, isSameDay as F, endOfWeek as de, endOfMonth as re, startOfMonth as fe } from "./ui-components-library80.js";
import { DateFormatter as ue } from "./ui-components-library312.js";
import { useControlledState as J } from "./ui-components-library207.js";
import { useMemo as c, useState as _ } from "react";
function ye(l) {
  let V = c(() => new ue(l.locale), [
    l.locale
  ]), D = c(() => V.resolvedOptions(), [
    V
  ]), { locale: d, createCalendar: A, visibleDuration: a = {
    months: 1
  }, minValue: s, maxValue: i, selectionAlignment: K, isDateUnavailable: y, pageBehavior: M = "visible", firstDayOfWeek: B } = l, o = c(() => A(D.calendar), [
    A,
    D.calendar
  ]);
  var O;
  let [r, I] = J(l.value, (O = l.defaultValue) !== null && O !== void 0 ? O : null, l.onChange), $ = c(() => r ? g(Z(r), o) : null, [
    r,
    o
  ]), P = c(() => r && "timeZone" in r ? r.timeZone : D.timeZone, [
    r,
    D.timeZone
  ]), Q = c(() => l.focusedValue ? m(g(Z(l.focusedValue), o), s, i) : void 0, [
    l.focusedValue,
    o,
    s,
    i
  ]), T = c(() => m(l.defaultFocusedValue ? g(Z(l.defaultFocusedValue), o) : $ || g(ie(P), o), s, i), [
    l.defaultFocusedValue,
    $,
    P,
    o,
    s,
    i
  ]), [t, C] = J(Q, T, l.onFocusChange), [f, k] = _(() => {
    switch (K) {
      case "start":
        return S(t, a, d, s, i);
      case "end":
        return q(t, a, d, s, i);
      case "center":
      default:
        return j(t, a, d, s, i);
    }
  }), [E, G] = _(l.autoFocus || !1), h = c(() => {
    let e = {
      ...a
    };
    return e.days ? e.days-- : e.days = -1, f.add(e);
  }, [
    f,
    a
  ]), [X, Y] = _(o.identifier);
  if (o.identifier !== X) {
    let e = g(t, o);
    k(j(e, a, d, s, i)), C(e), Y(o.identifier);
  }
  W(t, s, i) ? C(m(t, s, i)) : t.compare(f) < 0 ? k(q(t, a, d, s, i)) : t.compare(h) > 0 && k(S(t, a, d, s, i));
  function n(e) {
    e = m(e, s, i), C(e);
  }
  function R(e) {
    if (!l.isDisabled && !l.isReadOnly) {
      let u = e;
      if (u === null) {
        I(null);
        return;
      }
      if (u = m(u, s, i), u = le(u, f, y), !u) return;
      u = g(u, (r == null ? void 0 : r.calendar) || new se()), r && "hour" in r ? I(r.set(u)) : I(u);
    }
  }
  let ee = c(() => $ ? y && y($) ? !0 : W($, s, i) : !1, [
    $,
    y,
    s,
    i
  ]), L = l.isInvalid || l.validationState === "invalid" || ee, ae = L ? "invalid" : null, b = c(() => M === "visible" ? a : p(a), [
    M,
    a
  ]);
  var N, U;
  return {
    isDisabled: (N = l.isDisabled) !== null && N !== void 0 ? N : !1,
    isReadOnly: (U = l.isReadOnly) !== null && U !== void 0 ? U : !1,
    value: $,
    setValue: R,
    visibleRange: {
      start: f,
      end: h
    },
    minValue: s,
    maxValue: i,
    focusedDate: t,
    timeZone: P,
    validationState: ae,
    isValueInvalid: L,
    setFocusedDate(e) {
      n(e), G(!0);
    },
    focusNextDay() {
      n(t.add({
        days: 1
      }));
    },
    focusPreviousDay() {
      n(t.subtract({
        days: 1
      }));
    },
    focusNextRow() {
      a.days ? this.focusNextPage() : (a.weeks || a.months || a.years) && n(t.add({
        weeks: 1
      }));
    },
    focusPreviousRow() {
      a.days ? this.focusPreviousPage() : (a.weeks || a.months || a.years) && n(t.subtract({
        weeks: 1
      }));
    },
    focusNextPage() {
      let e = f.add(b);
      C(m(t.add(b), s, i)), k(S(z(t, e, b, d, s, i), b, d));
    },
    focusPreviousPage() {
      let e = f.subtract(b);
      C(m(t.subtract(b), s, i)), k(S(z(t, e, b, d, s, i), b, d));
    },
    focusSectionStart() {
      a.days ? n(f) : a.weeks ? n(H(t, d)) : (a.months || a.years) && n(fe(t));
    },
    focusSectionEnd() {
      a.days ? n(h) : a.weeks ? n(de(t, d)) : (a.months || a.years) && n(re(t));
    },
    focusNextSection(e) {
      if (!e && !a.days) {
        n(t.add(p(a)));
        return;
      }
      a.days ? this.focusNextPage() : a.weeks ? n(t.add({
        months: 1
      })) : (a.months || a.years) && n(t.add({
        years: 1
      }));
    },
    focusPreviousSection(e) {
      if (!e && !a.days) {
        n(t.subtract(p(a)));
        return;
      }
      a.days ? this.focusPreviousPage() : a.weeks ? n(t.subtract({
        months: 1
      })) : (a.months || a.years) && n(t.subtract({
        years: 1
      }));
    },
    selectFocusedDate() {
      y && y(t) || R(t);
    },
    selectDate(e) {
      R(e);
    },
    isFocused: E,
    setFocused: G,
    isInvalid(e) {
      return W(e, s, i);
    },
    isSelected(e) {
      return $ != null && F(e, $) && !this.isCellDisabled(e) && !this.isCellUnavailable(e);
    },
    isCellFocused(e) {
      return E && t && F(e, t);
    },
    isCellDisabled(e) {
      return l.isDisabled || e.compare(f) < 0 || e.compare(h) > 0 || this.isInvalid(e);
    },
    isCellUnavailable(e) {
      return l.isDateUnavailable ? l.isDateUnavailable(e) : !1;
    },
    isPreviousVisibleRangeInvalid() {
      let e = f.subtract({
        days: 1
      });
      return F(e, f) || this.isInvalid(e);
    },
    isNextVisibleRangeInvalid() {
      let e = h.add({
        days: 1
      });
      return F(e, h) || this.isInvalid(e);
    },
    getDatesInWeek(e, u = f) {
      let v = u.add({
        weeks: e
      }), x = [];
      v = H(v, d, B);
      let te = ne(v, d, B);
      for (let w = 0; w < te; w++) x.push(null);
      for (; x.length < 7; ) {
        x.push(v);
        let w = v.add({
          days: 1
        });
        if (F(v, w)) break;
        v = w;
      }
      for (; x.length < 7; ) x.push(null);
      return x;
    }
  };
}
function p(l) {
  let V = {
    ...l
  };
  for (let D in l) V[D] = 1;
  return V;
}
export {
  ye as useCalendarState
};
