import { j as e } from "./ui-components-library39.js";
import { useId as w } from "react";
import y from "./ui-components-library55.js";
import z from "./ui-components-library56.js";
import T from "./ui-components-library57.js";
import $ from "./ui-components-library58.js";
import B from "./ui-components-library59.js";
import E from "./ui-components-library60.js";
import { cn as o } from "./ui-components-library41.js";
import { clsx as n } from "./ui-components-library47.js";
import { useBigNumberField as F } from "./ui-components-library65.js";
import { Button as a } from "./ui-components-library42.js";
import { Group as P } from "./ui-components-library61.js";
import { Input as W } from "./ui-components-library62.js";
function V({
  variant: r,
  message: i,
  Icon: s,
  className: u,
  placeholder: f,
  label: m,
  isDisabled: c,
  id: x,
  isReadOnly: d,
  ...b
}) {
  const h = w(), k = x || h, {
    inputProps: t,
    labelProps: g,
    incrementButtonProps: I,
    decrementButtonProps: U,
    groupProps: C,
    descriptionProps: j,
    errorMessageProps: S
  } = F({ id: k, isDisabled: c, placeholder: f, isReadOnly: d, ...b });
  return /* @__PURE__ */ e.jsxs("div", { className: o("flex w-[278px] flex-col", u), children: [
    m && /* @__PURE__ */ e.jsx(
      "label",
      {
        ...g,
        className: "text-klerosUIComponentsSecondaryText mb-1 text-sm",
        children: m
      }
    ),
    /* @__PURE__ */ e.jsx(
      P,
      {
        ...C,
        isDisabled: c || d,
        className: "input-wrapper relative box-border h-[45px] w-full",
        children: ({ isHovered: N, isDisabled: p }) => /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
          /* @__PURE__ */ e.jsx(
            W,
            {
              ...t,
              className: o(
                "hover-short-transition bg-klerosUIComponentsWhiteBackground size-full",
                "rounded-base border-klerosUIComponentsStroke text-klerosUIComponentsPrimaryText border text-base",
                "placeholder:text-klerosUIComponentsSecondaryText placeholder:opacity-50",
                "focus:border-klerosUIComponentsPrimaryBlue focus:shadow-input focus:rounded-base focus:outline-none",
                "focus:invalid:border-klerosUIComponentsError focus:invalid:shadow-klerosUIComponentsError",
                !p && "hover-medium-blue",
                "py-3.5 pr-7.5 pl-4",
                { "pr-13": r && r !== "info", "pr-16": s },
                {
                  "border-klerosUIComponentsWarning": r === "warning",
                  "border-klerosUIComponentsError": r === "error",
                  "border-klerosUIComponentsSuccess": r === "success"
                },
                t == null ? void 0 : t.className
              )
            }
          ),
          /* @__PURE__ */ e.jsxs(
            "div",
            {
              className: o(
                "animate-fade-in absolute top-0 right-3 hidden h-full w-3.5",
                N && !p && "flex flex-col items-center justify-center gap-1",
                {
                  "right-9": r && r !== "info",
                  "right-12": s
                }
              ),
              children: [
                /* @__PURE__ */ e.jsx(
                  a,
                  {
                    ...I,
                    excludeFromTabOrder: !0,
                    className: n(
                      "rounded-base hover:bg-klerosUIComponentsStroke size-3.5 cursor-pointer border-none bg-transparent",
                      "flex items-center justify-center",
                      "disabled:cursor-default"
                    ),
                    children: ({ isDisabled: l }) => /* @__PURE__ */ e.jsx(
                      B,
                      {
                        className: n(
                          "size-2",
                          l ? "[&_path]:fill-klerosUIComponentsStroke" : "[&_path]:fill-klerosUIComponentsSecondaryText"
                        )
                      }
                    )
                  }
                ),
                /* @__PURE__ */ e.jsx(
                  a,
                  {
                    ...U,
                    excludeFromTabOrder: !0,
                    className: n(
                      "rounded-base hover:bg-klerosUIComponentsStroke size-3.5 cursor-pointer border-none bg-transparent",
                      "flex items-center justify-center",
                      "disabled:cursor-default"
                    ),
                    children: ({ isDisabled: l }) => /* @__PURE__ */ e.jsx(
                      E,
                      {
                        className: n(
                          "size-2",
                          l ? "[&_path]:fill-klerosUIComponentsStroke" : "[&_path]:fill-klerosUIComponentsSecondaryText"
                        )
                      }
                    )
                  }
                )
              ]
            }
          ),
          r === "success" && /* @__PURE__ */ e.jsx(y, { className: "fill-klerosUIComponentsSuccess absolute top-3.5 right-4 size-4" }),
          r === "warning" && /* @__PURE__ */ e.jsx(z, { className: "fill-klerosUIComponentsWarning absolute top-3.5 right-4 size-4" }),
          r === "error" && /* @__PURE__ */ e.jsx(T, { className: "fill-klerosUIComponentsError absolute top-3.5 right-4 size-4" }),
          s && /* @__PURE__ */ e.jsx(
            "div",
            {
              className: o(
                "bg-klerosUIComponentsLightBlue absolute top-0.25 right-0.25 h-10.75 w-11",
                "border-l-klerosUIComponentsStroke rounded-r-base border-l",
                "flex items-center justify-center"
              ),
              children: /* @__PURE__ */ e.jsx(s, { className: "size-6" })
            }
          )
        ] })
      }
    ),
    i && /* @__PURE__ */ e.jsxs(
      "div",
      {
        ...r === "error" ? S : j,
        className: o(
          "relative mt-1.25 flex items-center",
          "text-klerosUIComponentsSecondaryText text-justify text-sm break-words",
          {
            "text-klerosUIComponentsSuccess": r === "success",
            "text-klerosUIComponentsError": r === "error",
            "text-klerosUIComponentsWarning": r === "warning"
          }
        ),
        children: [
          r === "info" && /* @__PURE__ */ e.jsx($, { className: "fill-klerosUIComponentsSecondaryText mr-2 max-w-4 min-w-4" }),
          i
        ]
      }
    )
  ] });
}
export {
  V as default
};
