import { hookData as G } from "./ui-components-library145.js";
import { useDisplayNames as J } from "./ui-components-library390.js";
import { CalendarDate as Q } from "./ui-components-library296.js";
import { toCalendar as X } from "./ui-components-library300.js";
import { useId as Y } from "./ui-components-library122.js";
import { mergeProps as g } from "./ui-components-library123.js";
import { useLabels as ee } from "./ui-components-library152.js";
import { useLayoutEffect as re } from "./ui-components-library142.js";
import { getScrollParent as ae } from "./ui-components-library284.js";
import { isIOS as te, isMac as ie } from "./ui-components-library278.js";
import { useEvent as v } from "./ui-components-library288.js";
import { scrollIntoViewport as oe } from "./ui-components-library290.js";
import { NumberParser as le } from "./ui-components-library374.js";
import ne, { useRef as P, useMemo as f } from "react";
import { useLocale as de } from "./ui-components-library130.js";
import { useDateFormatter as $ } from "./ui-components-library382.js";
import { useFilter as ue } from "./ui-components-library391.js";
import { useSpinButton as ce } from "./ui-components-library392.js";
function Re(r, a, o) {
  let l = P(""), { locale: D, direction: E } = de(), O = J(), { ariaLabel: V, ariaLabelledBy: w, ariaDescribedBy: S, focusManager: u } = G.get(a), p = r.isPlaceholder ? "" : r.text, m = f(() => a.dateFormatter.resolvedOptions(), [
    a.dateFormatter
  ]), I = $({
    month: "long",
    timeZone: m.timeZone
  }), B = $({
    hour: "numeric",
    hour12: m.hour12,
    timeZone: m.timeZone
  });
  if (r.type === "month" && !r.isPlaceholder) {
    let e = I.format(a.dateValue);
    p = e !== p ? `${p} – ${e}` : e;
  } else r.type === "hour" && !r.isPlaceholder && (p = B.format(a.dateValue));
  let { spinButtonProps: K } = ce({
    // The ARIA spec says aria-valuenow is optional if there's no value, but aXe seems to require it.
    // This doesn't seem to have any negative effects with real AT since we also use aria-valuetext.
    // https://github.com/dequelabs/axe-core/issues/3505
    value: r.value,
    textValue: p,
    minValue: r.minValue,
    maxValue: r.maxValue,
    isDisabled: a.isDisabled,
    isReadOnly: a.isReadOnly || !r.isEditable,
    isRequired: a.isRequired,
    onIncrement: () => {
      l.current = "", a.increment(r.type);
    },
    onDecrement: () => {
      l.current = "", a.decrement(r.type);
    },
    onIncrementPage: () => {
      l.current = "", a.incrementPage(r.type);
    },
    onDecrementPage: () => {
      l.current = "", a.decrementPage(r.type);
    },
    onIncrementToMax: () => {
      l.current = "", r.maxValue !== void 0 && a.setSegment(r.type, r.maxValue);
    },
    onDecrementToMin: () => {
      l.current = "", r.minValue !== void 0 && a.setSegment(r.type, r.minValue);
    }
  }), d = f(() => new le(D, {
    maximumFractionDigits: 0
  }), [
    D
  ]), C = () => {
    if (r.text === r.placeholder && u.focusPrevious(), d.isValidPartialNumber(r.text) && !a.isReadOnly && !r.isPlaceholder) {
      let e = r.text.slice(0, -1), t = d.parse(e);
      e = t === 0 ? "" : e, e.length === 0 || t === 0 ? a.clearSegment(r.type) : a.setSegment(r.type, t), l.current = e;
    } else r.type === "dayPeriod" && a.clearSegment(r.type);
  }, L = (e) => {
    if (e.key === "a" && (ie() ? e.metaKey : e.ctrlKey) && e.preventDefault(), !(e.ctrlKey || e.metaKey || e.shiftKey || e.altKey))
      switch (e.key) {
        case "Backspace":
        case "Delete":
          e.preventDefault(), e.stopPropagation(), C();
          break;
      }
  }, { startsWith: s } = ue({
    sensitivity: "base"
  }), b = $({
    hour: "numeric",
    hour12: !0
  }), N = f(() => {
    let e = /* @__PURE__ */ new Date();
    return e.setHours(0), b.formatToParts(e).find((t) => t.type === "dayPeriod").value;
  }, [
    b
  ]), F = f(() => {
    let e = /* @__PURE__ */ new Date();
    return e.setHours(12), b.formatToParts(e).find((t) => t.type === "dayPeriod").value;
  }, [
    b
  ]), k = $({
    year: "numeric",
    era: "narrow",
    timeZone: "UTC"
  }), M = f(() => {
    if (r.type !== "era") return [];
    let e = X(new Q(1, 1, 1), a.calendar), t = a.calendar.getEras().map((n) => {
      let y = e.set({
        year: 1,
        month: 1,
        day: 1,
        era: n
      }).toDate("UTC"), z = k.formatToParts(y).find((A) => A.type === "era").value;
      return {
        era: n,
        formatted: z
      };
    }), i = fe(t.map((n) => n.formatted));
    if (i) for (let n of t) n.formatted = n.formatted.slice(i);
    return t;
  }, [
    k,
    a.calendar,
    r.type
  ]), R = (e) => {
    if (a.isDisabled || a.isReadOnly) return;
    let t = l.current + e;
    switch (r.type) {
      case "dayPeriod":
        if (s(N, e)) a.setSegment("dayPeriod", 0);
        else if (s(F, e)) a.setSegment("dayPeriod", 12);
        else break;
        u.focusNext();
        break;
      case "era": {
        let i = M.find((n) => s(n.formatted, e));
        i && (a.setSegment("era", i.era), u.focusNext());
        break;
      }
      case "day":
      case "hour":
      case "minute":
      case "second":
      case "month":
      case "year": {
        if (!d.isValidPartialNumber(t)) return;
        let i = d.parse(t), n = i, y = r.minValue === 0;
        if (r.type === "hour" && a.dateFormatter.resolvedOptions().hour12) {
          switch (a.dateFormatter.resolvedOptions().hourCycle) {
            case "h11":
              i > 11 && (n = d.parse(e));
              break;
            case "h12":
              y = !1, i > 12 && (n = d.parse(e));
              break;
          }
          r.value !== void 0 && r.value >= 12 && i > 1 && (i += 12);
        } else r.maxValue !== void 0 && i > r.maxValue && (n = d.parse(e));
        if (isNaN(i)) return;
        let h = n !== 0 || y;
        h && a.setSegment(r.type, n), r.maxValue !== void 0 && (+(i + "0") > r.maxValue || t.length >= String(r.maxValue).length) ? (l.current = "", h && u.focusNext()) : l.current = t;
        break;
      }
    }
  }, Z = () => {
    l.current = "", o.current && oe(o.current, {
      containingElement: ae(o.current)
    });
    let e = window.getSelection();
    e == null || e.collapse(o.current);
  }, _ = P(typeof document < "u" ? document : null);
  v(_, "selectionchange", () => {
    var e;
    let t = window.getSelection();
    t != null && t.anchorNode && (!((e = o.current) === null || e === void 0) && e.contains(t == null ? void 0 : t.anchorNode)) && t.collapse(o.current);
  });
  let T = P("");
  v(o, "beforeinput", (e) => {
    if (o.current)
      switch (e.preventDefault(), e.inputType) {
        case "deleteContentBackward":
        case "deleteContentForward":
          d.isValidPartialNumber(r.text) && !a.isReadOnly && C();
          break;
        case "insertCompositionText":
          T.current = o.current.textContent, o.current.textContent = o.current.textContent;
          break;
        default:
          e.data != null && R(e.data);
          break;
      }
  }), v(o, "input", (e) => {
    let { inputType: t, data: i } = e;
    switch (t) {
      case "insertCompositionText":
        o.current && (o.current.textContent = T.current), i != null && (s(N, i) || s(F, i)) && R(i);
        break;
    }
  }), re(() => {
    let e = o.current;
    return () => {
      document.activeElement === e && (u.focusPrevious() || u.focusNext());
    };
  }, [
    o,
    u
  ]);
  let H = te() || r.type === "timeZoneName" ? {
    role: "textbox",
    "aria-valuemax": null,
    "aria-valuemin": null,
    "aria-valuetext": null,
    "aria-valuenow": null
  } : {}, W = f(() => a.segments.find((e) => e.isEditable), [
    a.segments
  ]);
  r !== W && !a.isInvalid && (S = void 0);
  let q = Y(), c = !a.isDisabled && !a.isReadOnly && r.isEditable, U = r.type === "literal" ? "" : O.of(r.type), j = ee({
    "aria-label": `${U}${V ? `, ${V}` : ""}${w ? ", " : ""}`,
    "aria-labelledby": w
  });
  if (r.type === "literal") return {
    segmentProps: {
      "aria-hidden": !0
    }
  };
  let x = {
    caretColor: "transparent"
  };
  if (E === "rtl") {
    x.unicodeBidi = "embed";
    let e = m[r.type];
    (e === "numeric" || e === "2-digit") && (x.direction = "ltr");
  }
  return {
    segmentProps: g(K, j, {
      id: q,
      ...H,
      "aria-invalid": a.isInvalid ? "true" : void 0,
      "aria-describedby": S,
      "aria-readonly": a.isReadOnly || !r.isEditable ? "true" : void 0,
      "data-placeholder": r.isPlaceholder || void 0,
      contentEditable: c,
      suppressContentEditableWarning: c,
      spellCheck: c ? "false" : void 0,
      autoCorrect: c ? "off" : void 0,
      // Capitalization was changed in React 17...
      [parseInt(ne.version, 10) >= 17 ? "enterKeyHint" : "enterkeyhint"]: c ? "next" : void 0,
      inputMode: a.isDisabled || r.type === "dayPeriod" || r.type === "era" || !c ? void 0 : "numeric",
      tabIndex: a.isDisabled ? void 0 : 0,
      onKeyDown: L,
      onFocus: Z,
      style: x,
      // Prevent pointer events from reaching useDatePickerGroup, and allow native browser behavior to focus the segment.
      onPointerDown(e) {
        e.stopPropagation();
      },
      onMouseDown(e) {
        e.stopPropagation();
      }
    })
  };
}
function fe(r) {
  r.sort();
  let a = r[0], o = r[r.length - 1];
  for (let l = 0; l < a.length; l++)
    if (a[l] !== o[l]) return l;
  return 0;
}
export {
  Re as useDateSegment
};
