import R from "./ui-components-library387.js";
import { useDatePickerGroup as k } from "./ui-components-library388.js";
import { createFocusManager as E } from "./ui-components-library171.js";
import { mergeProps as P } from "./ui-components-library123.js";
import { filterDOMProps as V } from "./ui-components-library124.js";
import { useDescription as C } from "./ui-components-library287.js";
import { useFormReset as I } from "./ui-components-library293.js";
import { useFocusWithin as S } from "./ui-components-library341.js";
import { useRef as y, useMemo as G, useEffect as L } from "react";
import { useField as O } from "./ui-components-library389.js";
import { useFormValidation as U } from "./ui-components-library384.js";
import { useLocalizedStringFormatter as j } from "./ui-components-library156.js";
function q(e) {
  return e && e.__esModule ? e.default : e;
}
const T = /* @__PURE__ */ new WeakMap(), c = "__role_" + Date.now(), z = "__focusManager_" + Date.now();
function re(e, a, l) {
  var n;
  let { isInvalid: u, validationErrors: f, validationDetails: g } = a.displayValidation, { labelProps: b, fieldProps: d, descriptionProps: D, errorMessageProps: F } = O({
    ...e,
    labelElementType: "span",
    isInvalid: u,
    errorMessage: e.errorMessage || f
  }), m = y(null), { focusWithinProps: x } = S({
    ...e,
    onFocusWithin(o) {
      var i;
      m.current = a.value, (i = e.onFocus) === null || i === void 0 || i.call(e, o);
    },
    onBlurWithin: (o) => {
      var i;
      a.confirmPlaceholder(), a.value !== m.current && a.commitValidation(), (i = e.onBlur) === null || i === void 0 || i.call(e, o);
    },
    onFocusWithinChange: e.onFocusChange
  }), h = j(q(R), "@react-aria/datepicker"), M = a.maxGranularity === "hour" ? "selectedTimeDescription" : "selectedDateDescription", _ = a.maxGranularity === "hour" ? "time" : "date", B = a.value ? h.format(M, {
    [_]: a.formatValue({
      month: "long"
    })
  }) : "", W = C(B), $ = e[c] === "presentation" ? d["aria-describedby"] : [
    W["aria-describedby"],
    d["aria-describedby"]
  ].filter(Boolean).join(" ") || void 0, p = e[z], r = G(() => p || E(l), [
    p,
    l
  ]), w = k(a, l, e[c] === "presentation");
  T.set(a, {
    ariaLabel: e["aria-label"],
    ariaLabelledBy: [
      b.id,
      e["aria-labelledby"]
    ].filter(Boolean).join(" ") || void 0,
    ariaDescribedBy: $,
    focusManager: r
  });
  let v = y(e.autoFocus), s;
  e[c] === "presentation" ? s = {
    role: "presentation"
  } : s = P(d, {
    role: "group",
    "aria-disabled": e.isDisabled || void 0,
    "aria-describedby": $
  }), L(() => {
    v.current && r.focusFirst(), v.current = !1;
  }, [
    r
  ]), I(e.inputRef, a.value, a.setValue), U({
    ...e,
    focus() {
      r.focusFirst();
    }
  }, a, e.inputRef);
  let t = {
    type: "hidden",
    name: e.name,
    value: ((n = a.value) === null || n === void 0 ? void 0 : n.toString()) || "",
    disabled: e.isDisabled
  };
  e.validationBehavior === "native" && (t.type = "text", t.hidden = !0, t.required = e.isRequired, t.onChange = () => {
  });
  let K = V(e);
  return {
    labelProps: {
      ...b,
      onClick: () => {
        r.focusFirst();
      }
    },
    fieldProps: P(K, s, w, x, {
      onKeyDown(o) {
        e.onKeyDown && e.onKeyDown(o);
      },
      onKeyUp(o) {
        e.onKeyUp && e.onKeyUp(o);
      },
      style: {
        unicodeBidi: "isolate"
      }
    }),
    inputProps: t,
    descriptionProps: D,
    errorMessageProps: F,
    isInvalid: u,
    validationErrors: f,
    validationDetails: g
  };
}
export {
  z as focusManagerSymbol,
  T as hookData,
  c as roleSymbol,
  re as useDateField
};
