import { useDefaultProps as ie, convertValue as ne, createPlaceholderDate as D, getFormatOptions as Y, getValidationResult as ue } from "./ui-components-library365.js";
import { getPlaceholder as oe } from "./ui-components-library367.js";
import { GregorianCalendar as se } from "./ui-components-library299.js";
import { toCalendar as Q } from "./ui-components-library300.js";
import { getMinimumDayInMonth as ce, getMinimumMonthInYear as de } from "./ui-components-library80.js";
import { DateFormatter as T } from "./ui-components-library312.js";
import { useFormValidationState as fe } from "./ui-components-library366.js";
import { useControlledState as he } from "./ui-components-library207.js";
import { useMemo as $, useState as W, useRef as X, useEffect as me } from "react";
const _ = {
  year: !0,
  month: !0,
  day: !0,
  hour: !0,
  minute: !0,
  second: !0,
  dayPeriod: !0,
  era: !0
}, ee = {
  year: 5,
  month: 2,
  day: 7,
  hour: 2,
  minute: 15,
  second: 15
}, ye = {
  dayperiod: "dayPeriod"
};
function Me(e) {
  let { locale: r, createCalendar: o, hideTimeZone: s, isDisabled: c = !1, isReadOnly: y = !1, isRequired: M = !1, minValue: O, maxValue: k, isDateUnavailable: j } = e, d = e.value || e.defaultValue || e.placeholderValue || null, [l, m] = ie(d, e.granularity), S = m || "UTC";
  if (d && !(l in d)) throw new Error("Invalid granularity " + l + " for value " + d.toString());
  let w = $(() => new T(r), [
    r
  ]), i = $(() => o(w.resolvedOptions().calendar), [
    o,
    w
  ]);
  var Z;
  let [b, K] = he(e.value, (Z = e.defaultValue) !== null && Z !== void 0 ? Z : null, e.onChange), E = $(() => {
    var a;
    return (a = ne(b, i)) !== null && a !== void 0 ? a : null;
  }, [
    b,
    i
  ]), [q, C] = W(() => D(e.placeholderValue, l, i, m)), ae = E || q, A = i.identifier === "gregory" && ae.era === "BC", x = $(() => {
    var a;
    return {
      granularity: l,
      maxGranularity: (a = e.maxGranularity) !== null && a !== void 0 ? a : "year",
      timeZone: m,
      hideTimeZone: s,
      hourCycle: e.hourCycle,
      showEra: A,
      shouldForceLeadingZeros: e.shouldForceLeadingZeros
    };
  }, [
    e.maxGranularity,
    l,
    e.hourCycle,
    e.shouldForceLeadingZeros,
    m,
    s,
    A
  ]), B = $(() => Y({}, x), [
    x
  ]), v = $(() => new T(r, B), [
    r,
    B
  ]), F = $(() => v.resolvedOptions(), [
    v
  ]), f = $(() => v.formatToParts(/* @__PURE__ */ new Date()).filter((a) => _[a.type]).reduce((a, u) => (a[u.type] = !0, a), {}), [
    v
  ]), [t, g] = W(() => e.value || e.defaultValue ? {
    ...f
  } : {}), L = X(null), N = X(i.identifier);
  me(() => {
    i.identifier !== N.current && (N.current = i.identifier, C((a) => Object.keys(t).length > 0 ? Q(a, i) : D(e.placeholderValue, l, i, m)));
  }, [
    i,
    l,
    t,
    m,
    e.placeholderValue
  ]), b && Object.keys(t).length < Object.keys(f).length && (t = {
    ...f
  }, g(t)), b == null && Object.keys(t).length === Object.keys(f).length && (t = {}, g(t), C(D(e.placeholderValue, l, i, m)));
  let n = E && Object.keys(t).length >= Object.keys(f).length ? E : q, V = (a) => {
    if (e.isDisabled || e.isReadOnly) return;
    let u = Object.keys(t), h = Object.keys(f);
    a == null ? (K(null), C(D(e.placeholderValue, l, i, m)), g({})) : u.length >= h.length || u.length === h.length - 1 && f.dayPeriod && !t.dayPeriod && L.current !== "dayPeriod" ? (a = Q(a, (d == null ? void 0 : d.calendar) || new se()), K(a)) : C(a), L.current = null;
  }, I = $(() => n.toDate(S), [
    n,
    S
  ]), te = $(() => $e(I, t, v, F, n, i, r, l), [
    I,
    t,
    v,
    F,
    n,
    i,
    r,
    l
  ]);
  f.era && t.year && !t.era ? (t.era = !0, g({
    ...t
  })) : !f.era && t.era && (delete t.era, g({
    ...t
  }));
  let p = (a) => {
    t[a] = !0, a === "year" && f.era && (t.era = !0), g({
      ...t
    });
  }, G = (a, u) => {
    if (t[a])
      V(ge(n, a, u, F));
    else {
      p(a);
      let h = Object.keys(t), P = Object.keys(f);
      (h.length >= P.length || h.length === P.length - 1 && f.dayPeriod && !t.dayPeriod) && V(n);
    }
  }, le = $(() => ue(b, O, k, j, x), [
    b,
    O,
    k,
    j,
    x
  ]), z = fe({
    ...e,
    value: b,
    builtinValidation: le
  }), H = z.displayValidation.isInvalid, re = e.validationState || (H ? "invalid" : null);
  var U;
  return {
    ...z,
    value: E,
    dateValue: I,
    calendar: i,
    setValue: V,
    segments: te,
    dateFormatter: v,
    validationState: re,
    isInvalid: H,
    granularity: l,
    maxGranularity: (U = e.maxGranularity) !== null && U !== void 0 ? U : "year",
    isDisabled: c,
    isReadOnly: y,
    isRequired: M,
    increment(a) {
      G(a, 1);
    },
    decrement(a) {
      G(a, -1);
    },
    incrementPage(a) {
      G(a, ee[a] || 1);
    },
    decrementPage(a) {
      G(a, -(ee[a] || 1));
    },
    setSegment(a, u) {
      p(a), V(be(n, a, u, F));
    },
    confirmPlaceholder() {
      if (e.isDisabled || e.isReadOnly) return;
      let a = Object.keys(t), u = Object.keys(f);
      a.length === u.length - 1 && f.dayPeriod && !t.dayPeriod && (t = {
        ...f
      }, g(t), V(n.copy()));
    },
    clearSegment(a) {
      delete t[a], L.current = a, g({
        ...t
      });
      let u = D(e.placeholderValue, l, i, m), h = n;
      if (a === "dayPeriod" && "hour" in n && "hour" in u) {
        let P = n.hour >= 12, J = u.hour >= 12;
        P && !J ? h = n.set({
          hour: n.hour - 12
        }) : !P && J && (h = n.set({
          hour: n.hour + 12
        }));
      } else a === "hour" && "hour" in n && n.hour >= 12 && t.dayPeriod ? h = n.set({
        hour: u.hour + 12
      }) : a in n && (h = n.set({
        [a]: u[a]
      }));
      K(null), V(h);
    },
    formatValue(a) {
      if (!E) return "";
      let u = Y(a, x);
      return new T(r, u).format(I);
    },
    getDateFormatter(a, u) {
      let h = {
        ...x,
        ...u
      }, P = Y({}, h);
      return new T(a, P);
    }
  };
}
function $e(e, r, o, s, c, y, M, O) {
  let k = [
    "hour",
    "minute",
    "second"
  ], j = o.formatToParts(e), d = [];
  for (let l of j) {
    let m = _[l.type];
    l.type === "era" && y.getEras().length === 1 && (m = !1);
    let S = _[l.type] && !r[l.type], w = _[l.type] ? oe(l.type, l.value, M) : null, i = {
      type: ye[l.type] || l.type,
      text: S ? w : l.value,
      ...R(c, l.type, s),
      isPlaceholder: S,
      placeholder: w,
      isEditable: m
    };
    l.type === "hour" ? (d.push({
      type: "literal",
      text: "⁦",
      ...R(c, "literal", s),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    }), d.push(i), l.type === O && d.push({
      type: "literal",
      text: "⁩",
      ...R(c, "literal", s),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    })) : k.includes(l.type) && l.type === O ? (d.push(i), d.push({
      type: "literal",
      text: "⁩",
      ...R(c, "literal", s),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    })) : d.push(i);
  }
  return d;
}
function R(e, r, o) {
  switch (r) {
    case "era": {
      let s = e.calendar.getEras();
      return {
        value: s.indexOf(e.era),
        minValue: 0,
        maxValue: s.length - 1
      };
    }
    case "year":
      return {
        value: e.year,
        minValue: 1,
        maxValue: e.calendar.getYearsInEra(e)
      };
    case "month":
      return {
        value: e.month,
        minValue: de(e),
        maxValue: e.calendar.getMonthsInYear(e)
      };
    case "day":
      return {
        value: e.day,
        minValue: ce(e),
        maxValue: e.calendar.getDaysInMonth(e)
      };
  }
  if ("hour" in e) switch (r) {
    case "dayPeriod":
      return {
        value: e.hour >= 12 ? 12 : 0,
        minValue: 0,
        maxValue: 12
      };
    case "hour":
      if (o.hour12) {
        let s = e.hour >= 12;
        return {
          value: e.hour,
          minValue: s ? 12 : 0,
          maxValue: s ? 23 : 11
        };
      }
      return {
        value: e.hour,
        minValue: 0,
        maxValue: 23
      };
    case "minute":
      return {
        value: e.minute,
        minValue: 0,
        maxValue: 59
      };
    case "second":
      return {
        value: e.second,
        minValue: 0,
        maxValue: 59
      };
  }
  return {};
}
function ge(e, r, o, s) {
  switch (r) {
    case "era":
    case "year":
    case "month":
    case "day":
      return e.cycle(r, o, {
        round: r === "year"
      });
  }
  if ("hour" in e) switch (r) {
    case "dayPeriod": {
      let c = e.hour, y = c >= 12;
      return e.set({
        hour: y ? c - 12 : c + 12
      });
    }
    case "hour":
    case "minute":
    case "second":
      return e.cycle(r, o, {
        round: r !== "hour",
        hourCycle: s.hour12 ? 12 : 24
      });
  }
  throw new Error("Unknown segment: " + r);
}
function be(e, r, o, s) {
  switch (r) {
    case "day":
    case "month":
    case "year":
    case "era":
      return e.set({
        [r]: o
      });
  }
  if ("hour" in e && typeof o == "number") switch (r) {
    case "dayPeriod": {
      let c = e.hour, y = c >= 12;
      return o >= 12 === y ? e : e.set({
        hour: y ? c - 12 : c + 12
      });
    }
    case "hour":
      if (s.hour12) {
        let y = e.hour >= 12;
        !y && o === 12 && (o = 0), y && o < 12 && (o += 12);
      }
    // fallthrough
    case "minute":
    case "second":
      return e.set({
        [r]: o
      });
  }
  throw new Error("Unknown segment: " + r);
}
export {
  Me as useDateFieldState
};
