import E from "./ui-components-library387.js";
import { roleSymbol as K } from "./ui-components-library145.js";
import { useDatePickerGroup as U } from "./ui-components-library388.js";
import { createFocusManager as W } from "./ui-components-library171.js";
import { useId as f } from "./ui-components-library122.js";
import { mergeProps as k } from "./ui-components-library123.js";
import { filterDOMProps as L } from "./ui-components-library124.js";
import { useDescription as T } from "./ui-components-library287.js";
import { useFocusWithin as Z } from "./ui-components-library341.js";
import { privateValidationStateProp as w } from "./ui-components-library366.js";
import { useField as C } from "./ui-components-library389.js";
import { useLocale as S } from "./ui-components-library130.js";
import { useLocalizedStringFormatter as j } from "./ui-components-library156.js";
import { useMemo as q, useRef as z } from "react";
function G(e) {
  return e && e.__esModule ? e.default : e;
}
function de(e, a, o) {
  let t = f(), m = f(), P = f(), $ = j(G(E), "@react-aria/datepicker"), { isInvalid: v, validationErrors: y, validationDetails: D } = a.displayValidation, { labelProps: h, fieldProps: d, descriptionProps: x, errorMessageProps: V } = C({
    ...e,
    labelElementType: "span",
    isInvalid: v,
    errorMessage: e.errorMessage || y
  }), M = U(a, o), n = d["aria-labelledby"] || d.id, { locale: F } = S(), g = a.formatValue(F, {
    month: "long"
  }), I = g ? $.format("selectedDateDescription", {
    date: g
  }) : "", s = T(I), u = [
    s["aria-describedby"],
    d["aria-describedby"]
  ].filter(Boolean).join(" ") || void 0, O = L(e), R = q(() => W(o), [
    o
  ]), b = z(!1), { focusWithinProps: B } = Z({
    ...e,
    isDisabled: a.isOpen,
    onBlurWithin: (i) => {
      let l = document.getElementById(m);
      if (!(l != null && l.contains(i.relatedTarget))) {
        var r, c;
        b.current = !1, (r = e.onBlur) === null || r === void 0 || r.call(e, i), (c = e.onFocusChange) === null || c === void 0 || c.call(e, !1);
      }
    },
    onFocusWithin: (i) => {
      if (!b.current) {
        var l, r;
        b.current = !0, (l = e.onFocus) === null || l === void 0 || l.call(e, i), (r = e.onFocusChange) === null || r === void 0 || r.call(e, !0);
      }
    }
  });
  return {
    groupProps: k(O, M, d, s, B, {
      role: "group",
      "aria-disabled": e.isDisabled || null,
      "aria-labelledby": n,
      "aria-describedby": u,
      onKeyDown(i) {
        a.isOpen || e.onKeyDown && e.onKeyDown(i);
      },
      onKeyUp(i) {
        a.isOpen || e.onKeyUp && e.onKeyUp(i);
      }
    }),
    labelProps: {
      ...h,
      onClick: () => {
        R.focusFirst();
      }
    },
    fieldProps: {
      ...d,
      id: P,
      [K]: "presentation",
      "aria-describedby": u,
      value: a.value,
      onChange: a.setValue,
      placeholderValue: e.placeholderValue,
      hideTimeZone: e.hideTimeZone,
      hourCycle: e.hourCycle,
      shouldForceLeadingZeros: e.shouldForceLeadingZeros,
      granularity: e.granularity,
      isDisabled: e.isDisabled,
      isReadOnly: e.isReadOnly,
      isRequired: e.isRequired,
      validationBehavior: e.validationBehavior,
      // DatePicker owns the validation state for the date field.
      [w]: a,
      autoFocus: e.autoFocus,
      name: e.name
    },
    descriptionProps: x,
    errorMessageProps: V,
    buttonProps: {
      ...s,
      id: t,
      "aria-haspopup": "dialog",
      "aria-label": $.format("calendar"),
      "aria-labelledby": `${t} ${n}`,
      "aria-describedby": u,
      "aria-expanded": a.isOpen,
      isDisabled: e.isDisabled || e.isReadOnly,
      onPress: () => a.setOpen(!0)
    },
    dialogProps: {
      id: m,
      "aria-labelledby": `${t} ${n}`
    },
    calendarProps: {
      autoFocus: !0,
      value: a.dateValue,
      onChange: a.setDateValue,
      minValue: e.minValue,
      maxValue: e.maxValue,
      isDisabled: e.isDisabled,
      isReadOnly: e.isReadOnly,
      isDateUnavailable: e.isDateUnavailable,
      defaultFocusedValue: a.dateValue ? void 0 : e.placeholderValue,
      isInvalid: a.isInvalid,
      errorMessage: typeof e.errorMessage == "function" ? e.errorMessage(a.displayValidation) : e.errorMessage || a.displayValidation.validationErrors.join(" ")
    },
    isInvalid: v,
    validationErrors: y,
    validationDetails: D
  };
}
export {
  de as useDatePicker
};
