import { registerDropTarget as K } from "./ui-components-library359.js";
import { setGlobalDropEffect as h, readFromDataTransfer as I, DragTypes as u, globalDndState as X, setGlobalDnDState as Y, globalAllowedDropOperations as A } from "./ui-components-library357.js";
import { DROP_OPERATION as p, DROP_EFFECT_TO_DROP_OPERATION as S, DROP_OPERATION_TO_DROP_EFFECT as O, DROP_OPERATION_ALLOWED as L } from "./ui-components-library358.js";
import { useVirtualDrop as M } from "./ui-components-library360.js";
import { useState as k, useRef as N } from "react";
import { useLayoutEffect as z } from "./ui-components-library142.js";
import { isMac as G, isIPad as V } from "./ui-components-library278.js";
import { useEffectEvent as d } from "./ui-components-library289.js";
const U = 800;
function te(t) {
  let { hasDropButton: f, isDisabled: c } = t, [w, D] = k(!1), r = N({
    x: 0,
    y: 0,
    dragOverElements: /* @__PURE__ */ new Set(),
    dropEffect: "none",
    allowedOperations: p.all,
    dropActivateTimer: void 0
  }).current, y = (e) => {
    if (D(!0), typeof t.onDropEnter == "function") {
      let o = e.currentTarget.getBoundingClientRect();
      t.onDropEnter({
        type: "dropenter",
        x: e.clientX - o.x,
        y: e.clientY - o.y
      });
    }
  }, g = (e) => {
    if (D(!1), typeof t.onDropExit == "function") {
      let o = e.currentTarget.getBoundingClientRect();
      t.onDropExit({
        type: "dropexit",
        x: e.clientX - o.x,
        y: e.clientY - o.y
      });
    }
  }, _ = (e) => {
    e.preventDefault(), e.stopPropagation();
    let o = R(e);
    if (e.clientX === r.x && e.clientY === r.y && o === r.allowedOperations) {
      e.dataTransfer.dropEffect = r.dropEffect;
      return;
    }
    r.x = e.clientX, r.y = e.clientY;
    let i = r.dropEffect;
    if (o !== r.allowedOperations) {
      let n = E(o), a = n[0];
      if (typeof t.getDropOperation == "function") {
        let l = new u(e.dataTransfer);
        a = s(o, t.getDropOperation(l, n));
      }
      r.dropEffect = O[a] || "none";
    }
    if (typeof t.getDropOperationForPoint == "function") {
      let n = new u(e.dataTransfer), a = e.currentTarget.getBoundingClientRect(), l = s(o, t.getDropOperationForPoint(n, E(o), r.x - a.x, r.y - a.y));
      r.dropEffect = O[l] || "none";
    }
    if (r.allowedOperations = o, e.dataTransfer.dropEffect = r.dropEffect, r.dropEffect === "none" && i !== "none" ? g(e) : r.dropEffect !== "none" && i === "none" && y(e), typeof t.onDropMove == "function" && r.dropEffect !== "none") {
      let n = e.currentTarget.getBoundingClientRect();
      t.onDropMove({
        type: "dropmove",
        x: r.x - n.x,
        y: r.y - n.y
      });
    }
    if (clearTimeout(r.dropActivateTimer), t.onDropActivate && typeof t.onDropActivate == "function" && r.dropEffect !== "none") {
      let n = t.onDropActivate, a = e.currentTarget.getBoundingClientRect();
      r.dropActivateTimer = setTimeout(() => {
        n({
          type: "dropactivate",
          x: r.x - a.x,
          y: r.y - a.y
        });
      }, U);
    }
  }, C = (e) => {
    if (e.preventDefault(), e.stopPropagation(), r.dragOverElements.add(e.target), r.dragOverElements.size > 1) return;
    let o = R(e), i = E(o), n = i[0];
    if (typeof t.getDropOperation == "function") {
      let a = new u(e.dataTransfer);
      n = s(o, t.getDropOperation(a, i));
    }
    if (typeof t.getDropOperationForPoint == "function") {
      let a = new u(e.dataTransfer), l = e.currentTarget.getBoundingClientRect();
      n = s(o, t.getDropOperationForPoint(a, i, e.clientX - l.x, e.clientY - l.y));
    }
    r.x = e.clientX, r.y = e.clientY, r.allowedOperations = o, r.dropEffect = O[n] || "none", e.dataTransfer.dropEffect = r.dropEffect, n !== "cancel" && y(e);
  }, B = (e) => {
    e.preventDefault(), e.stopPropagation(), r.dragOverElements.delete(e.target);
    for (let o of r.dragOverElements) e.currentTarget.contains(o) || r.dragOverElements.delete(o);
    r.dragOverElements.size > 0 || (r.dropEffect !== "none" && g(e), clearTimeout(r.dropActivateTimer));
  }, F = (e) => {
    if (e.preventDefault(), e.stopPropagation(), h(r.dropEffect), typeof t.onDrop == "function") {
      let i = S[r.dropEffect], n = I(e.dataTransfer), a = e.currentTarget.getBoundingClientRect(), l = {
        type: "drop",
        x: e.clientX - a.x,
        y: e.clientY - a.y,
        items: n,
        dropOperation: i
      };
      t.onDrop(l);
    }
    let o = {
      ...X
    };
    r.dragOverElements.clear(), g(e), clearTimeout(r.dropActivateTimer), o.draggingCollectionRef == null || Y(o);
  }, T = d((e) => {
    typeof t.onDropEnter == "function" && t.onDropEnter(e);
  }), x = d((e) => {
    typeof t.onDropExit == "function" && t.onDropExit(e);
  }), m = d((e) => {
    typeof t.onDropActivate == "function" && t.onDropActivate(e);
  }), v = d((e) => {
    typeof t.onDrop == "function" && t.onDrop(e);
  }), b = d((e, o) => t.getDropOperation ? t.getDropOperation(e, o) : o[0]), { ref: $ } = t;
  z(() => {
    if (!(c || !$.current))
      return K({
        element: $.current,
        getDropOperation: b,
        onDropEnter(e) {
          D(!0), T(e);
        },
        onDropExit(e) {
          D(!1), x(e);
        },
        onDrop: v,
        onDropActivate: m
      });
  }, [
    c,
    $,
    b,
    T,
    x,
    v,
    m
  ]);
  let { dropProps: P } = M();
  return c ? {
    dropProps: {},
    dropButtonProps: {
      isDisabled: !0
    },
    isDropTarget: !1
  } : {
    dropProps: {
      ...!f && P,
      onDragEnter: C,
      onDragOver: _,
      onDragLeave: B,
      onDrop: F
    },
    dropButtonProps: {
      ...f && P
    },
    isDropTarget: w
  };
}
function R(t) {
  let f = L[t.dataTransfer.effectAllowed];
  A && (f &= A);
  let c = p.none;
  return G() ? (t.altKey && (c |= p.copy), t.ctrlKey && !V() && (c |= p.link), t.metaKey && (c |= p.move)) : (t.altKey && (c |= p.link), t.shiftKey && (c |= p.move), t.ctrlKey && (c |= p.copy)), c ? f & c : f;
}
function E(t) {
  let f = [];
  return t & p.move && f.push("move"), t & p.copy && f.push("copy"), t & p.link && f.push("link"), f;
}
function s(t, f) {
  let c = p[f];
  return t & c ? f : "cancel";
}
export {
  te as useDrop
};
