import { DOMLayoutDelegate as n } from "./ui-components-library423.js";
import { isScrollable as r } from "./ui-components-library285.js";
class g {
  isDisabled(t) {
    var e;
    return this.disabledBehavior === "all" && (((e = t.props) === null || e === void 0 ? void 0 : e.isDisabled) || this.disabledKeys.has(t.key));
  }
  findNextNonDisabled(t, e) {
    let l = t;
    for (; l != null; ) {
      let i = this.collection.getItem(l);
      if ((i == null ? void 0 : i.type) === "item" && !this.isDisabled(i)) return l;
      l = e(l);
    }
    return null;
  }
  getNextKey(t) {
    let e = t;
    return e = this.collection.getKeyAfter(e), this.findNextNonDisabled(e, (l) => this.collection.getKeyAfter(l));
  }
  getPreviousKey(t) {
    let e = t;
    return e = this.collection.getKeyBefore(e), this.findNextNonDisabled(e, (l) => this.collection.getKeyBefore(l));
  }
  findKey(t, e, l) {
    let i = t, s = this.layoutDelegate.getItemRect(i);
    if (!s || i == null) return null;
    let o = s;
    do {
      if (i = e(i), i == null) break;
      s = this.layoutDelegate.getItemRect(i);
    } while (s && l(o, s) && i != null);
    return i;
  }
  isSameRow(t, e) {
    return t.y === e.y || t.x !== e.x;
  }
  isSameColumn(t, e) {
    return t.x === e.x || t.y !== e.y;
  }
  getKeyBelow(t) {
    return this.layout === "grid" && this.orientation === "vertical" ? this.findKey(t, (e) => this.getNextKey(e), this.isSameRow) : this.getNextKey(t);
  }
  getKeyAbove(t) {
    return this.layout === "grid" && this.orientation === "vertical" ? this.findKey(t, (e) => this.getPreviousKey(e), this.isSameRow) : this.getPreviousKey(t);
  }
  getNextColumn(t, e) {
    return e ? this.getPreviousKey(t) : this.getNextKey(t);
  }
  getKeyRightOf(t) {
    let e = this.direction === "ltr" ? "getKeyRightOf" : "getKeyLeftOf";
    return this.layoutDelegate[e] ? (t = this.layoutDelegate[e](t), this.findNextNonDisabled(t, (l) => this.layoutDelegate[e](l))) : this.layout === "grid" ? this.orientation === "vertical" ? this.getNextColumn(t, this.direction === "rtl") : this.findKey(t, (l) => this.getNextColumn(l, this.direction === "rtl"), this.isSameColumn) : this.orientation === "horizontal" ? this.getNextColumn(t, this.direction === "rtl") : null;
  }
  getKeyLeftOf(t) {
    let e = this.direction === "ltr" ? "getKeyLeftOf" : "getKeyRightOf";
    return this.layoutDelegate[e] ? (t = this.layoutDelegate[e](t), this.findNextNonDisabled(t, (l) => this.layoutDelegate[e](l))) : this.layout === "grid" ? this.orientation === "vertical" ? this.getNextColumn(t, this.direction === "ltr") : this.findKey(t, (l) => this.getNextColumn(l, this.direction === "ltr"), this.isSameColumn) : this.orientation === "horizontal" ? this.getNextColumn(t, this.direction === "ltr") : null;
  }
  getFirstKey() {
    let t = this.collection.getFirstKey();
    return this.findNextNonDisabled(t, (e) => this.collection.getKeyAfter(e));
  }
  getLastKey() {
    let t = this.collection.getLastKey();
    return this.findNextNonDisabled(t, (e) => this.collection.getKeyBefore(e));
  }
  getKeyPageAbove(t) {
    let e = this.ref.current, l = this.layoutDelegate.getItemRect(t);
    if (!l) return null;
    if (e && !r(e)) return this.getFirstKey();
    let i = t;
    if (this.orientation === "horizontal") {
      let s = Math.max(0, l.x + l.width - this.layoutDelegate.getVisibleRect().width);
      for (; l && l.x > s && i != null; )
        i = this.getKeyAbove(i), l = i == null ? null : this.layoutDelegate.getItemRect(i);
    } else {
      let s = Math.max(0, l.y + l.height - this.layoutDelegate.getVisibleRect().height);
      for (; l && l.y > s && i != null; )
        i = this.getKeyAbove(i), l = i == null ? null : this.layoutDelegate.getItemRect(i);
    }
    return i ?? this.getFirstKey();
  }
  getKeyPageBelow(t) {
    let e = this.ref.current, l = this.layoutDelegate.getItemRect(t);
    if (!l) return null;
    if (e && !r(e)) return this.getLastKey();
    let i = t;
    if (this.orientation === "horizontal") {
      let s = Math.min(this.layoutDelegate.getContentSize().width, l.y - l.width + this.layoutDelegate.getVisibleRect().width);
      for (; l && l.x < s && i != null; )
        i = this.getKeyBelow(i), l = i == null ? null : this.layoutDelegate.getItemRect(i);
    } else {
      let s = Math.min(this.layoutDelegate.getContentSize().height, l.y - l.height + this.layoutDelegate.getVisibleRect().height);
      for (; l && l.y < s && i != null; )
        i = this.getKeyBelow(i), l = i == null ? null : this.layoutDelegate.getItemRect(i);
    }
    return i ?? this.getLastKey();
  }
  getKeyForSearch(t, e) {
    if (!this.collator) return null;
    let l = this.collection, i = e || this.getFirstKey();
    for (; i != null; ) {
      let s = l.getItem(i);
      if (!s) return null;
      let o = s.textValue.slice(0, t.length);
      if (s.textValue && this.collator.compare(o, t) === 0) return i;
      i = this.getNextKey(i);
    }
    return null;
  }
  constructor(...t) {
    if (t.length === 1) {
      let e = t[0];
      this.collection = e.collection, this.ref = e.ref, this.collator = e.collator, this.disabledKeys = e.disabledKeys || /* @__PURE__ */ new Set(), this.disabledBehavior = e.disabledBehavior || "all", this.orientation = e.orientation || "vertical", this.direction = e.direction, this.layout = e.layout || "stack", this.layoutDelegate = e.layoutDelegate || new n(e.ref);
    } else
      this.collection = t[0], this.disabledKeys = t[1], this.ref = t[2], this.collator = t[3], this.layout = "stack", this.orientation = "vertical", this.disabledBehavior = "all", this.layoutDelegate = new n(this.ref);
    this.layout === "stack" && this.orientation === "vertical" && (this.getKeyLeftOf = void 0, this.getKeyRightOf = void 0);
  }
}
export {
  g as ListKeyboardDelegate
};
