import { isElementVisible as H } from "./ui-components-library361.js";
import { createShadowTreeWalker as J } from "./ui-components-library272.js";
import { getActiveElement as T, getEventTarget as S } from "./ui-components-library273.js";
import { getOwnerDocument as N } from "./ui-components-library275.js";
import { useLayoutEffect as g } from "./ui-components-library142.js";
import { isAndroid as U, isChrome as j } from "./ui-components-library278.js";
import { isTabbable as G, isFocusable as Q } from "./ui-components-library153.js";
import { getInteractionModality as X } from "./ui-components-library340.js";
import { focusSafely as Y } from "./ui-components-library175.js";
import L, { useRef as F, useContext as Z, useMemo as k, useEffect as q } from "react";
const P = /* @__PURE__ */ L.createContext(null), K = "react-aria-focus-scope-restore";
let v = null;
function ve(t) {
  let { children: e, contain: r, restoreFocus: n, autoFocus: o } = t, i = F(null), c = F(null), a = F([]), { parentNode: b } = Z(P) || {}, l = k(() => new D({
    scopeRef: a
  }), [
    a
  ]);
  g(() => {
    let f = b || $.root;
    if ($.getTreeNode(f.scopeRef) && v && !C(v, f.scopeRef)) {
      let s = $.getTreeNode(v);
      s && (f = s);
    }
    f.addChild(l), $.addNode(l);
  }, [
    l,
    b
  ]), g(() => {
    let f = $.getTreeNode(a);
    f && (f.contain = !!r);
  }, [
    r
  ]), g(() => {
    var f;
    let s = (f = i.current) === null || f === void 0 ? void 0 : f.nextSibling, p = [], y = (R) => R.stopPropagation();
    for (; s && s !== c.current; )
      p.push(s), s.addEventListener(K, y), s = s.nextSibling;
    return a.current = p, () => {
      for (let R of p) R.removeEventListener(K, y);
    };
  }, [
    e
  ]), re(a, n, r), ee(a, r), ne(a, n, r), te(a, o), q(() => {
    const f = T(N(a.current ? a.current[0] : void 0));
    let s = null;
    if (h(f, a.current)) {
      for (let p of $.traverse()) p.scopeRef && h(f, p.scopeRef.current) && (s = p);
      s === $.getTreeNode(a) && (v = s.scopeRef);
    }
  }, [
    a
  ]), g(() => () => {
    var f, s, p;
    let y = (p = (s = $.getTreeNode(a)) === null || s === void 0 || (f = s.parent) === null || f === void 0 ? void 0 : f.scopeRef) !== null && p !== void 0 ? p : null;
    (a === v || C(a, v)) && (!y || $.getTreeNode(y)) && (v = y), $.removeTreeNode(a);
  }, [
    a
  ]);
  let d = k(() => O(a), []), u = k(() => ({
    focusManager: d,
    parentNode: l
  }), [
    l,
    d
  ]);
  return /* @__PURE__ */ L.createElement(P.Provider, {
    value: u
  }, /* @__PURE__ */ L.createElement("span", {
    "data-focus-scope-start": !0,
    hidden: !0,
    ref: i
  }), e, /* @__PURE__ */ L.createElement("span", {
    "data-focus-scope-end": !0,
    hidden: !0,
    ref: c
  }));
}
function O(t) {
  return {
    focusNext(e = {}) {
      let r = t.current, { from: n, tabbable: o, wrap: i, accept: c } = e;
      var a;
      let b = n || T(N((a = r[0]) !== null && a !== void 0 ? a : void 0)), l = r[0].previousElementSibling, d = x(r), u = E(d, {
        tabbable: o,
        accept: c
      }, r);
      u.currentNode = h(b, r) ? b : l;
      let f = u.nextNode();
      return !f && i && (u.currentNode = l, f = u.nextNode()), f && m(f, !0), f;
    },
    focusPrevious(e = {}) {
      let r = t.current, { from: n, tabbable: o, wrap: i, accept: c } = e;
      var a;
      let b = n || T(N((a = r[0]) !== null && a !== void 0 ? a : void 0)), l = r[r.length - 1].nextElementSibling, d = x(r), u = E(d, {
        tabbable: o,
        accept: c
      }, r);
      u.currentNode = h(b, r) ? b : l;
      let f = u.previousNode();
      return !f && i && (u.currentNode = l, f = u.previousNode()), f && m(f, !0), f;
    },
    focusFirst(e = {}) {
      let r = t.current, { tabbable: n, accept: o } = e, i = x(r), c = E(i, {
        tabbable: n,
        accept: o
      }, r);
      c.currentNode = r[0].previousElementSibling;
      let a = c.nextNode();
      return a && m(a, !0), a;
    },
    focusLast(e = {}) {
      let r = t.current, { tabbable: n, accept: o } = e, i = x(r), c = E(i, {
        tabbable: n,
        accept: o
      }, r);
      c.currentNode = r[r.length - 1].nextElementSibling;
      let a = c.previousNode();
      return a && m(a, !0), a;
    }
  };
}
function x(t) {
  return t[0].parentElement;
}
function _(t) {
  let e = $.getTreeNode(v);
  for (; e && e.scopeRef !== t; ) {
    if (e.contain) return !1;
    e = e.parent;
  }
  return !0;
}
function ee(t, e) {
  let r = F(void 0), n = F(void 0);
  g(() => {
    let o = t.current;
    if (!e) {
      n.current && (cancelAnimationFrame(n.current), n.current = void 0);
      return;
    }
    const i = N(o ? o[0] : void 0);
    let c = (l) => {
      if (l.key !== "Tab" || l.altKey || l.ctrlKey || l.metaKey || !_(t) || l.isComposing) return;
      let d = T(i), u = t.current;
      if (!u || !h(d, u)) return;
      let f = x(u), s = E(f, {
        tabbable: !0
      }, u);
      if (!d) return;
      s.currentNode = d;
      let p = l.shiftKey ? s.previousNode() : s.nextNode();
      p || (s.currentNode = l.shiftKey ? u[u.length - 1].nextElementSibling : u[0].previousElementSibling, p = l.shiftKey ? s.previousNode() : s.nextNode()), l.preventDefault(), p && m(p, !0);
    }, a = (l) => {
      (!v || C(v, t)) && h(S(l), t.current) ? (v = t, r.current = S(l)) : _(t) && !w(S(l), t) ? r.current ? r.current.focus() : v && v.current && A(v.current) : _(t) && (r.current = S(l));
    }, b = (l) => {
      n.current && cancelAnimationFrame(n.current), n.current = requestAnimationFrame(() => {
        let d = X(), u = (d === "virtual" || d === null) && U() && j(), f = T(i);
        if (!u && f && _(t) && !w(f, t)) {
          v = t;
          let p = S(l);
          if (p && p.isConnected) {
            var s;
            r.current = p, (s = r.current) === null || s === void 0 || s.focus();
          } else v.current && A(v.current);
        }
      });
    };
    return i.addEventListener("keydown", c, !1), i.addEventListener("focusin", a, !1), o == null || o.forEach((l) => l.addEventListener("focusin", a, !1)), o == null || o.forEach((l) => l.addEventListener("focusout", b, !1)), () => {
      i.removeEventListener("keydown", c, !1), i.removeEventListener("focusin", a, !1), o == null || o.forEach((l) => l.removeEventListener("focusin", a, !1)), o == null || o.forEach((l) => l.removeEventListener("focusout", b, !1));
    };
  }, [
    t,
    e
  ]), g(() => () => {
    n.current && cancelAnimationFrame(n.current);
  }, [
    n
  ]);
}
function V(t) {
  return w(t);
}
function h(t, e) {
  return !t || !e ? !1 : e.some((r) => r.contains(t));
}
function w(t, e = null) {
  if (t instanceof Element && t.closest("[data-react-aria-top-layer]")) return !0;
  for (let { scopeRef: r } of $.traverse($.getTreeNode(e)))
    if (r && h(t, r.current)) return !0;
  return !1;
}
function pe(t) {
  return w(t, v);
}
function C(t, e) {
  var r;
  let n = (r = $.getTreeNode(e)) === null || r === void 0 ? void 0 : r.parent;
  for (; n; ) {
    if (n.scopeRef === t) return !0;
    n = n.parent;
  }
  return !1;
}
function m(t, e = !1) {
  if (t != null && !e) try {
    Y(t);
  } catch {
  }
  else if (t != null) try {
    t.focus();
  } catch {
  }
}
function B(t, e = !0) {
  let r = t[0].previousElementSibling, n = x(t), o = E(n, {
    tabbable: e
  }, t);
  o.currentNode = r;
  let i = o.nextNode();
  return e && !i && (n = x(t), o = E(n, {
    tabbable: !1
  }, t), o.currentNode = r, i = o.nextNode()), i;
}
function A(t, e = !0) {
  m(B(t, e));
}
function te(t, e) {
  const r = L.useRef(e);
  q(() => {
    if (r.current) {
      v = t;
      const n = N(t.current ? t.current[0] : void 0);
      !h(T(n), v.current) && t.current && A(t.current);
    }
    r.current = !1;
  }, [
    t
  ]);
}
function re(t, e, r) {
  g(() => {
    if (e || r) return;
    let n = t.current;
    const o = N(n ? n[0] : void 0);
    let i = (c) => {
      let a = S(c);
      h(a, t.current) ? v = t : V(a) || (v = null);
    };
    return o.addEventListener("focusin", i, !1), n == null || n.forEach((c) => c.addEventListener("focusin", i, !1)), () => {
      o.removeEventListener("focusin", i, !1), n == null || n.forEach((c) => c.removeEventListener("focusin", i, !1));
    };
  }, [
    t,
    e,
    r
  ]);
}
function z(t) {
  let e = $.getTreeNode(v);
  for (; e && e.scopeRef !== t; ) {
    if (e.nodeToRestore) return !1;
    e = e.parent;
  }
  return (e == null ? void 0 : e.scopeRef) === t;
}
function ne(t, e, r) {
  const n = F(typeof document < "u" ? T(N(t.current ? t.current[0] : void 0)) : null);
  g(() => {
    let o = t.current;
    const i = N(o ? o[0] : void 0);
    if (!e || r) return;
    let c = () => {
      (!v || C(v, t)) && h(T(i), t.current) && (v = t);
    };
    return i.addEventListener("focusin", c, !1), o == null || o.forEach((a) => a.addEventListener("focusin", c, !1)), () => {
      i.removeEventListener("focusin", c, !1), o == null || o.forEach((a) => a.removeEventListener("focusin", c, !1));
    };
  }, [
    t,
    r
  ]), g(() => {
    const o = N(t.current ? t.current[0] : void 0);
    if (!e) return;
    let i = (c) => {
      if (c.key !== "Tab" || c.altKey || c.ctrlKey || c.metaKey || !_(t) || c.isComposing) return;
      let a = o.activeElement;
      if (!w(a, t) || !z(t)) return;
      let b = $.getTreeNode(t);
      if (!b) return;
      let l = b.nodeToRestore, d = E(o.body, {
        tabbable: !0
      });
      d.currentNode = a;
      let u = c.shiftKey ? d.previousNode() : d.nextNode();
      if ((!l || !l.isConnected || l === o.body) && (l = void 0, b.nodeToRestore = void 0), (!u || !w(u, t)) && l) {
        d.currentNode = l;
        do
          u = c.shiftKey ? d.previousNode() : d.nextNode();
        while (w(u, t));
        c.preventDefault(), c.stopPropagation(), u ? m(u, !0) : V(l) ? m(l, !0) : a.blur();
      }
    };
    return r || o.addEventListener("keydown", i, !0), () => {
      r || o.removeEventListener("keydown", i, !0);
    };
  }, [
    t,
    e,
    r
  ]), g(() => {
    const o = N(t.current ? t.current[0] : void 0);
    if (!e) return;
    let i = $.getTreeNode(t);
    if (i) {
      var c;
      return i.nodeToRestore = (c = n.current) !== null && c !== void 0 ? c : void 0, () => {
        let a = $.getTreeNode(t);
        if (!a) return;
        let b = a.nodeToRestore, l = T(o);
        if (e && b && (l && w(l, t) || l === o.body && z(t))) {
          let d = $.clone();
          requestAnimationFrame(() => {
            if (o.activeElement === o.body) {
              let u = d.getTreeNode(t);
              for (; u; ) {
                if (u.nodeToRestore && u.nodeToRestore.isConnected) {
                  W(u.nodeToRestore);
                  return;
                }
                u = u.parent;
              }
              for (u = d.getTreeNode(t); u; ) {
                if (u.scopeRef && u.scopeRef.current && $.getTreeNode(u.scopeRef)) {
                  let f = B(u.scopeRef.current, !0);
                  W(f);
                  return;
                }
                u = u.parent;
              }
            }
          });
        }
      };
    }
  }, [
    t,
    e
  ]);
}
function W(t) {
  t.dispatchEvent(new CustomEvent(K, {
    bubbles: !0,
    cancelable: !0
  })) && m(t);
}
function E(t, e, r) {
  let n = e != null && e.tabbable ? G : Q, o = (t == null ? void 0 : t.nodeType) === Node.ELEMENT_NODE ? t : null, i = N(o), c = J(i, t || i, NodeFilter.SHOW_ELEMENT, {
    acceptNode(a) {
      var b;
      return !(e == null || (b = e.from) === null || b === void 0) && b.contains(a) ? NodeFilter.FILTER_REJECT : n(a) && H(a) && (!r || h(a, r)) && (!(e != null && e.accept) || e.accept(a)) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;
    }
  });
  return e != null && e.from && (c.currentNode = e.from), c;
}
function $e(t, e = {}) {
  return {
    focusNext(r = {}) {
      let n = t.current;
      if (!n) return null;
      let { from: o, tabbable: i = e.tabbable, wrap: c = e.wrap, accept: a = e.accept } = r, b = o || T(N(n)), l = E(n, {
        tabbable: i,
        accept: a
      });
      n.contains(b) && (l.currentNode = b);
      let d = l.nextNode();
      return !d && c && (l.currentNode = n, d = l.nextNode()), d && m(d, !0), d;
    },
    focusPrevious(r = e) {
      let n = t.current;
      if (!n) return null;
      let { from: o, tabbable: i = e.tabbable, wrap: c = e.wrap, accept: a = e.accept } = r, b = o || T(N(n)), l = E(n, {
        tabbable: i,
        accept: a
      });
      if (n.contains(b)) l.currentNode = b;
      else {
        let u = M(l);
        return u && m(u, !0), u ?? null;
      }
      let d = l.previousNode();
      if (!d && c) {
        l.currentNode = n;
        let u = M(l);
        if (!u)
          return null;
        d = u;
      }
      return d && m(d, !0), d ?? null;
    },
    focusFirst(r = e) {
      let n = t.current;
      if (!n) return null;
      let { tabbable: o = e.tabbable, accept: i = e.accept } = r, a = E(n, {
        tabbable: o,
        accept: i
      }).nextNode();
      return a && m(a, !0), a;
    },
    focusLast(r = e) {
      let n = t.current;
      if (!n) return null;
      let { tabbable: o = e.tabbable, accept: i = e.accept } = r, c = E(n, {
        tabbable: o,
        accept: i
      }), a = M(c);
      return a && m(a, !0), a ?? null;
    }
  };
}
function M(t) {
  let e, r;
  do
    r = t.lastChild(), r && (e = r);
  while (r);
  return e;
}
class I {
  get size() {
    return this.fastMap.size;
  }
  getTreeNode(e) {
    return this.fastMap.get(e);
  }
  addTreeNode(e, r, n) {
    let o = this.fastMap.get(r ?? null);
    if (!o) return;
    let i = new D({
      scopeRef: e
    });
    o.addChild(i), i.parent = o, this.fastMap.set(e, i), n && (i.nodeToRestore = n);
  }
  addNode(e) {
    this.fastMap.set(e.scopeRef, e);
  }
  removeTreeNode(e) {
    if (e === null) return;
    let r = this.fastMap.get(e);
    if (!r) return;
    let n = r.parent;
    for (let i of this.traverse()) i !== r && r.nodeToRestore && i.nodeToRestore && r.scopeRef && r.scopeRef.current && h(i.nodeToRestore, r.scopeRef.current) && (i.nodeToRestore = r.nodeToRestore);
    let o = r.children;
    n && (n.removeChild(r), o.size > 0 && o.forEach((i) => n && n.addChild(i))), this.fastMap.delete(r.scopeRef);
  }
  // Pre Order Depth First
  *traverse(e = this.root) {
    if (e.scopeRef != null && (yield e), e.children.size > 0) for (let r of e.children) yield* this.traverse(r);
  }
  clone() {
    var e;
    let r = new I();
    var n;
    for (let o of this.traverse()) r.addTreeNode(o.scopeRef, (n = (e = o.parent) === null || e === void 0 ? void 0 : e.scopeRef) !== null && n !== void 0 ? n : null, o.nodeToRestore);
    return r;
  }
  constructor() {
    this.fastMap = /* @__PURE__ */ new Map(), this.root = new D({
      scopeRef: null
    }), this.fastMap.set(null, this.root);
  }
}
class D {
  addChild(e) {
    this.children.add(e), e.parent = this;
  }
  removeChild(e) {
    this.children.delete(e), e.parent = void 0;
  }
  constructor(e) {
    this.children = /* @__PURE__ */ new Set(), this.contain = !1, this.scopeRef = e.scopeRef;
  }
}
let $ = new I();
export {
  ve as FocusScope,
  $e as createFocusManager,
  $ as focusScopeTree,
  E as getFocusableTreeWalker,
  pe as isElementInChildOfActiveScope
};
