import ve from "./ui-components-library409.js";
import { useId as F } from "./ui-components-library122.js";
import { chain as De } from "./ui-components-library271.js";
import { mergeProps as v } from "./ui-components-library123.js";
import { filterDOMProps as he } from "./ui-components-library124.js";
import { isIPhone as ge, isAndroid as Ve, isIOS as ye } from "./ui-components-library278.js";
import { useFormReset as Me } from "./ui-components-library293.js";
import { useMemo as D, useState as Be, useCallback as K } from "react";
import { privateValidationStateProp as Oe } from "./ui-components-library366.js";
import { useFocus as Ie } from "./ui-components-library338.js";
import { useFocusWithin as We } from "./ui-components-library341.js";
import { useScrollWheel as Se } from "./ui-components-library350.js";
import { useFormattedTextField as Ce } from "./ui-components-library410.js";
import { useLocalizedStringFormatter as Te } from "./ui-components-library156.js";
import { useNumberFormatter as E } from "./ui-components-library190.js";
import { useSpinButton as Le } from "./ui-components-library392.js";
function Ne(e) {
  return e && e.__esModule ? e.default : e;
}
function Ze(e, a, o) {
  let { id: R, decrementAriaLabel: s, incrementAriaLabel: d, isDisabled: t, isReadOnly: u, isRequired: h, minValue: _, maxValue: q, autoFocus: A, label: k, formatOptions: g, onBlur: U = () => {
  }, onFocus: Y, onFocusChange: z, onKeyDown: V, onKeyUp: X, description: j, errorMessage: G, isWheelDisabled: H, ...J } = e, { increment: c, incrementToMax: Q, decrement: m, decrementToMin: Z, numberValue: n, inputValue: ee, commit: f, commitValidation: y } = a;
  const b = Te(Ne(ve), "@react-aria/numberfield");
  let p = F(R), { focusProps: ae } = Ie({
    onBlur() {
      f();
    }
  }), M = E(g), re = D(() => M.resolvedOptions(), [
    M
  ]), B = E({
    ...g,
    currencySign: void 0
  }), ie = D(() => isNaN(n) ? "" : B.format(n), [
    B,
    n
  ]), { spinButtonProps: oe, incrementButtonProps: te, decrementButtonProps: le } = Le({
    isDisabled: t,
    isReadOnly: u,
    isRequired: h,
    maxValue: q,
    minValue: _,
    onIncrement: c,
    onIncrementToMax: Q,
    onDecrement: m,
    onDecrementToMin: Z,
    value: n,
    textValue: ie
  }), [ne, se] = Be(!1), { focusWithinProps: de } = We({
    isDisabled: t,
    onFocusWithinChange: se
  }), ue = K((r) => {
    Math.abs(r.deltaY) <= Math.abs(r.deltaX) || (r.deltaY > 0 ? c() : r.deltaY < 0 && m());
  }, [
    m,
    c
  ]);
  Se({
    onScroll: ue,
    isDisabled: H || t || u || !ne
  }, o);
  var $;
  let O = (($ = re.maximumFractionDigits) !== null && $ !== void 0 ? $ : 0) > 0, I = a.minValue === void 0 || isNaN(a.minValue) || a.minValue < 0, l = "numeric";
  ge() ? I ? l = "text" : O && (l = "decimal") : Ve() && (I ? l = "numeric" : O && (l = "decimal"));
  let ce = (r) => {
    a.validate(r) && a.setInputValue(r);
  }, me = he(e), W = K((r) => {
    r.key === "Enter" ? (f(), y()) : r.continuePropagation();
  }, [
    f,
    y
  ]), { isInvalid: S, validationErrors: fe, validationDetails: be } = a.displayValidation, { labelProps: C, inputProps: pe, descriptionProps: $e, errorMessageProps: Pe } = Ce({
    ...J,
    ...me,
    name: void 0,
    label: k,
    autoFocus: A,
    isDisabled: t,
    isReadOnly: u,
    isRequired: h,
    validate: void 0,
    [Oe]: a,
    value: ee,
    defaultValue: void 0,
    autoComplete: "off",
    "aria-label": e["aria-label"] || void 0,
    "aria-labelledby": e["aria-labelledby"] || void 0,
    id: p,
    type: "text",
    inputMode: l,
    onChange: ce,
    onBlur: U,
    onFocus: Y,
    onFocusChange: z,
    onKeyDown: D(() => De(W, V), [
      W,
      V
    ]),
    onKeyUp: X,
    description: j,
    errorMessage: G
  }, a, o);
  Me(o, a.numberValue, a.setNumberValue);
  let T = v(oe, ae, pe, {
    // override the spinbutton role, we can't focus a spin button with VO
    role: null,
    // ignore aria-roledescription on iOS so that required state will announce when it is present
    "aria-roledescription": ye() ? null : b.format("numberField"),
    "aria-valuemax": null,
    "aria-valuemin": null,
    "aria-valuenow": null,
    "aria-valuetext": null,
    autoCorrect: "off",
    spellCheck: "false"
  });
  e.validationBehavior === "native" && (T["aria-required"] = void 0);
  let L = (r) => {
    var x;
    document.activeElement !== o.current && (r.pointerType === "mouse" ? (x = o.current) === null || x === void 0 || x.focus() : r.target.focus());
  }, P = e["aria-label"] || (typeof e.label == "string" ? e.label : ""), i;
  P || (i = e.label != null ? C.id : e["aria-labelledby"]);
  let N = F(), w = F(), xe = v(te, {
    "aria-label": d || b.format("increase", {
      fieldLabel: P
    }).trim(),
    id: i && !d ? N : null,
    "aria-labelledby": i && !d ? `${N} ${i}` : null,
    "aria-controls": p,
    excludeFromTabOrder: !0,
    preventFocusOnPress: !0,
    allowFocusWhenDisabled: !0,
    isDisabled: !a.canIncrement,
    onPressStart: L
  }), Fe = v(le, {
    "aria-label": s || b.format("decrease", {
      fieldLabel: P
    }).trim(),
    id: i && !s ? w : null,
    "aria-labelledby": i && !s ? `${w} ${i}` : null,
    "aria-controls": p,
    excludeFromTabOrder: !0,
    preventFocusOnPress: !0,
    allowFocusWhenDisabled: !0,
    isDisabled: !a.canDecrement,
    onPressStart: L
  });
  return {
    groupProps: {
      ...de,
      role: "group",
      "aria-disabled": t,
      "aria-invalid": S ? "true" : void 0
    },
    labelProps: C,
    inputProps: T,
    incrementButtonProps: xe,
    decrementButtonProps: Fe,
    errorMessageProps: Pe,
    descriptionProps: $e,
    isInvalid: S,
    validationErrors: fe,
    validationDetails: be
  };
}
export {
  Ze as useNumberField
};
