import { radioGroupData as I } from "./ui-components-library418.js";
import { useId as y } from "./ui-components-library122.js";
import { mergeProps as F } from "./ui-components-library123.js";
import { filterDOMProps as k } from "./ui-components-library124.js";
import { getFocusableTreeWalker as M } from "./ui-components-library171.js";
import { useFocusWithin as W } from "./ui-components-library341.js";
import { useField as B } from "./ui-components-library389.js";
import { useLocale as R } from "./ui-components-library130.js";
function L(r, o) {
  let { name: c, isReadOnly: u, isRequired: p, isDisabled: b, orientation: l = "vertical", validationBehavior: v = "aria" } = r, { direction: s } = R(), { isInvalid: m, validationErrors: n, validationDetails: $ } = o.displayValidation, { labelProps: g, fieldProps: x, descriptionProps: d, errorMessageProps: f } = B({
    ...r,
    // Radio group is not an HTML input element so it
    // shouldn't be labeled by a <label> element.
    labelElementType: "span",
    isInvalid: o.isInvalid,
    errorMessage: r.errorMessage || n
  }), P = k(r, {
    labelable: !0
  }), { focusWithinProps: h } = W({
    onBlurWithin(i) {
      var e;
      (e = r.onBlur) === null || e === void 0 || e.call(r, i), o.selectedValue || o.setLastFocusedValue(null);
    },
    onFocusWithin: r.onFocus,
    onFocusWithinChange: r.onFocusChange
  }), D = (i) => {
    let e;
    switch (i.key) {
      case "ArrowRight":
        s === "rtl" && l !== "vertical" ? e = "prev" : e = "next";
        break;
      case "ArrowLeft":
        s === "rtl" && l !== "vertical" ? e = "next" : e = "prev";
        break;
      case "ArrowDown":
        e = "next";
        break;
      case "ArrowUp":
        e = "prev";
        break;
      default:
        return;
    }
    i.preventDefault();
    let t = M(i.currentTarget, {
      from: i.target
    }), a;
    e === "next" ? (a = t.nextNode(), a || (t.currentNode = i.currentTarget, a = t.firstChild())) : (a = t.previousNode(), a || (t.currentNode = i.currentTarget, a = t.lastChild())), a && (a.focus(), o.setSelectedValue(a.value));
  }, w = y(c);
  return I.set(o, {
    name: w,
    descriptionId: d.id,
    errorMessageId: f.id,
    validationBehavior: v
  }), {
    radioGroupProps: F(P, {
      // https://www.w3.org/TR/wai-aria-1.2/#radiogroup
      role: "radiogroup",
      onKeyDown: D,
      "aria-invalid": o.isInvalid || void 0,
      "aria-errormessage": r["aria-errormessage"],
      "aria-readonly": u || void 0,
      "aria-required": p || void 0,
      "aria-disabled": b || void 0,
      "aria-orientation": l,
      ...x,
      ...h
    }),
    labelProps: g,
    descriptionProps: d,
    errorMessageProps: f,
    isInvalid: m,
    validationErrors: n,
    validationDetails: $
  };
}
export {
  L as useRadioGroup
};
