import { useId as C } from "./ui-components-library122.js";
import { chain as T } from "./ui-components-library271.js";
import { mergeProps as P } from "./ui-components-library123.js";
import { filterDOMProps as I } from "./ui-components-library124.js";
import { useMemo as E } from "react";
import { ListKeyboardDelegate as O } from "./ui-components-library167.js";
import { useTypeSelect as R } from "./ui-components-library420.js";
import { setInteractionModality as q } from "./ui-components-library340.js";
import { useCollator as U } from "./ui-components-library166.js";
import { useField as j } from "./ui-components-library389.js";
import { useMenuTrigger as L } from "./ui-components-library406.js";
const A = /* @__PURE__ */ new WeakMap();
function _(o, e, s) {
  let { keyboardDelegate: y, isDisabled: d, isRequired: D, name: g, validationBehavior: h = "aria" } = o, $ = U({
    usage: "search",
    sensitivity: "base"
  }), l = E(() => y || new O(e.collection, e.disabledKeys, s, $), [
    y,
    e.collection,
    e.disabledKeys,
    $
  ]), { menuTriggerProps: K, menuProps: x } = L({
    isDisabled: d,
    type: "listbox"
  }, e, s), F = (a) => {
    switch (a.key) {
      case "ArrowLeft": {
        var c, u;
        a.preventDefault();
        let i = e.selectedKey != null ? (c = l.getKeyAbove) === null || c === void 0 ? void 0 : c.call(l, e.selectedKey) : (u = l.getFirstKey) === null || u === void 0 ? void 0 : u.call(l);
        i && e.setSelectedKey(i);
        break;
      }
      case "ArrowRight": {
        var b, f;
        a.preventDefault();
        let i = e.selectedKey != null ? (b = l.getKeyBelow) === null || b === void 0 ? void 0 : b.call(l, e.selectedKey) : (f = l.getFirstKey) === null || f === void 0 ? void 0 : f.call(l);
        i && e.setSelectedKey(i);
        break;
      }
    }
  }, { typeSelectProps: n } = R({
    keyboardDelegate: l,
    selectionManager: e.selectionManager,
    onTypeSelect(a) {
      e.setSelectedKey(a);
    }
  }), { isInvalid: m, validationErrors: v, validationDetails: k } = e.displayValidation, { labelProps: w, fieldProps: t, descriptionProps: M, errorMessageProps: B } = j({
    ...o,
    labelElementType: "span",
    isInvalid: m,
    errorMessage: o.errorMessage || v
  });
  n.onKeyDown = n.onKeyDownCapture, delete n.onKeyDownCapture;
  let S = I(o, {
    labelable: !0
  }), r = P(n, K, t), p = C();
  return A.set(e, {
    isDisabled: d,
    isRequired: D,
    name: g,
    validationBehavior: h
  }), {
    labelProps: {
      ...w,
      onClick: () => {
        if (!o.isDisabled) {
          var a;
          (a = s.current) === null || a === void 0 || a.focus(), q("keyboard");
        }
      }
    },
    triggerProps: P(S, {
      ...r,
      isDisabled: d,
      onKeyDown: T(r.onKeyDown, F, o.onKeyDown),
      onKeyUp: o.onKeyUp,
      "aria-labelledby": [
        p,
        r["aria-labelledby"],
        r["aria-label"] && !r["aria-labelledby"] ? r.id : null
      ].filter(Boolean).join(" "),
      onFocus(a) {
        e.isFocused || (o.onFocus && o.onFocus(a), o.onFocusChange && o.onFocusChange(!0), e.setFocused(!0));
      },
      onBlur(a) {
        e.isOpen || (o.onBlur && o.onBlur(a), o.onFocusChange && o.onFocusChange(!1), e.setFocused(!1));
      }
    }),
    valueProps: {
      id: p
    },
    menuProps: {
      ...x,
      autoFocus: e.focusStrategy || !0,
      shouldSelectOnPressUp: !0,
      shouldFocusOnHover: !0,
      disallowEmptySelection: !0,
      linkBehavior: "selection",
      onBlur: (a) => {
        a.currentTarget.contains(a.relatedTarget) || (o.onBlur && o.onBlur(a), o.onFocusChange && o.onFocusChange(!1), e.setFocused(!1));
      },
      "aria-labelledby": [
        t["aria-labelledby"],
        r["aria-label"] && !t["aria-labelledby"] ? r.id : null
      ].filter(Boolean).join(" ")
    },
    descriptionProps: M,
    errorMessageProps: B,
    isInvalid: m,
    validationErrors: v,
    validationDetails: k
  };
}
export {
  A as selectData,
  _ as useSelect
};
