import { getOwnerWindow as y } from "./ui-components-library275.js";
import { mergeProps as h } from "./ui-components-library123.js";
import { filterDOMProps as E } from "./ui-components-library124.js";
import { useFormReset as I } from "./ui-components-library293.js";
import { useControlledState as M } from "./ui-components-library207.js";
import O, { useEffect as S } from "react";
import { useField as D } from "./ui-components-library389.js";
import { useFocusable as F } from "./ui-components-library101.js";
import { useFormValidation as R } from "./ui-components-library384.js";
import { useFormValidationState as V } from "./ui-components-library366.js";
function _(e, a) {
  let { inputElementType: u = "input", isDisabled: c = !1, isRequired: n = !1, isReadOnly: f = !1, type: m = "text", validationBehavior: r = "aria" } = e, [i, l] = M(e.value, e.defaultValue || "", e.onChange), { focusableProps: b } = F(e, a), d = V({
    ...e,
    value: i
  }), { isInvalid: o, validationErrors: s, validationDetails: $ } = d.displayValidation, { labelProps: v, fieldProps: p, descriptionProps: C, errorMessageProps: P } = D({
    ...e,
    isInvalid: o,
    errorMessage: e.errorMessage || s
  }), g = E(e, {
    labelable: !0
  });
  const x = {
    type: m,
    pattern: e.pattern
  };
  return I(a, i, l), R(e, d, a), S(() => {
    if (a.current instanceof y(a.current).HTMLTextAreaElement) {
      let t = a.current;
      Object.defineProperty(t, "defaultValue", {
        get: () => t.value,
        set: () => {
        },
        configurable: !0
      });
    }
  }, [
    a
  ]), {
    labelProps: v,
    inputProps: h(g, u === "input" ? x : void 0, {
      disabled: c,
      readOnly: f,
      required: n && r === "native",
      "aria-required": n && r === "aria" || void 0,
      "aria-invalid": o || void 0,
      "aria-errormessage": e["aria-errormessage"],
      "aria-activedescendant": e["aria-activedescendant"],
      "aria-autocomplete": e["aria-autocomplete"],
      "aria-haspopup": e["aria-haspopup"],
      "aria-controls": e["aria-controls"],
      value: i,
      onChange: (t) => l(t.target.value),
      autoComplete: e.autoComplete,
      autoCapitalize: e.autoCapitalize,
      maxLength: e.maxLength,
      minLength: e.minLength,
      name: e.name,
      placeholder: e.placeholder,
      inputMode: e.inputMode,
      autoCorrect: e.autoCorrect,
      spellCheck: e.spellCheck,
      [parseInt(O.version, 10) >= 17 ? "enterKeyHint" : "enterkeyhint"]: e.enterKeyHint,
      // Clipboard events
      onCopy: e.onCopy,
      onCut: e.onCut,
      onPaste: e.onPaste,
      // Composition events
      onCompositionEnd: e.onCompositionEnd,
      onCompositionStart: e.onCompositionStart,
      onCompositionUpdate: e.onCompositionUpdate,
      // Selection events
      onSelect: e.onSelect,
      // Input events
      onBeforeInput: e.onBeforeInput,
      onInput: e.onInput,
      ...b,
      ...p
    }),
    descriptionProps: C,
    errorMessageProps: P,
    isInvalid: o,
    validationErrors: s,
    validationDetails: $
  };
}
export {
  _ as useTextField
};
