import { ButtonContext as A } from "./ui-components-library42.js";
import { CheckboxContext as O } from "./ui-components-library117.js";
import { CollectionRendererContext as z, usePersistedKeys as W, DefaultCollectionRenderer as G } from "./ui-components-library160.js";
import { useContextProps as U, useRenderProps as w, Provider as H, DEFAULT_SLOT as j } from "./ui-components-library119.js";
import { createBranchComponent as q, CollectionBuilder as J, Collection as Q, createLeafComponent as D } from "./ui-components-library93.js";
import { useCachedChildren as X } from "./ui-components-library161.js";
import { mergeProps as S } from "./ui-components-library123.js";
import { filterDOMProps as F } from "./ui-components-library124.js";
import { useObjectRef as Y } from "./ui-components-library138.js";
import { useControlledState as Z } from "./ui-components-library207.js";
import n, { forwardRef as ee, createContext as V, useContext as E, useEffect as I, useRef as te, useMemo as ae } from "react";
import { useTreeItem as N } from "./ui-components-library208.js";
import { useTree as le } from "./ui-components-library209.js";
import { useHover as re } from "./ui-components-library127.js";
import { useFocusRing as T } from "./ui-components-library126.js";
import { FocusScope as oe } from "./ui-components-library171.js";
import { useGridListSelectionCheckbox as ne } from "./ui-components-library210.js";
import { useTreeState as se } from "./ui-components-library211.js";
class ie {
  // TODO: should this collection's getters reflect the flattened structure or the original structure
  // If we respresent the flattened structure, it is easier for the keyboard nav but harder to find all the nodes
  *[Symbol.iterator]() {
    yield* this.flattenedRows;
  }
  get size() {
    return this.flattenedRows.length;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  getItem(e) {
    return this.keyMap.get(e) || null;
  }
  at(e) {
    return this.flattenedRows[e];
  }
  getFirstKey() {
    var e;
    return (e = this.flattenedRows[0]) === null || e === void 0 ? void 0 : e.key;
  }
  getLastKey() {
    var e;
    return (e = this.flattenedRows[this.size - 1]) === null || e === void 0 ? void 0 : e.key;
  }
  getKeyAfter(e) {
    var t;
    let o = this.flattenedRows.findIndex((l) => l.key === e);
    return (t = this.flattenedRows[o + 1]) === null || t === void 0 ? void 0 : t.key;
  }
  getKeyBefore(e) {
    var t;
    let o = this.flattenedRows.findIndex((l) => l.key === e);
    return (t = this.flattenedRows[o - 1]) === null || t === void 0 ? void 0 : t.key;
  }
  // Note that this will return Content nodes in addition to nested TreeItems
  getChildren(e) {
    let t = this.keyMap;
    return {
      *[Symbol.iterator]() {
        let o = t.get(e), l = (o == null ? void 0 : o.firstChildKey) != null ? t.get(o.firstChildKey) : null;
        for (; l; )
          yield l, l = l.nextKey != null ? t.get(l.nextKey) : void 0;
      }
    };
  }
  getTextValue(e) {
    let t = this.getItem(e);
    return t ? t.textValue : "";
  }
  constructor(e) {
    this.keyMap = /* @__PURE__ */ new Map();
    let { collection: t, expandedKeys: o } = e, { flattenedRows: l, keyMap: s } = fe(t, {
      expandedKeys: o
    });
    this.flattenedRows = l, this.keyMap = s;
  }
}
const de = /* @__PURE__ */ V(null), _ = /* @__PURE__ */ V(null), Te = /* @__PURE__ */ ee(function(e, t) {
  return [e, t] = U(e, t, de), /* @__PURE__ */ n.createElement(J, {
    content: /* @__PURE__ */ n.createElement(Q, e)
  }, (o) => /* @__PURE__ */ n.createElement(ce, {
    props: e,
    collection: o,
    treeRef: t
  }));
});
function ce({ props: r, collection: e, treeRef: t }) {
  let { selectionMode: o = "none", expandedKeys: l, defaultExpandedKeys: s, onExpandedChange: a, disabledBehavior: i = "all" } = r, { CollectionRoot: f, isVirtualized: d, layoutDelegate: $ } = E(z), [u, p] = Z(l ? B(l) : void 0, s ? B(s) : /* @__PURE__ */ new Set(), a), P = ae(() => new ie({
    collection: e,
    expandedKeys: u
  }), [
    e,
    u
  ]), c = se({
    ...r,
    selectionMode: o,
    expandedKeys: u,
    onExpandedChange: p,
    collection: P,
    children: void 0,
    disabledBehavior: i
  }), { gridProps: m } = le({
    ...r,
    isVirtualized: d,
    layoutDelegate: $
  }, c, t), { focusProps: R, isFocused: b, isFocusVisible: h } = T(), x = {
    isEmpty: c.collection.size === 0,
    isFocused: b,
    isFocusVisible: h,
    state: c
  }, v = w({
    className: r.className,
    style: r.style,
    defaultClassName: "react-aria-Tree",
    values: x
  }), y = null;
  if (c.collection.size === 0 && r.renderEmptyState) {
    let { isEmpty: k, ...M } = x, C = r.renderEmptyState({
      ...M
    }), K = {
      "aria-level": 1,
      "aria-posinset": 1,
      "aria-setsize": 1
    };
    y = /* @__PURE__ */ n.createElement("div", {
      role: "row",
      style: {
        display: "contents"
      },
      ...K
    }, /* @__PURE__ */ n.createElement("div", {
      role: "gridcell",
      style: {
        display: "contents"
      }
    }, C));
  }
  return /* @__PURE__ */ n.createElement(oe, null, /* @__PURE__ */ n.createElement("div", {
    ...F(r),
    ...v,
    ...S(m, R),
    ref: t,
    slot: r.slot || void 0,
    onScroll: r.onScroll,
    "data-empty": c.collection.size === 0 || void 0,
    "data-focused": b || void 0,
    "data-focus-visible": h || void 0
  }, /* @__PURE__ */ n.createElement(H, {
    values: [
      [
        _,
        c
      ]
    ]
  }, /* @__PURE__ */ n.createElement(f, {
    collection: c.collection,
    persistedKeys: W(c.selectionManager.focusedKey),
    scrollRef: t
  })), y));
}
const Se = /* @__PURE__ */ D("content", function(e) {
  let t = E(L), o = w({
    children: e.children,
    values: t
  });
  return /* @__PURE__ */ n.createElement(z.Provider, {
    value: G
  }, o.children);
}), L = /* @__PURE__ */ V(null), Fe = /* @__PURE__ */ q("item", (r, e, t) => {
  var o;
  let l = E(_);
  e = Y(e);
  let { rowProps: s, gridCellProps: a, expandButtonProps: i, descriptionProps: f, ...d } = N({
    node: t
  }, l, e), $ = s["aria-expanded"] === !0, u = r.hasChildItems || ((o = [
    ...l.collection.getChildren(t.key)
  ]) === null || o === void 0 ? void 0 : o.length) > 1, p = s["aria-level"] || 1, { hoverProps: P, isHovered: c } = re({
    isDisabled: !d.allowsSelection && !d.hasAction,
    onHoverStart: r.onHoverStart,
    onHoverChange: r.onHoverChange,
    onHoverEnd: r.onHoverEnd
  }), { isFocusVisible: m, focusProps: R } = T(), { isFocusVisible: b, focusProps: h } = T({
    within: !0
  }), { checkboxProps: x } = ne({
    key: t.key
  }, l), v = l.selectionManager.selectionMode, y = l.selectionManager.selectionBehavior, k = n.useMemo(() => ({
    ...d,
    isHovered: c,
    isFocusVisible: m,
    isExpanded: $,
    hasChildItems: u,
    level: p,
    selectionMode: v,
    selectionBehavior: y,
    isFocusVisibleWithin: b,
    state: l,
    id: t.key
  }), [
    d,
    c,
    m,
    v,
    y,
    $,
    u,
    p,
    b,
    l,
    t.key
  ]), M = w({
    ...r,
    id: void 0,
    children: t.rendered,
    defaultClassName: "react-aria-TreeItem",
    defaultStyle: {
      // @ts-ignore
      "--tree-item-level": p
    },
    values: k
  });
  I(() => {
    t.textValue || console.warn("A `textValue` prop is required for <TreeItem> elements in order to support accessibility features such as type to select.");
  }, [
    t.textValue
  ]);
  let C = te(null);
  I(() => {
    u && !C.current && console.warn("Expandable tree items must contain a expand button so screen reader users can expand/collapse the item.");
  }, []);
  let K = X({
    items: l.collection.getChildren(t.key),
    children: (g) => {
      switch (g.type) {
        case "content":
          return g.render(g);
        // Skip item since we don't render the nested rows as children of the parent row, the flattened collection
        // will render them each as siblings instead
        case "loader":
        case "item":
          return /* @__PURE__ */ n.createElement(n.Fragment, null);
        default:
          throw new Error("Unsupported element type in TreeRow: " + g.type);
      }
    }
  });
  return /* @__PURE__ */ n.createElement(n.Fragment, null, /* @__PURE__ */ n.createElement("div", {
    ...S(F(r), s, R, P, h),
    ...M,
    ref: e,
    // TODO: missing selectionBehavior, hasAction and allowsSelection data attribute equivalents (available in renderProps). Do we want those?
    "data-expanded": u && $ || void 0,
    "data-has-child-items": u || void 0,
    "data-level": p,
    "data-selected": d.isSelected || void 0,
    "data-disabled": d.isDisabled || void 0,
    "data-hovered": c || void 0,
    "data-focused": d.isFocused || void 0,
    "data-focus-visible": m || void 0,
    "data-pressed": d.isPressed || void 0,
    "data-selection-mode": l.selectionManager.selectionMode === "none" ? void 0 : l.selectionManager.selectionMode
  }, /* @__PURE__ */ n.createElement("div", {
    ...a,
    style: {
      display: "contents"
    }
  }, /* @__PURE__ */ n.createElement(H, {
    values: [
      [
        O,
        {
          slots: {
            selection: x
          }
        }
      ],
      // TODO: support description in the tree row
      // TODO: don't think I need to pass isExpanded to the button here since it can be sourced from the renderProps? Might be worthwhile passing it down?
      [
        A,
        {
          slots: {
            [j]: {},
            chevron: {
              ...i,
              ref: C
            }
          }
        }
      ],
      [
        L,
        {
          ...k
        }
      ]
    ]
  }, K))));
});
D("loader", function(e, t, o) {
  let l = E(_), { rowProps: s } = N({
    node: o
  }, l, t), a = s["aria-level"] || 1, i = {
    "aria-level": s["aria-level"],
    "aria-posinset": s["aria-posinset"],
    "aria-setsize": s["aria-setsize"]
  }, f = w({
    ...e,
    id: void 0,
    children: o.rendered,
    defaultClassName: "react-aria-TreeLoader",
    values: {
      level: a
    }
  });
  return /* @__PURE__ */ n.createElement(n.Fragment, null, /* @__PURE__ */ n.createElement("div", {
    role: "row",
    ref: t,
    ...S(F(e), i),
    ...f,
    "data-level": a
  }, /* @__PURE__ */ n.createElement("div", {
    role: "gridcell",
    "aria-colindex": 1
  }, f.children)));
});
function B(r) {
  return r ? r === "all" ? "all" : new Set(r) : /* @__PURE__ */ new Set();
}
function fe(r, e) {
  let { expandedKeys: t = /* @__PURE__ */ new Set() } = e, o = /* @__PURE__ */ new Map(), l = [], s = (a) => {
    if (a.type === "item" || a.type === "loader") {
      let i = a == null ? void 0 : a.parentKey, f = {
        ...a
      };
      i != null ? ([
        ...r.getChildren(i)
      ][0].type !== "item" && (f.index = (a == null ? void 0 : a.index) != null ? (a == null ? void 0 : a.index) - 1 : 0), a.type === "loader" && (f.level = a.level + 1), o.set(f.key, f)) : o.set(a.key, a), (a.level === 0 || i != null && t.has(i) && l.find((d) => d.key === i)) && l.push(o.get(a.key) || a);
    } else a.type !== null && o.set(a.key, a);
    for (let i of r.getChildren(a.key)) s(i);
  };
  for (let a of r) s(a);
  return {
    flattenedRows: l,
    keyMap: o
  };
}
export {
  Te as Tree,
  de as TreeContext,
  Fe as TreeItem,
  Se as TreeItemContent,
  L as TreeItemContentContext,
  _ as TreeStateContext
};
