import { nodeContains as l } from "./ui-components-library273.js";
import { shadowDOM as h } from "./ui-components-library274.js";
class u {
  get currentNode() {
    return this._currentNode;
  }
  set currentNode(t) {
    if (!l(this.root, t)) throw new Error("Cannot set currentNode to a node that is not contained by the root node.");
    const e = [];
    let r = t, o = t;
    for (this._currentNode = t; r && r !== this.root; ) if (r.nodeType === Node.DOCUMENT_FRAGMENT_NODE) {
      const s = r, n = this._doc.createTreeWalker(s, this.whatToShow, {
        acceptNode: this._acceptNode
      });
      e.push(n), n.currentNode = o, this._currentSetFor.add(n), r = o = s.host;
    } else r = r.parentNode;
    const i = this._doc.createTreeWalker(this.root, this.whatToShow, {
      acceptNode: this._acceptNode
    });
    e.push(i), i.currentNode = o, this._currentSetFor.add(i), this._walkerStack = e;
  }
  get doc() {
    return this._doc;
  }
  firstChild() {
    let t = this.currentNode, e = this.nextNode();
    return l(t, e) ? (e && (this.currentNode = e), e) : (this.currentNode = t, null);
  }
  lastChild() {
    let e = this._walkerStack[0].lastChild();
    return e && (this.currentNode = e), e;
  }
  nextNode() {
    const t = this._walkerStack[0].nextNode();
    if (t) {
      if (t.shadowRoot) {
        var e;
        let o;
        if (typeof this.filter == "function" ? o = this.filter(t) : !((e = this.filter) === null || e === void 0) && e.acceptNode && (o = this.filter.acceptNode(t)), o === NodeFilter.FILTER_ACCEPT)
          return this.currentNode = t, t;
        let i = this.nextNode();
        return i && (this.currentNode = i), i;
      }
      return t && (this.currentNode = t), t;
    } else if (this._walkerStack.length > 1) {
      this._walkerStack.shift();
      let r = this.nextNode();
      return r && (this.currentNode = r), r;
    } else return null;
  }
  previousNode() {
    const t = this._walkerStack[0];
    if (t.currentNode === t.root) {
      if (this._currentSetFor.has(t))
        if (this._currentSetFor.delete(t), this._walkerStack.length > 1) {
          this._walkerStack.shift();
          let o = this.previousNode();
          return o && (this.currentNode = o), o;
        } else return null;
      return null;
    }
    const e = t.previousNode();
    if (e) {
      if (e.shadowRoot) {
        var r;
        let i;
        if (typeof this.filter == "function" ? i = this.filter(e) : !((r = this.filter) === null || r === void 0) && r.acceptNode && (i = this.filter.acceptNode(e)), i === NodeFilter.FILTER_ACCEPT)
          return e && (this.currentNode = e), e;
        let s = this.lastChild();
        return s && (this.currentNode = s), s;
      }
      return e && (this.currentNode = e), e;
    } else if (this._walkerStack.length > 1) {
      this._walkerStack.shift();
      let o = this.previousNode();
      return o && (this.currentNode = o), o;
    } else return null;
  }
  /**
   * @deprecated
   */
  nextSibling() {
    return null;
  }
  /**
   * @deprecated
   */
  previousSibling() {
    return null;
  }
  /**
   * @deprecated
   */
  parentNode() {
    return null;
  }
  constructor(t, e, r, o) {
    this._walkerStack = [], this._currentSetFor = /* @__PURE__ */ new Set(), this._acceptNode = (s) => {
      if (s.nodeType === Node.ELEMENT_NODE) {
        const d = s.shadowRoot;
        if (d) {
          const a = this._doc.createTreeWalker(d, this.whatToShow, {
            acceptNode: this._acceptNode
          });
          return this._walkerStack.unshift(a), NodeFilter.FILTER_ACCEPT;
        } else {
          var n;
          if (typeof this.filter == "function") return this.filter(s);
          if (!((n = this.filter) === null || n === void 0) && n.acceptNode) return this.filter.acceptNode(s);
          if (this.filter === null) return NodeFilter.FILTER_ACCEPT;
        }
      }
      return NodeFilter.FILTER_SKIP;
    }, this._doc = t, this.root = e, this.filter = o ?? null, this.whatToShow = r ?? NodeFilter.SHOW_ALL, this._currentNode = e, this._walkerStack.unshift(t.createTreeWalker(e, r, this._acceptNode));
    const i = e.shadowRoot;
    if (i) {
      const s = this._doc.createTreeWalker(i, this.whatToShow, {
        acceptNode: this._acceptNode
      });
      this._walkerStack.unshift(s);
    }
  }
}
function w(c, t, e, r) {
  return h() ? new u(c, t, e, r) : c.createTreeWalker(t, e, r);
}
export {
  u as ShadowTreeWalker,
  w as createShadowTreeWalker
};
