import { CalendarDate as $ } from "./ui-components-library296.js";
import { GregorianCalendar as c } from "./ui-components-library299.js";
const f = [
  [
    1868,
    9,
    8
  ],
  [
    1912,
    7,
    30
  ],
  [
    1926,
    12,
    25
  ],
  [
    1989,
    1,
    8
  ],
  [
    2019,
    5,
    1
  ]
], D = [
  [
    1912,
    7,
    29
  ],
  [
    1926,
    12,
    24
  ],
  [
    1989,
    1,
    7
  ],
  [
    2019,
    4,
    30
  ]
], u = [
  1867,
  1911,
  1925,
  1988,
  2018
], i = [
  "meiji",
  "taisho",
  "showa",
  "heisei",
  "reiwa"
];
function h(e) {
  const r = f.findIndex(([n, a, t]) => e.year < n || e.year === n && e.month < a || e.year === n && e.month === a && e.day < t);
  return r === -1 ? f.length - 1 : r === 0 ? 0 : r - 1;
}
function s(e) {
  let r = u[i.indexOf(e.era)];
  if (!r) throw new Error("Unknown era: " + e.era);
  return new $(e.year + r, e.month, e.day);
}
class g extends c {
  fromJulianDay(r) {
    let n = super.fromJulianDay(r), a = h(n);
    return new $(this, i[a], n.year - u[a], n.month, n.day);
  }
  toJulianDay(r) {
    return super.toJulianDay(s(r));
  }
  balanceDate(r) {
    let n = s(r), a = h(n);
    i[a] !== r.era && (r.era = i[a], r.year = n.year - u[a]), this.constrainDate(r);
  }
  constrainDate(r) {
    let n = i.indexOf(r.era), a = D[n];
    if (a != null) {
      let [t, o, y] = a, m = t - u[n];
      r.year = Math.max(1, Math.min(m, r.year)), r.year === m && (r.month = Math.min(o, r.month), r.month === o && (r.day = Math.min(y, r.day)));
    }
    if (r.year === 1 && n >= 0) {
      let [, t, o] = f[n];
      r.month = Math.max(t, r.month), r.month === t && (r.day = Math.max(o, r.day));
    }
  }
  getEras() {
    return i;
  }
  getYearsInEra(r) {
    let n = i.indexOf(r.era), a = f[n], t = f[n + 1];
    if (t == null)
      return 9999 - a[0] + 1;
    let o = t[0] - a[0];
    return (r.month < t[1] || r.month === t[1] && r.day < t[2]) && o++, o;
  }
  getDaysInMonth(r) {
    return super.getDaysInMonth(s(r));
  }
  getMinimumMonthInYear(r) {
    let n = l(r);
    return n ? n[1] : 1;
  }
  getMinimumDayInMonth(r) {
    let n = l(r);
    return n && r.month === n[1] ? n[2] : 1;
  }
  constructor(...r) {
    super(...r), this.identifier = "japanese";
  }
}
function l(e) {
  if (e.year === 1) {
    let r = i.indexOf(e.era);
    return f[r];
  }
}
export {
  g as JapaneseCalendar
};
