import { CalendarDate as s } from "./ui-components-library296.js";
const i = 1723856, $ = 1824665, c = 5500;
function f(a, r, e, t) {
  return a + 365 * r + Math.floor(r / 4) + 30 * (e - 1) + t - 1;
}
function u(a, r) {
  let e = Math.floor(4 * (r - a) / 1461), t = 1 + Math.floor((r - f(a, e, 1, 1)) / 30), n = r + 1 - f(a, e, t, 1);
  return [
    e,
    t,
    n
  ];
}
function l(a) {
  return Math.floor(a % 4 / 3);
}
function y(a, r) {
  return r % 13 !== 0 ? 30 : l(a) + 5;
}
class b {
  fromJulianDay(r) {
    let [e, t, n] = u(i, r), o = "AM";
    return e <= 0 && (o = "AA", e += c), new s(this, o, e, t, n);
  }
  toJulianDay(r) {
    let e = r.year;
    return r.era === "AA" && (e -= c), f(i, e, r.month, r.day);
  }
  getDaysInMonth(r) {
    return y(r.year, r.month);
  }
  getMonthsInYear() {
    return 13;
  }
  getDaysInYear(r) {
    return 365 + l(r.year);
  }
  getYearsInEra(r) {
    return r.era === "AA" ? 9999 : 9991;
  }
  getEras() {
    return [
      "AA",
      "AM"
    ];
  }
  constructor() {
    this.identifier = "ethiopic";
  }
}
class h extends b {
  fromJulianDay(r) {
    let [e, t, n] = u(i, r);
    return e += c, new s(this, "AA", e, t, n);
  }
  getEras() {
    return [
      "AA"
    ];
  }
  getYearsInEra() {
    return 9999;
  }
  constructor(...r) {
    super(...r), this.identifier = "ethioaa";
  }
}
class C extends b {
  fromJulianDay(r) {
    let [e, t, n] = u($, r), o = "CE";
    return e <= 0 && (o = "BCE", e = 1 - e), new s(this, o, e, t, n);
  }
  toJulianDay(r) {
    let e = r.year;
    return r.era === "BCE" && (e = 1 - e), f($, e, r.month, r.day);
  }
  getDaysInMonth(r) {
    let e = r.year;
    return r.era === "BCE" && (e = 1 - e), y(e, r.month);
  }
  isInverseEra(r) {
    return r.era === "BCE";
  }
  balanceDate(r) {
    r.year <= 0 && (r.era = r.era === "BCE" ? "CE" : "BCE", r.year = 1 - r.year);
  }
  getEras() {
    return [
      "BCE",
      "CE"
    ];
  }
  getYearsInEra(r) {
    return r.era === "BCE" ? 9999 : 9715;
  }
  constructor(...r) {
    super(...r), this.identifier = "coptic";
  }
}
export {
  C as CopticCalendar,
  h as EthiopicAmeteAlemCalendar,
  b as EthiopicCalendar
};
