import { getOwnerWindow as b } from "./ui-components-library275.js";
import { focusWithoutScrolling as l } from "./ui-components-library276.js";
import { useLayoutEffect as p } from "./ui-components-library142.js";
import { useEffectEvent as m } from "./ui-components-library289.js";
import { isFocusable as v } from "./ui-components-library153.js";
import { useRef as $, useCallback as h } from "react";
class E {
  isDefaultPrevented() {
    return this.nativeEvent.defaultPrevented;
  }
  preventDefault() {
    this.defaultPrevented = !0, this.nativeEvent.preventDefault();
  }
  stopPropagation() {
    this.nativeEvent.stopPropagation(), this.isPropagationStopped = () => !0;
  }
  isPropagationStopped() {
    return !1;
  }
  persist() {
  }
  constructor(e, r) {
    this.nativeEvent = r, this.target = r.target, this.currentTarget = r.currentTarget, this.relatedTarget = r.relatedTarget, this.bubbles = r.bubbles, this.cancelable = r.cancelable, this.defaultPrevented = r.defaultPrevented, this.eventPhase = r.eventPhase, this.isTrusted = r.isTrusted, this.timeStamp = r.timeStamp, this.type = e;
  }
}
function w(s) {
  let e = $({
    isFocused: !1,
    observer: null
  });
  p(() => {
    const t = e.current;
    return () => {
      t.observer && (t.observer.disconnect(), t.observer = null);
    };
  }, []);
  let r = m((t) => {
    s == null || s(t);
  });
  return h((t) => {
    if (t.target instanceof HTMLButtonElement || t.target instanceof HTMLInputElement || t.target instanceof HTMLTextAreaElement || t.target instanceof HTMLSelectElement) {
      e.current.isFocused = !0;
      let n = t.target, u = (o) => {
        e.current.isFocused = !1, n.disabled && r(new E("blur", o)), e.current.observer && (e.current.observer.disconnect(), e.current.observer = null);
      };
      n.addEventListener("focusout", u, {
        once: !0
      }), e.current.observer = new MutationObserver(() => {
        if (e.current.isFocused && n.disabled) {
          var o;
          (o = e.current.observer) === null || o === void 0 || o.disconnect();
          let i = n === document.activeElement ? null : document.activeElement;
          n.dispatchEvent(new FocusEvent("blur", {
            relatedTarget: i
          })), n.dispatchEvent(new FocusEvent("focusout", {
            bubbles: !0,
            relatedTarget: i
          }));
        }
      }), e.current.observer.observe(n, {
        attributes: !0,
        attributeFilter: [
          "disabled"
        ]
      });
    }
  }, [
    r
  ]);
}
let d = !1;
function S(s) {
  for (; s && !v(s); ) s = s.parentElement;
  let e = b(s), r = e.document.activeElement;
  if (!r || r === s) return;
  d = !0;
  let t = !1, n = (a) => {
    (a.target === r || t) && a.stopImmediatePropagation();
  }, u = (a) => {
    (a.target === r || t) && (a.stopImmediatePropagation(), !s && !t && (t = !0, l(r), c()));
  }, o = (a) => {
    (a.target === s || t) && a.stopImmediatePropagation();
  }, i = (a) => {
    (a.target === s || t) && (a.stopImmediatePropagation(), t || (t = !0, l(r), c()));
  };
  e.addEventListener("blur", n, !0), e.addEventListener("focusout", u, !0), e.addEventListener("focusin", i, !0), e.addEventListener("focus", o, !0);
  let c = () => {
    cancelAnimationFrame(f), e.removeEventListener("blur", n, !0), e.removeEventListener("focusout", u, !0), e.removeEventListener("focusin", i, !0), e.removeEventListener("focus", o, !0), d = !1, t = !1;
  }, f = requestAnimationFrame(c);
  return c;
}
export {
  E as SyntheticFocusEvent,
  d as ignoreFocusEvent,
  S as preventFocus,
  w as useSyntheticBlurEvent
};
