import { restoreTextSelection as X, disableTextSelection as Y } from "./ui-components-library346.js";
import { useRef as D, useMemo as x } from "react";
import { useGlobalListeners as k } from "./ui-components-library280.js";
import { useEffectEvent as T } from "./ui-components-library289.js";
function P($) {
  let { onMoveStart: g, onMove: s, onMoveEnd: K } = $, o = D({
    didMove: !1,
    lastPosition: null,
    id: null
  }), { addGlobalListener: t, removeGlobalListener: u } = k(), m = T((d, f, v, n) => {
    v === 0 && n === 0 || (o.current.didMove || (o.current.didMove = !0, g == null || g({
      type: "movestart",
      pointerType: f,
      shiftKey: d.shiftKey,
      metaKey: d.metaKey,
      ctrlKey: d.ctrlKey,
      altKey: d.altKey
    })), s == null || s({
      type: "move",
      pointerType: f,
      deltaX: v,
      deltaY: n,
      shiftKey: d.shiftKey,
      metaKey: d.metaKey,
      ctrlKey: d.ctrlKey,
      altKey: d.altKey
    }));
  }), y = T((d, f) => {
    X(), o.current.didMove && (K == null || K({
      type: "moveend",
      pointerType: f,
      shiftKey: d.shiftKey,
      metaKey: d.metaKey,
      ctrlKey: d.ctrlKey,
      altKey: d.altKey
    }));
  });
  return {
    moveProps: x(() => {
      let d = {}, f = () => {
        Y(), o.current.didMove = !1;
      };
      if (typeof PointerEvent > "u") {
        let n = (e) => {
          if (e.button === 0) {
            var p, l, a, w;
            m(e, "mouse", e.pageX - ((a = (p = o.current.lastPosition) === null || p === void 0 ? void 0 : p.pageX) !== null && a !== void 0 ? a : 0), e.pageY - ((w = (l = o.current.lastPosition) === null || l === void 0 ? void 0 : l.pageY) !== null && w !== void 0 ? w : 0)), o.current.lastPosition = {
              pageX: e.pageX,
              pageY: e.pageY
            };
          }
        }, c = (e) => {
          e.button === 0 && (y(e, "mouse"), u(window, "mousemove", n, !1), u(window, "mouseup", c, !1));
        };
        d.onMouseDown = (e) => {
          e.button === 0 && (f(), e.stopPropagation(), e.preventDefault(), o.current.lastPosition = {
            pageX: e.pageX,
            pageY: e.pageY
          }, t(window, "mousemove", n, !1), t(window, "mouseup", c, !1));
        };
        let r = (e) => {
          let p = [
            ...e.changedTouches
          ].findIndex(({ identifier: h }) => h === o.current.id);
          if (p >= 0) {
            var l, a;
            let { pageX: h, pageY: M } = e.changedTouches[p];
            var w, b;
            m(e, "touch", h - ((w = (l = o.current.lastPosition) === null || l === void 0 ? void 0 : l.pageX) !== null && w !== void 0 ? w : 0), M - ((b = (a = o.current.lastPosition) === null || a === void 0 ? void 0 : a.pageY) !== null && b !== void 0 ? b : 0)), o.current.lastPosition = {
              pageX: h,
              pageY: M
            };
          }
        }, i = (e) => {
          [
            ...e.changedTouches
          ].findIndex(({ identifier: l }) => l === o.current.id) >= 0 && (y(e, "touch"), o.current.id = null, u(window, "touchmove", r), u(window, "touchend", i), u(window, "touchcancel", i));
        };
        d.onTouchStart = (e) => {
          if (e.changedTouches.length === 0 || o.current.id != null) return;
          let { pageX: p, pageY: l, identifier: a } = e.changedTouches[0];
          f(), e.stopPropagation(), e.preventDefault(), o.current.lastPosition = {
            pageX: p,
            pageY: l
          }, o.current.id = a, t(window, "touchmove", r, !1), t(window, "touchend", i, !1), t(window, "touchcancel", i, !1);
        };
      } else {
        let n = (r) => {
          if (r.pointerId === o.current.id) {
            var i, e;
            let a = r.pointerType || "mouse";
            var p, l;
            m(r, a, r.pageX - ((p = (i = o.current.lastPosition) === null || i === void 0 ? void 0 : i.pageX) !== null && p !== void 0 ? p : 0), r.pageY - ((l = (e = o.current.lastPosition) === null || e === void 0 ? void 0 : e.pageY) !== null && l !== void 0 ? l : 0)), o.current.lastPosition = {
              pageX: r.pageX,
              pageY: r.pageY
            };
          }
        }, c = (r) => {
          if (r.pointerId === o.current.id) {
            let i = r.pointerType || "mouse";
            y(r, i), o.current.id = null, u(window, "pointermove", n, !1), u(window, "pointerup", c, !1), u(window, "pointercancel", c, !1);
          }
        };
        d.onPointerDown = (r) => {
          r.button === 0 && o.current.id == null && (f(), r.stopPropagation(), r.preventDefault(), o.current.lastPosition = {
            pageX: r.pageX,
            pageY: r.pageY
          }, o.current.id = r.pointerId, t(window, "pointermove", n, !1), t(window, "pointerup", c, !1), t(window, "pointercancel", c, !1));
        };
      }
      let v = (n, c, r) => {
        f(), m(n, "keyboard", c, r), y(n, "keyboard");
      };
      return d.onKeyDown = (n) => {
        switch (n.key) {
          case "Left":
          case "ArrowLeft":
            n.preventDefault(), n.stopPropagation(), v(n, -1, 0);
            break;
          case "Right":
          case "ArrowRight":
            n.preventDefault(), n.stopPropagation(), v(n, 1, 0);
            break;
          case "Up":
          case "ArrowUp":
            n.preventDefault(), n.stopPropagation(), v(n, 0, -1);
            break;
          case "Down":
          case "ArrowDown":
            n.preventDefault(), n.stopPropagation(), v(n, 0, 1);
            break;
        }
      }, d;
    }, [
      o,
      t,
      u,
      m,
      y
    ])
  };
}
export {
  P as useMove
};
