import { restoreTextSelection as U, disableTextSelection as H } from "./ui-components-library346.js";
import { PressResponderContext as re } from "./ui-components-library337.js";
import { preventFocus as G } from "./ui-components-library339.js";
import { _class_private_field_get as ne } from "./ui-components-library348.js";
import { _class_private_field_init as ie } from "./ui-components-library301.js";
import { _class_private_field_set as B } from "./ui-components-library349.js";
import { chain as ae } from "./ui-components-library271.js";
import { nodeContains as p, getEventTarget as c } from "./ui-components-library273.js";
import { getOwnerDocument as D, getOwnerWindow as R } from "./ui-components-library275.js";
import { mergeProps as J } from "./ui-components-library123.js";
import { focusWithoutScrolling as se } from "./ui-components-library276.js";
import { openLink as V } from "./ui-components-library277.js";
import { useGlobalListeners as oe } from "./ui-components-library280.js";
import { useSyncRef as le } from "./ui-components-library283.js";
import { isMac as fe } from "./ui-components-library278.js";
import { isVirtualPointerEvent as ue, isVirtualClick as W } from "./ui-components-library291.js";
import { useEffectEvent as I } from "./ui-components-library289.js";
import { flushSync as ce } from "react-dom";
import { useState as pe, useRef as de, useMemo as ge, useEffect as ve, useContext as Te } from "react";
function Pe(n) {
  let i = Te(re);
  if (i) {
    let { register: o, ...l } = i;
    n = J(l, n), o();
  }
  return le(i, n.ref), n;
}
var X = /* @__PURE__ */ new WeakMap();
class Y {
  continuePropagation() {
    B(this, X, !1);
  }
  get shouldStopPropagation() {
    return ne(this, X);
  }
  constructor(i, o, l, d) {
    ie(this, X, {
      writable: !0,
      value: void 0
    }), B(this, X, !0);
    var y;
    let $ = (y = d == null ? void 0 : d.target) !== null && y !== void 0 ? y : l.currentTarget;
    const E = $ == null ? void 0 : $.getBoundingClientRect();
    let b, k = 0, v, w = null;
    l.clientX != null && l.clientY != null && (v = l.clientX, w = l.clientY), E && (v != null && w != null ? (b = v - E.left, k = w - E.top) : (b = E.width / 2, k = E.height / 2)), this.type = i, this.pointerType = o, this.target = l.currentTarget, this.shiftKey = l.shiftKey, this.metaKey = l.metaKey, this.ctrlKey = l.ctrlKey, this.altKey = l.altKey, this.x = b, this.y = k;
  }
}
const N = Symbol("linkClicked");
function He(n) {
  let {
    onPress: i,
    onPressChange: o,
    onPressStart: l,
    onPressEnd: d,
    onPressUp: y,
    isDisabled: $,
    isPressed: E,
    preventFocusOnPress: b,
    shouldCancelOnPointerExit: k,
    allowTextSelectionOnPress: v,
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    ref: w,
    ...Z
  } = Pe(n), [ee, A] = pe(!1), K = de({
    isPressed: !1,
    ignoreEmulatedMouseEvents: !1,
    didFirePressStart: !1,
    isTriggeringEvent: !1,
    activePointerId: null,
    target: null,
    isOverTarget: !1,
    pointerType: null,
    disposables: []
  }), { addGlobalListener: S, removeAllGlobalListeners: C } = oe(), h = I((e, a) => {
    let g = K.current;
    if ($ || g.didFirePressStart) return !1;
    let r = !0;
    if (g.isTriggeringEvent = !0, l) {
      let u = new Y("pressstart", a, e);
      l(u), r = u.shouldStopPropagation;
    }
    return o && o(!0), g.isTriggeringEvent = !1, g.didFirePressStart = !0, A(!0), r;
  }), P = I((e, a, g = !0) => {
    let r = K.current;
    if (!r.didFirePressStart) return !1;
    r.didFirePressStart = !1, r.isTriggeringEvent = !0;
    let u = !0;
    if (d) {
      let t = new Y("pressend", a, e);
      d(t), u = t.shouldStopPropagation;
    }
    if (o && o(!1), A(!1), i && g && !$) {
      let t = new Y("press", a, e);
      i(t), u && (u = t.shouldStopPropagation);
    }
    return r.isTriggeringEvent = !1, u;
  }), x = I((e, a) => {
    let g = K.current;
    if ($) return !1;
    if (y) {
      g.isTriggeringEvent = !0;
      let r = new Y("pressup", a, e);
      return y(r), g.isTriggeringEvent = !1, r.shouldStopPropagation;
    }
    return !0;
  }), T = I((e) => {
    let a = K.current;
    if (a.isPressed && a.target) {
      a.didFirePressStart && a.pointerType != null && P(M(a.target, e), a.pointerType, !1), a.isPressed = !1, a.isOverTarget = !1, a.activePointerId = null, a.pointerType = null, C(), v || U(a.target);
      for (let g of a.disposables) g();
      a.disposables = [];
    }
  }), L = I((e) => {
    k && T(e);
  }), te = ge(() => {
    let e = K.current, a = {
      onKeyDown(r) {
        if (F(r.nativeEvent, r.currentTarget) && p(r.currentTarget, c(r.nativeEvent))) {
          var u;
          q(c(r.nativeEvent), r.key) && r.preventDefault();
          let t = !0;
          if (!e.isPressed && !r.repeat) {
            e.target = r.currentTarget, e.isPressed = !0, e.pointerType = "keyboard", t = h(r, "keyboard");
            let s = r.currentTarget, f = (O) => {
              F(O, s) && !O.repeat && p(s, c(O)) && e.target && x(M(e.target, O), "keyboard");
            };
            S(D(r.currentTarget), "keyup", ae(f, g), !0);
          }
          t && r.stopPropagation(), r.metaKey && fe() && ((u = e.metaKeyEvents) === null || u === void 0 || u.set(r.key, r.nativeEvent));
        } else r.key === "Meta" && (e.metaKeyEvents = /* @__PURE__ */ new Map());
      },
      onClick(r) {
        if (!(r && !p(r.currentTarget, c(r.nativeEvent))) && r && r.button === 0 && !e.isTriggeringEvent && !V.isOpening) {
          let u = !0;
          if ($ && r.preventDefault(), !e.ignoreEmulatedMouseEvents && !e.isPressed && (e.pointerType === "virtual" || W(r.nativeEvent))) {
            let t = h(r, "virtual"), s = x(r, "virtual"), f = P(r, "virtual");
            u = t && s && f;
          } else if (e.isPressed && e.pointerType !== "keyboard") {
            let t = e.pointerType || r.nativeEvent.pointerType || "virtual";
            u = P(M(r.currentTarget, r), t, !0), e.isOverTarget = !1, T(r);
          }
          e.ignoreEmulatedMouseEvents = !1, u && r.stopPropagation();
        }
      }
    }, g = (r) => {
      var u;
      if (e.isPressed && e.target && F(r, e.target)) {
        var t;
        q(c(r), r.key) && r.preventDefault();
        let f = c(r);
        P(M(e.target, r), "keyboard", p(e.target, c(r))), C(), r.key !== "Enter" && _(e.target) && p(e.target, f) && !r[N] && (r[N] = !0, V(e.target, r, !1)), e.isPressed = !1, (t = e.metaKeyEvents) === null || t === void 0 || t.delete(r.key);
      } else if (r.key === "Meta" && (!((u = e.metaKeyEvents) === null || u === void 0) && u.size)) {
        var s;
        let f = e.metaKeyEvents;
        e.metaKeyEvents = void 0;
        for (let O of f.values()) (s = e.target) === null || s === void 0 || s.dispatchEvent(new KeyboardEvent("keyup", O));
      }
    };
    if (typeof PointerEvent < "u") {
      a.onPointerDown = (t) => {
        if (t.button !== 0 || !p(t.currentTarget, c(t.nativeEvent))) return;
        if (ue(t.nativeEvent)) {
          e.pointerType = "virtual";
          return;
        }
        e.pointerType = t.pointerType;
        let s = !0;
        if (!e.isPressed) {
          e.isPressed = !0, e.isOverTarget = !0, e.activePointerId = t.pointerId, e.target = t.currentTarget, v || H(e.target), s = h(t, e.pointerType);
          let f = c(t.nativeEvent);
          "releasePointerCapture" in f && f.releasePointerCapture(t.pointerId), S(D(t.currentTarget), "pointerup", r, !1), S(D(t.currentTarget), "pointercancel", u, !1);
        }
        s && t.stopPropagation();
      }, a.onMouseDown = (t) => {
        if (p(t.currentTarget, c(t.nativeEvent)) && t.button === 0) {
          if (b) {
            let s = G(t.target);
            s && e.disposables.push(s);
          }
          t.stopPropagation();
        }
      }, a.onPointerUp = (t) => {
        !p(t.currentTarget, c(t.nativeEvent)) || e.pointerType === "virtual" || t.button === 0 && x(t, e.pointerType || t.pointerType);
      }, a.onPointerEnter = (t) => {
        t.pointerId === e.activePointerId && e.target && !e.isOverTarget && e.pointerType != null && (e.isOverTarget = !0, h(M(e.target, t), e.pointerType));
      }, a.onPointerLeave = (t) => {
        t.pointerId === e.activePointerId && e.target && e.isOverTarget && e.pointerType != null && (e.isOverTarget = !1, P(M(e.target, t), e.pointerType, !1), L(t));
      };
      let r = (t) => {
        if (t.pointerId === e.activePointerId && e.isPressed && t.button === 0 && e.target) {
          if (p(e.target, c(t)) && e.pointerType != null) {
            let s = !1, f = setTimeout(() => {
              e.isPressed && e.target instanceof HTMLElement && (s ? T(t) : (se(e.target), e.target.click()));
            }, 80);
            S(t.currentTarget, "click", () => s = !0, !0), e.disposables.push(() => clearTimeout(f));
          } else T(t);
          e.isOverTarget = !1;
        }
      }, u = (t) => {
        T(t);
      };
      a.onDragStart = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && T(t);
      };
    } else {
      a.onMouseDown = (t) => {
        if (t.button !== 0 || !p(t.currentTarget, c(t.nativeEvent))) return;
        if (e.ignoreEmulatedMouseEvents) {
          t.stopPropagation();
          return;
        }
        if (e.isPressed = !0, e.isOverTarget = !0, e.target = t.currentTarget, e.pointerType = W(t.nativeEvent) ? "virtual" : "mouse", ce(() => h(t, e.pointerType)) && t.stopPropagation(), b) {
          let f = G(t.target);
          f && e.disposables.push(f);
        }
        S(D(t.currentTarget), "mouseup", r, !1);
      }, a.onMouseEnter = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let s = !0;
        e.isPressed && !e.ignoreEmulatedMouseEvents && e.pointerType != null && (e.isOverTarget = !0, s = h(t, e.pointerType)), s && t.stopPropagation();
      }, a.onMouseLeave = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let s = !0;
        e.isPressed && !e.ignoreEmulatedMouseEvents && e.pointerType != null && (e.isOverTarget = !1, s = P(t, e.pointerType, !1), L(t)), s && t.stopPropagation();
      }, a.onMouseUp = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && !e.ignoreEmulatedMouseEvents && t.button === 0 && x(t, e.pointerType || "mouse");
      };
      let r = (t) => {
        if (t.button === 0) {
          if (e.ignoreEmulatedMouseEvents) {
            e.ignoreEmulatedMouseEvents = !1;
            return;
          }
          e.target && e.target.contains(t.target) && e.pointerType != null || T(t), e.isOverTarget = !1;
        }
      };
      a.onTouchStart = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let s = ye(t.nativeEvent);
        if (!s) return;
        e.activePointerId = s.identifier, e.ignoreEmulatedMouseEvents = !0, e.isOverTarget = !0, e.isPressed = !0, e.target = t.currentTarget, e.pointerType = "touch", v || H(e.target), h(m(e.target, t), e.pointerType) && t.stopPropagation(), S(R(t.currentTarget), "scroll", u, !0);
      }, a.onTouchMove = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        if (!e.isPressed) {
          t.stopPropagation();
          return;
        }
        let s = z(t.nativeEvent, e.activePointerId), f = !0;
        s && j(s, t.currentTarget) ? !e.isOverTarget && e.pointerType != null && (e.isOverTarget = !0, f = h(m(e.target, t), e.pointerType)) : e.isOverTarget && e.pointerType != null && (e.isOverTarget = !1, f = P(m(e.target, t), e.pointerType, !1), L(m(e.target, t))), f && t.stopPropagation();
      }, a.onTouchEnd = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        if (!e.isPressed) {
          t.stopPropagation();
          return;
        }
        let s = z(t.nativeEvent, e.activePointerId), f = !0;
        s && j(s, t.currentTarget) && e.pointerType != null ? (x(m(e.target, t), e.pointerType), f = P(m(e.target, t), e.pointerType)) : e.isOverTarget && e.pointerType != null && (f = P(m(e.target, t), e.pointerType, !1)), f && t.stopPropagation(), e.isPressed = !1, e.activePointerId = null, e.isOverTarget = !1, e.ignoreEmulatedMouseEvents = !0, e.target && !v && U(e.target), C();
      }, a.onTouchCancel = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && (t.stopPropagation(), e.isPressed && T(m(e.target, t)));
      };
      let u = (t) => {
        e.isPressed && p(c(t), e.target) && T({
          currentTarget: e.target,
          shiftKey: !1,
          ctrlKey: !1,
          metaKey: !1,
          altKey: !1
        });
      };
      a.onDragStart = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && T(t);
      };
    }
    return a;
  }, [
    S,
    $,
    b,
    C,
    v,
    T,
    L,
    P,
    h,
    x
  ]);
  return ve(() => {
    let e = K.current;
    return () => {
      var a;
      v || U((a = e.target) !== null && a !== void 0 ? a : void 0);
      for (let g of e.disposables) g();
      e.disposables = [];
    };
  }, [
    v
  ]), {
    isPressed: E || ee,
    pressProps: J(Z, te)
  };
}
function _(n) {
  return n.tagName === "A" && n.hasAttribute("href");
}
function F(n, i) {
  const { key: o, code: l } = n, d = i, y = d.getAttribute("role");
  return (o === "Enter" || o === " " || o === "Spacebar" || l === "Space") && !(d instanceof R(d).HTMLInputElement && !Q(d, o) || d instanceof R(d).HTMLTextAreaElement || d.isContentEditable) && // Links should only trigger with Enter key
  !((y === "link" || !y && _(d)) && o !== "Enter");
}
function ye(n) {
  const { targetTouches: i } = n;
  return i.length > 0 ? i[0] : null;
}
function z(n, i) {
  const o = n.changedTouches;
  for (let l = 0; l < o.length; l++) {
    const d = o[l];
    if (d.identifier === i) return d;
  }
  return null;
}
function m(n, i) {
  let o = 0, l = 0;
  return i.targetTouches && i.targetTouches.length === 1 && (o = i.targetTouches[0].clientX, l = i.targetTouches[0].clientY), {
    currentTarget: n,
    shiftKey: i.shiftKey,
    ctrlKey: i.ctrlKey,
    metaKey: i.metaKey,
    altKey: i.altKey,
    clientX: o,
    clientY: l
  };
}
function M(n, i) {
  let o = i.clientX, l = i.clientY;
  return {
    currentTarget: n,
    shiftKey: i.shiftKey,
    ctrlKey: i.ctrlKey,
    metaKey: i.metaKey,
    altKey: i.altKey,
    clientX: o,
    clientY: l
  };
}
function $e(n) {
  let i = 0, o = 0;
  return n.width !== void 0 ? i = n.width / 2 : n.radiusX !== void 0 && (i = n.radiusX), n.height !== void 0 ? o = n.height / 2 : n.radiusY !== void 0 && (o = n.radiusY), {
    top: n.clientY - o,
    right: n.clientX + i,
    bottom: n.clientY + o,
    left: n.clientX - i
  };
}
function he(n, i) {
  return !(n.left > i.right || i.left > n.right || n.top > i.bottom || i.top > n.bottom);
}
function j(n, i) {
  let o = i.getBoundingClientRect(), l = $e(n);
  return he(o, l);
}
function me(n) {
  return n instanceof HTMLInputElement ? !1 : n instanceof HTMLButtonElement ? n.type !== "submit" && n.type !== "reset" : !_(n);
}
function q(n, i) {
  return n instanceof HTMLInputElement ? !Q(n, i) : me(n);
}
const Ee = /* @__PURE__ */ new Set([
  "checkbox",
  "radio",
  "range",
  "color",
  "file",
  "image",
  "button",
  "submit",
  "reset"
]);
function Q(n, i) {
  return n.type === "checkbox" || n.type === "radio" ? i === " " : Ee.has(n.type);
}
export {
  He as usePress
};
