import p from "./ui-components-library550.js";
import { Time as h } from "./ui-components-library296.js";
import { toCalendar as b, toCalendarDate as x, toCalendarDateTime as y } from "./ui-components-library300.js";
import { now as w, getLocalTimeZone as D } from "./ui-components-library80.js";
import { DateFormatter as T } from "./ui-components-library312.js";
import { LocalizedStringDictionary as g } from "./ui-components-library395.js";
import { LocalizedStringFormatter as I } from "./ui-components-library396.js";
import { useState as O } from "react";
function F(e) {
  return e && e.__esModule ? e.default : e;
}
const L = new g(F(p));
function Z() {
  return typeof navigator < "u" && (navigator.language || navigator.userLanguage) || "en-US";
}
function j(e, t, n, r, a) {
  let i = e != null && n != null && e.compare(n) > 0, o = e != null && t != null && e.compare(t) < 0, l = e != null && (r == null ? void 0 : r(e)) || !1, f = i || o || l, d = [];
  if (f) {
    let u = Z(), c = g.getGlobalDictionaryForPackage("@react-stately/datepicker") || L, s = new I(u, c), m = new T(u, E({}, a)), $ = m.resolvedOptions().timeZone;
    o && t != null && d.push(s.format("rangeUnderflow", {
      minValue: m.format(t.toDate($))
    })), i && n != null && d.push(s.format("rangeOverflow", {
      maxValue: m.format(n.toDate($))
    })), l && d.push(s.format("unavailableDate"));
  }
  return {
    isInvalid: f,
    validationErrors: d,
    validationDetails: {
      badInput: l,
      customError: !1,
      patternMismatch: !1,
      rangeOverflow: i,
      rangeUnderflow: o,
      stepMismatch: !1,
      tooLong: !1,
      tooShort: !1,
      typeMismatch: !1,
      valueMissing: !1,
      valid: !f
    }
  };
}
const _ = {
  year: "numeric",
  month: "numeric",
  day: "numeric",
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, v = {
  year: "numeric",
  month: "2-digit",
  day: "2-digit",
  hour: "2-digit",
  minute: "2-digit",
  second: "2-digit"
};
function E(e, t) {
  e = {
    ...t.shouldForceLeadingZeros ? v : _,
    ...e
  };
  let r = t.granularity || "minute", a = Object.keys(e);
  var i;
  let o = a.indexOf((i = t.maxGranularity) !== null && i !== void 0 ? i : "year");
  o < 0 && (o = 0);
  let l = a.indexOf(r);
  if (l < 0 && (l = 2), o > l) throw new Error("maxGranularity must be greater than granularity");
  let f = a.slice(o, l + 1).reduce((u, c) => (u[c] = e[c], u), {});
  return t.hourCycle != null && (f.hour12 = t.hourCycle === 12), f.timeZone = t.timeZone || "UTC", (r === "hour" || r === "minute" || r === "second") && t.timeZone && !t.hideTimeZone && (f.timeZoneName = "short"), t.showEra && o === 0 && (f.era = "short"), f;
}
function A(e) {
  return e && "hour" in e ? e : new h();
}
function S(e, t) {
  if (e === null) return null;
  if (e)
    return b(e, t);
}
function R(e, t, n, r) {
  if (e) return S(e, n);
  let a = b(w(r ?? D()).set({
    hour: 0,
    minute: 0,
    second: 0,
    millisecond: 0
  }), n);
  return t === "year" || t === "month" || t === "day" ? x(a) : r ? a : y(a);
}
function W(e, t) {
  let n = e && "timeZone" in e ? e.timeZone : void 0, r = e && "minute" in e ? "minute" : "day";
  if (e && t && !(t in e)) throw new Error("Invalid granularity " + t + " for value " + e.toString());
  let [a, i] = O([
    r,
    n
  ]);
  e && (a[0] !== r || a[1] !== n) && i([
    r,
    n
  ]), t || (t = e ? r : a[0]);
  let o = e ? n : a[1];
  return [
    t,
    o
  ];
}
export {
  S as convertValue,
  R as createPlaceholderDate,
  E as getFormatOptions,
  A as getPlaceholderTime,
  j as getValidationResult,
  W as useDefaultProps
};
