import { useVisibleRangeDescription as c, useSelectedDateDescription as D, hookData as v } from "./ui-components-library381.js";
import P from "./ui-components-library383.js";
import { announce as f } from "./ui-components-library120.js";
import { useSlotId as F } from "./ui-components-library122.js";
import { mergeProps as R } from "./ui-components-library123.js";
import { filterDOMProps as y } from "./ui-components-library124.js";
import { useLabels as B } from "./ui-components-library152.js";
import { useUpdateEffect as n } from "./ui-components-library281.js";
import { useLocalizedStringFormatter as I } from "./ui-components-library156.js";
import { useState as u } from "react";
function M(e) {
  return e && e.__esModule ? e.default : e;
}
function z(e, a) {
  let o = I(M(P), "@react-aria/calendar"), $ = y(e), m = c(a.visibleRange.start, a.visibleRange.end, a.timeZone, !1), r = c(a.visibleRange.start, a.visibleRange.end, a.timeZone, !0);
  n(() => {
    a.isFocused || f(r);
  }, [
    r
  ]);
  let i = D(a);
  n(() => {
    i && f(i, "polite", 4e3);
  }, [
    i
  ]);
  let l = F([
    !!e.errorMessage,
    e.isInvalid,
    e.validationState
  ]);
  v.set(a, {
    ariaLabel: e["aria-label"],
    ariaLabelledBy: e["aria-labelledby"],
    errorMessageId: l,
    selectedDateDescription: i
  });
  let [p, s] = u(!1), t = e.isDisabled || a.isNextVisibleRangeInvalid();
  t && p && (s(!1), a.setFocused(!0));
  let [x, d] = u(!1), b = e.isDisabled || a.isPreviousVisibleRangeInvalid();
  b && x && (d(!1), a.setFocused(!0));
  let g = B({
    id: e.id,
    "aria-label": [
      e["aria-label"],
      r
    ].filter(Boolean).join(", "),
    "aria-labelledby": e["aria-labelledby"]
  });
  return {
    calendarProps: R($, g, {
      role: "application",
      "aria-describedby": e["aria-describedby"] || void 0
    }),
    nextButtonProps: {
      onPress: () => a.focusNextPage(),
      "aria-label": o.format("next"),
      isDisabled: t,
      onFocusChange: s
    },
    prevButtonProps: {
      onPress: () => a.focusPreviousPage(),
      "aria-label": o.format("previous"),
      isDisabled: b,
      onFocusChange: d
    },
    errorMessageProps: {
      id: l
    },
    title: m
  };
}
export {
  z as useCalendarBase
};
