import { setInteractionModality as m } from "./ui-components-library340.js";
import { useEffect as f } from "react";
import { useLayoutEffect as $ } from "./ui-components-library142.js";
import { useEffectEvent as v } from "./ui-components-library289.js";
function V(t, i, e) {
  let { validationBehavior: s, focus: u } = t;
  $(() => {
    if (s === "native" && (e != null && e.current) && !e.current.disabled) {
      let a = i.realtimeValidation.isInvalid ? i.realtimeValidation.validationErrors.join(" ") || "Invalid value." : "";
      e.current.setCustomValidity(a), e.current.hasAttribute("title") || (e.current.title = ""), i.realtimeValidation.isInvalid || i.updateValidation(g(e.current));
    }
  });
  let o = v(() => {
    i.resetValidation();
  }), l = v((a) => {
    var n;
    i.displayValidation.isInvalid || i.commitValidation();
    let c = e == null || (n = e.current) === null || n === void 0 ? void 0 : n.form;
    if (!a.defaultPrevented && e && c && b(c) === e.current) {
      var d;
      u ? u() : (d = e.current) === null || d === void 0 || d.focus(), m("keyboard");
    }
    a.preventDefault();
  }), r = v(() => {
    i.commitValidation();
  });
  f(() => {
    let a = e == null ? void 0 : e.current;
    if (!a) return;
    let n = a.form;
    return a.addEventListener("invalid", l), a.addEventListener("change", r), n == null || n.addEventListener("reset", o), () => {
      a.removeEventListener("invalid", l), a.removeEventListener("change", r), n == null || n.removeEventListener("reset", o);
    };
  }, [
    e,
    l,
    r,
    o,
    s
  ]);
}
function p(t) {
  let i = t.validity;
  return {
    badInput: i.badInput,
    customError: i.customError,
    patternMismatch: i.patternMismatch,
    rangeOverflow: i.rangeOverflow,
    rangeUnderflow: i.rangeUnderflow,
    stepMismatch: i.stepMismatch,
    tooLong: i.tooLong,
    tooShort: i.tooShort,
    typeMismatch: i.typeMismatch,
    valueMissing: i.valueMissing,
    valid: i.valid
  };
}
function g(t) {
  return {
    isInvalid: !t.validity.valid,
    validationDetails: p(t),
    validationErrors: t.validationMessage ? [
      t.validationMessage
    ] : []
  };
}
function b(t) {
  for (let i = 0; i < t.elements.length; i++) {
    let e = t.elements[i];
    if (!e.validity.valid) return e;
  }
  return null;
}
export {
  V as useFormValidation
};
