import { listMap as m } from "./ui-components-library398.js";
import { useId as g } from "./ui-components-library122.js";
import { mergeProps as h } from "./ui-components-library123.js";
import { filterDOMProps as y } from "./ui-components-library124.js";
import { useHighlightSelectionDescription as v } from "./ui-components-library399.js";
import { useGridSelectionAnnouncement as x } from "./ui-components-library400.js";
import { useHasTabbableChild as k } from "./ui-components-library362.js";
import { useSelectableList as A } from "./ui-components-library401.js";
function I(i, e, a) {
  let { isVirtualized: l, keyboardDelegate: c, layoutDelegate: s, onAction: r, disallowTypeAhead: b, linkBehavior: t = "action", keyboardNavigationBehavior: n = "arrow" } = i;
  !i["aria-label"] && !i["aria-labelledby"] && console.warn("An aria-label or aria-labelledby prop is required for accessibility.");
  let { listProps: u } = A({
    selectionManager: e.selectionManager,
    collection: e.collection,
    disabledKeys: e.disabledKeys,
    ref: a,
    keyboardDelegate: c,
    layoutDelegate: s,
    isVirtualized: l,
    selectOnFocus: e.selectionManager.selectionBehavior === "replace",
    shouldFocusWrap: i.shouldFocusWrap,
    linkBehavior: t,
    disallowTypeAhead: b,
    autoFocus: i.autoFocus
  }), d = g(i.id);
  m.set(e, {
    id: d,
    onAction: r,
    linkBehavior: t,
    keyboardNavigationBehavior: n
  });
  let f = v({
    selectionManager: e.selectionManager,
    hasItemActions: !!r
  }), $ = k(a, {
    isDisabled: e.collection.size !== 0
  }), p = y(i, {
    labelable: !0
  }), o = h(
    p,
    {
      role: "grid",
      id: d,
      "aria-multiselectable": e.selectionManager.selectionMode === "multiple" ? "true" : void 0
    },
    // If collection is empty, make sure the grid is tabbable unless there is a child tabbable element.
    e.collection.size === 0 ? {
      tabIndex: $ ? -1 : 0
    } : u,
    f
  );
  return l && (o["aria-rowcount"] = e.collection.size, o["aria-colcount"] = 1), x({}, e), {
    gridProps: o
  };
}
export {
  I as useGridList
};
