import { getCollectionId as R, isNonContiguousSelectionModifier as N } from "./ui-components-library422.js";
import { usePress as j } from "./ui-components-library347.js";
import { useLongPress as q } from "./ui-components-library351.js";
import { focusSafely as z } from "./ui-components-library175.js";
import { useId as G } from "./ui-components-library122.js";
import { mergeProps as K } from "./ui-components-library123.js";
import { useRouter as H, openLink as J } from "./ui-components-library277.js";
import { isCtrlKeyPressed as Q } from "./ui-components-library295.js";
import { moveVirtualFocus as W } from "./ui-components-library363.js";
import { useEffect as X, useRef as k } from "react";
function le(r) {
  let { id: $, selectionManager: o, key: t, ref: i, shouldSelectOnPressUp: O, shouldUseVirtualFocus: l, focus: T, isDisabled: c, onAction: g, allowsDifferentPressOrigin: C, linkBehavior: p = "action" } = r, D = H();
  $ = G($);
  let a = (e) => {
    if (e.pointerType === "keyboard" && N(e)) o.toggleSelection(t);
    else {
      if (o.selectionMode === "none") return;
      if (o.isLink(t)) {
        if (p === "selection" && i.current) {
          let y = o.getItemProps(t);
          D.open(i.current, e, y.href, y.routerOptions), o.setSelectedKeys(o.selectedKeys);
          return;
        } else if (p === "override" || p === "none") return;
      }
      o.selectionMode === "single" ? o.isSelected(t) && !o.disallowEmptySelection ? o.toggleSelection(t) : o.replaceSelection(t) : e && e.shiftKey ? o.extendSelection(t) : o.selectionBehavior === "toggle" || e && (Q(e) || e.pointerType === "touch" || e.pointerType === "virtual") ? o.toggleSelection(t) : o.replaceSelection(t);
    }
  };
  X(() => {
    t === o.focusedKey && o.isFocused && (l ? W(i.current) : T ? T() : document.activeElement !== i.current && i.current && z(i.current));
  }, [
    i,
    t,
    o.focusedKey,
    o.childFocusStrategy,
    o.isFocused,
    l
  ]), c = c || o.isDisabled(t);
  let u = {};
  !l && !c ? u = {
    tabIndex: t === o.focusedKey ? 0 : -1,
    onFocus(e) {
      e.target === i.current && o.setFocusedKey(t);
    }
  } : c && (u.onMouseDown = (e) => {
    e.preventDefault();
  });
  let L = o.isLink(t) && p === "override", F = o.isLink(t) && p !== "selection" && p !== "none", s = !c && o.canSelectItem(t) && !L, S = (g || F) && !c, f = S && (o.selectionBehavior === "replace" ? !s : !s || o.isEmpty), v = S && s && o.selectionBehavior === "replace", d = f || v, b = k(null), m = d && s, h = k(!1), x = k(!1), P = (e) => {
    if (g && g(), F && i.current) {
      let y = o.getItemProps(t);
      D.open(i.current, e, y.href, y.routerOptions);
    }
  }, n = {};
  O ? (n.onPressStart = (e) => {
    b.current = e.pointerType, h.current = m, e.pointerType === "keyboard" && (!d || A()) && a(e);
  }, C ? (n.onPressUp = f ? void 0 : (e) => {
    e.pointerType === "mouse" && s && a(e);
  }, n.onPress = f ? P : (e) => {
    e.pointerType !== "keyboard" && e.pointerType !== "mouse" && s && a(e);
  }) : n.onPress = (e) => {
    if (f || v && e.pointerType !== "mouse") {
      if (e.pointerType === "keyboard" && !w()) return;
      P(e);
    } else e.pointerType !== "keyboard" && s && a(e);
  }) : (n.onPressStart = (e) => {
    b.current = e.pointerType, h.current = m, x.current = f, s && (e.pointerType === "mouse" && !f || e.pointerType === "keyboard" && (!S || A())) && a(e);
  }, n.onPress = (e) => {
    (e.pointerType === "touch" || e.pointerType === "pen" || e.pointerType === "virtual" || e.pointerType === "keyboard" && d && w() || e.pointerType === "mouse" && x.current) && (d ? P(e) : s && a(e));
  }), u["data-collection"] = R(o.collection), u["data-key"] = t, n.preventFocusOnPress = l, l && (n = K(n, {
    onPressStart(e) {
      e.pointerType !== "touch" && (o.setFocused(!0), o.setFocusedKey(t));
    },
    onPress(e) {
      e.pointerType === "touch" && (o.setFocused(!0), o.setFocusedKey(t));
    }
  }));
  let { pressProps: E, isPressed: I } = j(n), B = v ? (e) => {
    b.current === "mouse" && (e.stopPropagation(), e.preventDefault(), P(e));
  } : void 0, { longPressProps: M } = q({
    isDisabled: !m,
    onLongPress(e) {
      e.pointerType === "touch" && (a(e), o.setSelectionBehavior("toggle"));
    }
  }), U = (e) => {
    b.current === "touch" && h.current && e.preventDefault();
  }, V = o.isLink(t) ? (e) => {
    J.isOpening || e.preventDefault();
  } : void 0;
  return {
    itemProps: K(
      u,
      s || f || l ? E : {},
      m ? M : {},
      {
        onDoubleClick: B,
        onDragStartCapture: U,
        onClick: V,
        id: $
      },
      // Prevent DOM focus from moving on mouse down when using virtual focus
      l ? {
        onMouseDown: (e) => e.preventDefault()
      } : void 0
    ),
    isPressed: I,
    isSelected: o.isSelected(t),
    isFocused: o.isFocused && o.focusedKey === t,
    isDisabled: c,
    allowsSelection: s,
    hasAction: d
  };
}
function w() {
  let r = window.event;
  return (r == null ? void 0 : r.key) === "Enter";
}
function A() {
  let r = window.event;
  return (r == null ? void 0 : r.key) === " " || (r == null ? void 0 : r.code) === "Space";
}
export {
  le as useSelectableItem
};
