import { useContextProps as h, useRenderProps as B } from "./ui-components-library119.js";
import { ProgressBarContext as D } from "./ui-components-library94.js";
import { announce as P } from "./ui-components-library120.js";
import { createHideableComponent as F } from "./ui-components-library121.js";
import { useId as x } from "./ui-components-library122.js";
import { mergeProps as H } from "./ui-components-library123.js";
import { filterDOMProps as E } from "./ui-components-library124.js";
import v, { createContext as V, useRef as R, useEffect as p } from "react";
import { useButton as w } from "./ui-components-library125.js";
import { useFocusRing as I } from "./ui-components-library126.js";
import { useHover as M } from "./ui-components-library127.js";
const N = /* @__PURE__ */ new Set([
  "form",
  "formAction",
  "formEncType",
  "formMethod",
  "formNoValidate",
  "formTarget",
  "name",
  "value"
]), T = /* @__PURE__ */ V({}), J = /* @__PURE__ */ F(function(e, n) {
  [e, n] = h(e, n, T), e = A(e);
  let u = e, { isPending: d } = u, { buttonProps: a, isPressed: g } = w(e, n), { focusProps: y, isFocused: s, isFocusVisible: c } = I(e), { hoverProps: C, isHovered: l } = M({
    ...e,
    isDisabled: e.isDisabled || d
  }), b = {
    isHovered: l,
    isPressed: (u.isPressed || g) && !d,
    isFocused: s,
    isFocusVisible: c,
    isDisabled: e.isDisabled || !1,
    isPending: d ?? !1
  }, $ = B({
    ...e,
    values: b,
    defaultClassName: "react-aria-Button"
  }), r = x(a.id), o = x(), i = a["aria-labelledby"];
  d && (i ? i = `${i} ${o}` : a["aria-label"] && (i = `${r} ${o}`));
  let f = R(d);
  return p(() => {
    let m = {
      "aria-labelledby": i || r
    };
    !f.current && s && d ? P(m, "assertive") : f.current && s && !d && P(m, "assertive"), f.current = d;
  }, [
    d,
    s,
    i,
    r
  ]), /* @__PURE__ */ v.createElement("button", {
    ...E(e, {
      propNames: N
    }),
    ...H(a, y, C),
    ...$,
    type: a.type === "submit" && d ? "button" : a.type,
    id: r,
    ref: n,
    "aria-labelledby": i,
    slot: e.slot || void 0,
    "aria-disabled": d ? "true" : a["aria-disabled"],
    "data-disabled": e.isDisabled || void 0,
    "data-pressed": b.isPressed || void 0,
    "data-hovered": l || void 0,
    "data-focused": s || void 0,
    "data-pending": d || void 0,
    "data-focus-visible": c || void 0
  }, /* @__PURE__ */ v.createElement(D.Provider, {
    value: {
      id: o
    }
  }, $.children));
});
function A(t) {
  return t.isPending && (t.onPress = void 0, t.onPressStart = void 0, t.onPressEnd = void 0, t.onPressChange = void 0, t.onPressUp = void 0, t.onKeyDown = void 0, t.onKeyUp = void 0, t.onClick = void 0, t.href = void 0), t;
}
export {
  J as Button,
  T as ButtonContext
};
