import { ButtonContext as W } from "./ui-components-library42.js";
import { useContextProps as R, useSlottedContext as _, useSlot as H, removeDataAttributes as K, useRenderProps as I, Provider as N } from "./ui-components-library119.js";
import { FieldErrorContext as k } from "./ui-components-library48.js";
import { FormContext as A } from "./ui-components-library136.js";
import j from "./ui-components-library151.js";
import { LabelContext as G } from "./ui-components-library46.js";
import { ListBoxContext as J, ListStateContext as Q } from "./ui-components-library162.js";
import { OverlayTriggerStateContext as U } from "./ui-components-library75.js";
import { PopoverContext as X } from "./ui-components-library76.js";
import { TextContext as F } from "./ui-components-library64.js";
import { CollectionBuilder as Y } from "./ui-components-library93.js";
import { filterDOMProps as D } from "./ui-components-library124.js";
import { useResizeObserver as Z } from "./ui-components-library147.js";
import c, { forwardRef as B, createContext as v, useMemo as V, useRef as S, useState as ee, useCallback as te, useContext as ae } from "react";
import { useSelectState as le } from "./ui-components-library187.js";
import { useFocusRing as ie } from "./ui-components-library126.js";
import { useSelect as de } from "./ui-components-library188.js";
import { HiddenSelect as oe } from "./ui-components-library189.js";
import { useLocalizedStringFormatter as se } from "./ui-components-library156.js";
function re(e) {
  return e && e.__esModule ? e.default : e;
}
const x = /* @__PURE__ */ v(null), O = /* @__PURE__ */ v(null), Be = /* @__PURE__ */ B(function(d, r) {
  [d, r] = R(d, r, x);
  let { children: o, isDisabled: s = !1, isInvalid: a = !1, isRequired: n = !1 } = d, t = V(() => typeof o == "function" ? o({
    isOpen: !1,
    isDisabled: s,
    isInvalid: a,
    isRequired: n,
    isFocused: !1,
    isFocusVisible: !1,
    defaultChildren: null
  }) : o, [
    o,
    s,
    a,
    n
  ]);
  return /* @__PURE__ */ c.createElement(Y, {
    content: t
  }, (l) => /* @__PURE__ */ c.createElement(ne, {
    props: d,
    collection: l,
    selectRef: r
  }));
});
function ne({ props: e, selectRef: d, collection: r }) {
  let { validationBehavior: o } = _(A) || {};
  var s, a;
  let n = (a = (s = e.validationBehavior) !== null && s !== void 0 ? s : o) !== null && a !== void 0 ? a : "native", t = le({
    ...e,
    collection: r,
    children: void 0,
    validationBehavior: n
  }), { isFocusVisible: l, focusProps: m } = ie({
    within: !0
  }), i = S(null), [u, f] = H(!e["aria-label"] && !e["aria-labelledby"]), { labelProps: $, triggerProps: p, valueProps: P, menuProps: h, descriptionProps: M, errorMessageProps: q, ...b } = de({
    ...K(e),
    label: f,
    validationBehavior: n
  }, t, i), [E, z] = ee(null), L = te(() => {
    i.current && z(i.current.offsetWidth + "px");
  }, [
    i
  ]);
  Z({
    ref: i,
    onResize: L
  });
  let T = V(() => ({
    isOpen: t.isOpen,
    isFocused: t.isFocused,
    isFocusVisible: l,
    isDisabled: e.isDisabled || !1,
    isInvalid: b.isInvalid || !1,
    isRequired: e.isRequired || !1
  }), [
    t.isOpen,
    t.isFocused,
    l,
    e.isDisabled,
    b.isInvalid,
    e.isRequired
  ]), w = I({
    ...e,
    values: T,
    defaultClassName: "react-aria-Select"
  }), g = D(e);
  delete g.id;
  let C = S(null);
  return /* @__PURE__ */ c.createElement(N, {
    values: [
      [
        x,
        e
      ],
      [
        O,
        t
      ],
      [
        y,
        P
      ],
      [
        G,
        {
          ...$,
          ref: u,
          elementType: "span"
        }
      ],
      [
        W,
        {
          ...p,
          ref: i,
          isPressed: t.isOpen
        }
      ],
      [
        U,
        t
      ],
      [
        X,
        {
          trigger: "Select",
          triggerRef: i,
          scrollRef: C,
          placement: "bottom start",
          style: {
            "--trigger-width": E
          },
          "aria-labelledby": h["aria-labelledby"]
        }
      ],
      [
        J,
        {
          ...h,
          ref: C
        }
      ],
      [
        Q,
        t
      ],
      [
        F,
        {
          slots: {
            description: M,
            errorMessage: q
          }
        }
      ],
      [
        k,
        b
      ]
    ]
  }, /* @__PURE__ */ c.createElement("div", {
    ...g,
    ...w,
    ...m,
    ref: d,
    slot: e.slot || void 0,
    "data-focused": t.isFocused || void 0,
    "data-focus-visible": l || void 0,
    "data-open": t.isOpen || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-invalid": b.isInvalid || void 0,
    "data-required": e.isRequired || void 0
  }), /* @__PURE__ */ c.createElement(oe, {
    autoComplete: e.autoComplete,
    state: t,
    triggerRef: i,
    label: f,
    name: e.name,
    isDisabled: e.isDisabled
  }));
}
const y = /* @__PURE__ */ v(null), Ve = /* @__PURE__ */ B(function(d, r) {
  var o, s;
  [d, r] = R(d, r, y);
  let a = ae(O), { placeholder: n } = _(x), t = a.selectedKey != null ? a.collection.getItem(a.selectedKey) : null, l = t == null ? void 0 : t.props.children;
  typeof l == "function" && (l = l({
    isHovered: !1,
    isPressed: !1,
    isSelected: !1,
    isFocused: !1,
    isFocusVisible: !1,
    isDisabled: !1,
    selectionMode: "single",
    selectionBehavior: "toggle"
  }));
  let m = se(re(j), "react-aria-components");
  var i, u, f;
  let $ = I({
    ...d,
    defaultChildren: (i = l ?? n) !== null && i !== void 0 ? i : m.format("selectPlaceholder"),
    defaultClassName: "react-aria-SelectValue",
    values: {
      selectedItem: (u = (o = a.selectedItem) === null || o === void 0 ? void 0 : o.value) !== null && u !== void 0 ? u : null,
      selectedText: (f = (s = a.selectedItem) === null || s === void 0 ? void 0 : s.textValue) !== null && f !== void 0 ? f : null,
      isPlaceholder: !t
    }
  }), p = D(d);
  return /* @__PURE__ */ c.createElement("span", {
    ref: r,
    ...p,
    ...$,
    "data-placeholder": !t || void 0
  }, /* @__PURE__ */ c.createElement(F.Provider, {
    value: void 0
  }, $.children));
});
export {
  Be as Select,
  x as SelectContext,
  O as SelectStateContext,
  Ve as SelectValue,
  y as SelectValueContext
};
