var r = {};
r = {
  dragItem: (e) => `Drag ${e.itemText}`,
  dragSelectedItems: (e, t) => `Drag ${t.plural(e.count, {
    one: () => `${t.number(e.count)} selected item`,
    other: () => `${t.number(e.count)} selected items`
  })}`,
  dragDescriptionKeyboard: "Press Enter to start dragging.",
  dragDescriptionKeyboardAlt: "Press Alt + Enter to start dragging.",
  dragDescriptionTouch: "Double tap to start dragging.",
  dragDescriptionVirtual: "Click to start dragging.",
  dragDescriptionLongPress: "Long press to start dragging.",
  dragSelectedKeyboard: (e, t) => `Press Enter to drag ${t.plural(e.count, {
    one: () => `${t.number(e.count)} selected item`,
    other: () => `${t.number(e.count)} selected items`
  })}.`,
  dragSelectedKeyboardAlt: (e, t) => `Press Alt + Enter to drag ${t.plural(e.count, {
    one: () => `${t.number(e.count)} selected item`,
    other: () => `${t.number(e.count)} selected items`
  })}.`,
  dragSelectedLongPress: (e, t) => `Long press to drag ${t.plural(e.count, {
    one: () => `${t.number(e.count)} selected item`,
    other: () => `${t.number(e.count)} selected items`
  })}.`,
  dragStartedKeyboard: "Started dragging. Press Tab to navigate to a drop target, then press Enter to drop, or press Escape to cancel.",
  dragStartedTouch: "Started dragging. Navigate to a drop target, then double tap to drop.",
  dragStartedVirtual: "Started dragging. Navigate to a drop target, then click or press Enter to drop.",
  endDragKeyboard: "Dragging. Press Enter to cancel drag.",
  endDragTouch: "Dragging. Double tap to cancel drag.",
  endDragVirtual: "Dragging. Click to cancel drag.",
  dropDescriptionKeyboard: "Press Enter to drop. Press Escape to cancel drag.",
  dropDescriptionTouch: "Double tap to drop.",
  dropDescriptionVirtual: "Click to drop.",
  dropCanceled: "Drop canceled.",
  dropComplete: "Drop complete.",
  dropIndicator: "drop indicator",
  dropOnRoot: "Drop on",
  dropOnItem: (e) => `Drop on ${e.itemText}`,
  insertBefore: (e) => `Insert before ${e.itemText}`,
  insertBetween: (e) => `Insert between ${e.beforeItemText} and ${e.afterItemText}`,
  insertAfter: (e) => `Insert after ${e.itemText}`
};
export {
  r as default
};
