var E = {};
E = {
  dragDescriptionKeyboard: "Enter キーを押してドラッグを開始してください。",
  dragDescriptionKeyboardAlt: "Alt+Enter キーを押してドラッグを開始します。",
  dragDescriptionLongPress: "長押ししてドラッグを開始します。",
  dragDescriptionTouch: "ダブルタップしてドラッグを開始します。",
  dragDescriptionVirtual: "クリックしてドラッグを開始します。",
  dragItem: (u) => `${u.itemText} をドラッグ`,
  dragSelectedItems: (u, C) => `${C.plural(u.count, {
    one: () => `${C.number(u.count)} 個の選択項目`,
    other: () => `${C.number(u.count)} 個の選択項目`
  })} をドラッグ`,
  dragSelectedKeyboard: (u, C) => `Enter キーを押して、${C.plural(u.count, {
    one: () => `${C.number(u.count)} 選択した項目`,
    other: () => `${C.number(u.count)} 選択した項目`
  })}をドラッグします。`,
  dragSelectedKeyboardAlt: (u, C) => `Alt+Enter キーを押して、${C.plural(u.count, {
    one: () => `${C.number(u.count)} 選択した項目`,
    other: () => `${C.number(u.count)} 選択した項目`
  })}をドラッグします。`,
  dragSelectedLongPress: (u, C) => `長押しして、${C.plural(u.count, {
    one: () => `${C.number(u.count)} 選択した項目`,
    other: () => `${C.number(u.count)} 選択した項目`
  })}をドラッグします。`,
  dragStartedKeyboard: "ドラッグを開始します。Tab キーを押してドロップターゲットにいどうし、Enter キーを押してドロップするか、Esc キーを押してキャンセルします。",
  dragStartedTouch: "ドラッグを開始しました。ドロップのターゲットに移動し、ダブルタップしてドロップします。",
  dragStartedVirtual: "ドラッグを開始しました。ドロップのターゲットに移動し、クリックまたは Enter キーを押してドロップします。",
  dropCanceled: "ドロップがキャンセルされました。",
  dropComplete: "ドロップが完了しました。",
  dropDescriptionKeyboard: "Enter キーを押してドロップします。Esc キーを押してドラッグをキャンセルします。",
  dropDescriptionTouch: "ダブルタップしてドロップします。",
  dropDescriptionVirtual: "クリックしてドロップします。",
  dropIndicator: "ドロップインジケーター",
  dropOnItem: (u) => `${u.itemText} にドロップ`,
  dropOnRoot: "ドロップ場所",
  endDragKeyboard: "ドラッグしています。Enter キーを押してドラッグをキャンセルします。",
  endDragTouch: "ドラッグしています。ダブルタップしてドラッグをキャンセルします。",
  endDragVirtual: "ドラッグしています。クリックしてドラッグをキャンセルします。",
  insertAfter: (u) => `${u.itemText} の後に挿入`,
  insertBefore: (u) => `${u.itemText} の前に挿入`,
  insertBetween: (u) => `${u.beforeItemText} と ${u.afterItemText} の間に挿入`
};
export {
  E as default
};
