import { useContextProps as m, useRenderProps as p } from "./ui-components-library119.js";
import H, { forwardRef as h, createContext as x } from "react";
import { useHover as P } from "./ui-components-library127.js";
import { useFocusRing as C } from "./ui-components-library126.js";
import { mergeProps as F } from "./ui-components-library123.js";
const g = /* @__PURE__ */ x({}), I = /* @__PURE__ */ h(function(e, i) {
  [e, i] = m(e, i, g);
  let { isDisabled: o, isInvalid: d, onHoverStart: f, onHoverChange: u, onHoverEnd: v, ...c } = e, { hoverProps: b, isHovered: s } = P({
    onHoverStart: f,
    onHoverChange: u,
    onHoverEnd: v,
    isDisabled: o
  }), { isFocused: n, isFocusVisible: t, focusProps: $ } = C({
    within: !0
  });
  o ?? (o = !!e["aria-disabled"] && e["aria-disabled"] !== "false"), d ?? (d = !!e["aria-invalid"] && e["aria-invalid"] !== "false");
  let l = p({
    ...e,
    values: {
      isHovered: s,
      isFocusWithin: n,
      isFocusVisible: t,
      isDisabled: o,
      isInvalid: d
    },
    defaultClassName: "react-aria-Group"
  });
  var a, r;
  return /* @__PURE__ */ H.createElement("div", {
    ...F(c, $, b),
    ...l,
    ref: i,
    role: (a = e.role) !== null && a !== void 0 ? a : "group",
    slot: (r = e.slot) !== null && r !== void 0 ? r : void 0,
    "data-focus-within": n || void 0,
    "data-hovered": s || void 0,
    "data-focus-visible": t || void 0,
    "data-disabled": o || void 0,
    "data-invalid": d || void 0
  }, l.children);
});
export {
  I as Group,
  g as GroupContext
};
