import { ButtonContext as n } from "./ui-components-library42.js";
import { useContextProps as b, useRenderProps as f, Provider as $, DEFAULT_SLOT as d } from "./ui-components-library119.js";
import { HeadingContext as x } from "./ui-components-library117.js";
import { filterDOMProps as m } from "./ui-components-library124.js";
import r, { forwardRef as u, createContext as i, useContext as g } from "react";
import { useDialog as y } from "./ui-components-library150.js";
const v = /* @__PURE__ */ i(null), P = /* @__PURE__ */ i(null), O = /* @__PURE__ */ u(function(e, l) {
  let s = e["aria-labelledby"];
  [e, l] = b(e, l, v);
  let { dialogProps: t, titleProps: c } = y({
    ...e,
    // Only pass aria-labelledby from props, not context.
    // Context is used as a fallback below.
    "aria-labelledby": s
  }, l), a = g(P);
  !t["aria-label"] && !t["aria-labelledby"] && (e["aria-labelledby"] ? t["aria-labelledby"] = e["aria-labelledby"] : console.warn('If a Dialog does not contain a <Heading slot="title">, it must have an aria-label or aria-labelledby attribute for accessibility.'));
  let o = f({
    defaultClassName: "react-aria-Dialog",
    className: e.className,
    style: e.style,
    children: e.children,
    values: {
      close: (a == null ? void 0 : a.close) || (() => {
      })
    }
  });
  return /* @__PURE__ */ r.createElement("section", {
    ...m(e),
    ...t,
    ...o,
    ref: l,
    slot: e.slot || void 0
  }, /* @__PURE__ */ r.createElement($, {
    values: [
      [
        x,
        {
          slots: {
            [d]: {},
            title: {
              ...c,
              level: 2
            }
          }
        }
      ],
      [
        n,
        {
          slots: {
            [d]: {},
            close: {
              onPress: () => a == null ? void 0 : a.close()
            }
          }
        }
      ]
    ]
  }, o.children));
});
export {
  O as Dialog,
  v as DialogContext,
  P as OverlayTriggerStateContext
};
