import { useContextProps as _, useRenderProps as A } from "./ui-components-library119.js";
import { OverlayArrowContext as H } from "./ui-components-library99.js";
import { OverlayTriggerStateContext as N } from "./ui-components-library75.js";
import { mergeProps as T } from "./ui-components-library123.js";
import { filterDOMProps as W } from "./ui-components-library124.js";
import { useLayoutEffect as y } from "./ui-components-library142.js";
import { useExitAnimation as q, useEnterAnimation as z } from "./ui-components-library174.js";
import { focusSafely as B } from "./ui-components-library175.js";
import r, { forwardRef as G, createContext as w, useContext as S, useRef as P, useState as C, useEffect as j } from "react";
import { useIsHidden as k } from "./ui-components-library121.js";
import { useOverlayTriggerState as J } from "./ui-components-library176.js";
import { useLocale as K } from "./ui-components-library130.js";
import { usePopover as L } from "./ui-components-library177.js";
import { DismissButton as O } from "./ui-components-library178.js";
import { Overlay as R } from "./ui-components-library179.js";
const Q = /* @__PURE__ */ w(null), h = /* @__PURE__ */ w(null), se = /* @__PURE__ */ G(function(t, a) {
  [t, a] = _(t, a, Q);
  let e = S(N), f = J(t), d = t.isOpen != null || t.defaultOpen != null || !e ? f : e, u = q(a, d.isOpen) || t.isExiting || !1, s = k(), { direction: o } = K();
  if (s) {
    let l = t.children;
    return typeof l == "function" && (l = l({
      trigger: t.trigger || null,
      placement: "bottom",
      isEntering: !1,
      isExiting: !1,
      defaultChildren: null
    })), /* @__PURE__ */ r.createElement(r.Fragment, null, l);
  }
  return d && !d.isOpen && !u ? null : /* @__PURE__ */ r.createElement(V, {
    ...t,
    triggerRef: t.triggerRef,
    state: d,
    popoverRef: a,
    isExiting: u,
    dir: o
  });
});
function V({ state: n, isExiting: t, UNSTABLE_portalContainer: a, ...e }) {
  let f = P(null), [d, u] = C(0), s = P(null), o = S(h), l = o && e.trigger === "SubmenuTrigger";
  y(() => {
    f.current && n.isOpen && u(f.current.getBoundingClientRect().width);
  }, [
    n.isOpen,
    f
  ]);
  var $;
  let { popoverProps: x, underlayProps: D, arrowProps: M, placement: m } = L({
    ...e,
    offset: ($ = e.offset) !== null && $ !== void 0 ? $ : 8,
    arrowSize: d,
    // If this is a submenu/subdialog, use the root popover's container 
    // to detect outside interaction and add aria-hidden.
    groupRef: l ? o : s
  }, n), i = e.popoverRef, v = z(i, !!m) || e.isEntering || !1, b = A({
    ...e,
    defaultClassName: "react-aria-Popover",
    values: {
      trigger: e.trigger || null,
      placement: m,
      isEntering: v,
      isExiting: t
    }
  }), p = !e.isNonModal || e.trigger === "SubmenuTrigger", [c, F] = C(!1);
  y(() => {
    i.current && F(p && !i.current.querySelector("[role=dialog]"));
  }, [
    i,
    p
  ]), j(() => {
    c && i.current && !i.current.contains(document.activeElement) && B(i.current);
  }, [
    c,
    i
  ]);
  let I = {
    ...x.style,
    ...b.style
  }, E = /* @__PURE__ */ r.createElement("div", {
    ...T(W(e), x),
    ...b,
    role: c ? "dialog" : void 0,
    tabIndex: c ? -1 : void 0,
    "aria-label": e["aria-label"],
    "aria-labelledby": e["aria-labelledby"],
    ref: i,
    slot: e.slot || void 0,
    style: I,
    dir: e.dir,
    "data-trigger": e.trigger,
    "data-placement": m,
    "data-entering": v || void 0,
    "data-exiting": t || void 0
  }, !e.isNonModal && /* @__PURE__ */ r.createElement(O, {
    onDismiss: n.close
  }), /* @__PURE__ */ r.createElement(H.Provider, {
    value: {
      ...M,
      placement: m,
      ref: f
    }
  }, b.children), /* @__PURE__ */ r.createElement(O, {
    onDismiss: n.close
  }));
  if (!l) return /* @__PURE__ */ r.createElement(R, {
    ...e,
    shouldContainFocus: c,
    isExiting: t,
    portalContainer: a
  }, !e.isNonModal && n.isOpen && /* @__PURE__ */ r.createElement("div", {
    "data-testid": "underlay",
    ...D,
    style: {
      position: "fixed",
      inset: 0
    }
  }), /* @__PURE__ */ r.createElement("div", {
    ref: s,
    style: {
      display: "contents"
    }
  }, /* @__PURE__ */ r.createElement(h.Provider, {
    value: s
  }, E)));
  var g;
  return /* @__PURE__ */ r.createElement(R, {
    ...e,
    shouldContainFocus: c,
    isExiting: t,
    portalContainer: (g = a ?? (o == null ? void 0 : o.current)) !== null && g !== void 0 ? g : void 0
  }, E);
}
export {
  se as Popover,
  Q as PopoverContext
};
