import { fromAbsolute as s, toCalendar as i, toCalendarDate as m } from "./ui-components-library300.js";
import { weekStartData as l } from "./ui-components-library311.js";
function p(e, a) {
  return a = i(a, e.calendar), e.era === a.era && e.year === a.year && e.month === a.month && e.day === a.day;
}
function k(e, a) {
  return a = i(a, e.calendar), e = r(e), a = r(a), e.era === a.era && e.year === a.year && e.month === a.month;
}
function w(e, a) {
  return e.calendar.identifier === a.calendar.identifier && e.era === a.era && e.year === a.year && e.month === a.month && e.day === a.day;
}
function O(e, a) {
  return p(e, h(a));
}
const y = {
  sun: 0,
  mon: 1,
  tue: 2,
  wed: 3,
  thu: 4,
  fri: 5,
  sat: 6
};
function u(e, a, n) {
  let t = e.calendar.toJulianDay(e), d = n ? y[n] : D(a), f = Math.ceil(t + 1 - d) % 7;
  return f < 0 && (f += 7), f;
}
function x(e) {
  return s(Date.now(), e);
}
function h(e) {
  return m(x(e));
}
function v(e, a) {
  return e.calendar.toJulianDay(e) - a.calendar.toJulianDay(a);
}
function T(e, a) {
  return o(e) - o(a);
}
function o(e) {
  return e.hour * 36e5 + e.minute * 6e4 + e.second * 1e3 + e.millisecond;
}
let c = null;
function W() {
  return c == null && (c = new Intl.DateTimeFormat().resolvedOptions().timeZone), c;
}
function r(e) {
  return e.subtract({
    days: e.day - 1
  });
}
function S(e) {
  return e.add({
    days: e.calendar.getDaysInMonth(e) - e.day
  });
}
function Y(e) {
  return r(e.subtract({
    months: e.month - 1
  }));
}
function A(e) {
  return e.calendar.getMinimumMonthInYear ? e.calendar.getMinimumMonthInYear(e) : 1;
}
function J(e) {
  return e.calendar.getMinimumDayInMonth ? e.calendar.getMinimumDayInMonth(e) : 1;
}
function M(e, a, n) {
  let t = u(e, a, n);
  return e.subtract({
    days: t
  });
}
function L(e, a, n) {
  return M(e, a, n).add({
    days: 6
  });
}
const $ = /* @__PURE__ */ new Map();
function g(e) {
  if (Intl.Locale) {
    let n = $.get(e);
    return n || (n = new Intl.Locale(e).maximize().region, n && $.set(e, n)), n;
  }
  let a = e.split("-")[1];
  return a === "u" ? void 0 : a;
}
function D(e) {
  let a = g(e);
  return a && l[a] || 0;
}
function Z(e, a, n) {
  let t = e.calendar.getDaysInMonth(e);
  return Math.ceil((u(r(e), a, n) + t) / 7);
}
function C(e, a) {
  return e && a ? e.compare(a) <= 0 ? e : a : e || a;
}
function R(e, a) {
  return e && a ? e.compare(a) >= 0 ? e : a : e || a;
}
export {
  v as compareDate,
  T as compareTime,
  S as endOfMonth,
  L as endOfWeek,
  u as getDayOfWeek,
  W as getLocalTimeZone,
  J as getMinimumDayInMonth,
  A as getMinimumMonthInYear,
  Z as getWeeksInMonth,
  w as isEqualDay,
  p as isSameDay,
  k as isSameMonth,
  O as isToday,
  R as maxDate,
  C as minDate,
  x as now,
  r as startOfMonth,
  M as startOfWeek,
  Y as startOfYear,
  h as today
};
