import { useContextProps as h, useSlottedContext as G, useSlot as q, useRenderProps as y, Provider as B, removeDataAttributes as I } from "./ui-components-library119.js";
import { FieldErrorContext as S } from "./ui-components-library48.js";
import { FormContext as g } from "./ui-components-library136.js";
import { LabelContext as E } from "./ui-components-library46.js";
import { TextContext as H } from "./ui-components-library64.js";
import { mergeProps as P } from "./ui-components-library123.js";
import { mergeRefs as M } from "./ui-components-library137.js";
import { filterDOMProps as V } from "./ui-components-library124.js";
import { useObjectRef as _ } from "./ui-components-library138.js";
import t, { forwardRef as C, createContext as m } from "react";
import { useRadioGroupState as T } from "./ui-components-library182.js";
import { useRadioGroup as N } from "./ui-components-library183.js";
import { useRadio as j } from "./ui-components-library184.js";
import { useFocusRing as w } from "./ui-components-library126.js";
import { useHover as A } from "./ui-components-library127.js";
import { VisuallyHidden as L } from "./ui-components-library135.js";
const k = /* @__PURE__ */ m(null), z = /* @__PURE__ */ m(null), D = /* @__PURE__ */ m(null), ne = /* @__PURE__ */ C(function(e, i) {
  [e, i] = h(e, i, k);
  let { validationBehavior: $ } = G(g) || {};
  var o, d;
  let r = (d = (o = e.validationBehavior) !== null && o !== void 0 ? o : $) !== null && d !== void 0 ? d : "native", a = T({
    ...e,
    validationBehavior: r
  }), [b, n] = q(!e["aria-label"] && !e["aria-labelledby"]), { radioGroupProps: s, labelProps: l, descriptionProps: f, errorMessageProps: c, ...p } = N({
    ...e,
    label: n,
    validationBehavior: r
  }, a), u = y({
    ...e,
    values: {
      orientation: e.orientation || "vertical",
      isDisabled: a.isDisabled,
      isReadOnly: a.isReadOnly,
      isRequired: a.isRequired,
      isInvalid: a.isInvalid,
      state: a
    },
    defaultClassName: "react-aria-RadioGroup"
  });
  return /* @__PURE__ */ t.createElement("div", {
    ...s,
    ...u,
    ref: i,
    slot: e.slot || void 0,
    "data-orientation": e.orientation || "vertical",
    "data-invalid": a.isInvalid || void 0,
    "data-disabled": a.isDisabled || void 0,
    "data-readonly": a.isReadOnly || void 0,
    "data-required": a.isRequired || void 0
  }, /* @__PURE__ */ t.createElement(B, {
    values: [
      [
        D,
        a
      ],
      [
        E,
        {
          ...l,
          ref: b,
          elementType: "span"
        }
      ],
      [
        H,
        {
          slots: {
            description: f,
            errorMessage: c
          }
        }
      ],
      [
        S,
        p
      ]
    ]
  }, u.children));
}), le = /* @__PURE__ */ C(function(e, i) {
  let { inputRef: $ = null, ...o } = e;
  [e, i] = h(o, i, z);
  let d = t.useContext(D), r = _(M($, e.inputRef !== void 0 ? e.inputRef : null)), { labelProps: a, inputProps: b, isSelected: n, isDisabled: s, isPressed: l } = j({
    ...I(e),
    // ReactNode type doesn't allow function children.
    children: typeof e.children == "function" ? !0 : e.children
  }, d, r), { isFocused: f, isFocusVisible: c, focusProps: p } = w(), u = s || d.isReadOnly, { hoverProps: F, isHovered: v } = A({
    ...e,
    isDisabled: u
  }), x = y({
    ...e,
    defaultClassName: "react-aria-Radio",
    values: {
      isSelected: n,
      isPressed: l,
      isHovered: v,
      isFocused: f,
      isFocusVisible: c,
      isDisabled: s,
      isReadOnly: d.isReadOnly,
      isInvalid: d.isInvalid,
      isRequired: d.isRequired
    }
  }), R = V(e);
  return delete R.id, /* @__PURE__ */ t.createElement("label", {
    ...P(R, a, F, x),
    ref: i,
    "data-selected": n || void 0,
    "data-pressed": l || void 0,
    "data-hovered": v || void 0,
    "data-focused": f || void 0,
    "data-focus-visible": c || void 0,
    "data-disabled": s || void 0,
    "data-readonly": d.isReadOnly || void 0,
    "data-invalid": d.isInvalid || void 0,
    "data-required": d.isRequired || void 0
  }, /* @__PURE__ */ t.createElement(L, {
    elementType: "span"
  }, /* @__PURE__ */ t.createElement("input", {
    ...P(b, p),
    ref: r
  })), x.children);
});
export {
  le as Radio,
  z as RadioContext,
  ne as RadioGroup,
  k as RadioGroupContext,
  D as RadioGroupStateContext
};
