import { CheckboxContext as S } from "./ui-components-library117.js";
import { useContextProps as g, useSlottedContext as B, removeDataAttributes as v, useRenderProps as O } from "./ui-components-library119.js";
import { FormContext as H } from "./ui-components-library136.js";
import { mergeProps as p } from "./ui-components-library123.js";
import { mergeRefs as V } from "./ui-components-library137.js";
import { filterDOMProps as _ } from "./ui-components-library124.js";
import { useObjectRef as q } from "./ui-components-library138.js";
import s, { forwardRef as E, useContext as G, createContext as M } from "react";
import { useCheckboxGroupItem as T } from "./ui-components-library139.js";
import { useCheckbox as j } from "./ui-components-library140.js";
import { useToggleState as w } from "./ui-components-library141.js";
import { useFocusRing as A } from "./ui-components-library126.js";
import { useHover as N } from "./ui-components-library127.js";
import { VisuallyHidden as z } from "./ui-components-library135.js";
const J = /* @__PURE__ */ M(null), se = /* @__PURE__ */ E(function(e, d) {
  let { inputRef: h = null, ...P } = e;
  [e, d] = g(P, d, S);
  let { validationBehavior: R } = B(H) || {};
  var t, i;
  let C = (i = (t = e.validationBehavior) !== null && t !== void 0 ? t : R) !== null && i !== void 0 ? i : "native", f = G(J), a = q(V(h, e.inputRef !== void 0 ? e.inputRef : null)), { labelProps: I, inputProps: y, isSelected: n, isDisabled: o, isReadOnly: r, isPressed: l, isInvalid: c } = f ? T({
    ...v(e),
    // Value is optional for standalone checkboxes, but required for CheckboxGroup items;
    // it's passed explicitly here to avoid typescript error (requires ignore).
    // @ts-ignore
    value: e.value,
    // ReactNode type doesn't allow function children.
    children: typeof e.children == "function" ? !0 : e.children
  }, f, a) : j({
    ...v(e),
    children: typeof e.children == "function" ? !0 : e.children,
    validationBehavior: C
  }, w(e), a), { isFocused: u, isFocusVisible: $, focusProps: D } = A(), F = o || r, { hoverProps: k, isHovered: b } = N({
    ...e,
    isDisabled: F
  }), m = O({
    ...e,
    defaultClassName: "react-aria-Checkbox",
    values: {
      isSelected: n,
      isIndeterminate: e.isIndeterminate || !1,
      isPressed: l,
      isHovered: b,
      isFocused: u,
      isFocusVisible: $,
      isDisabled: o,
      isReadOnly: r,
      isInvalid: c,
      isRequired: e.isRequired || !1
    }
  }), x = _(e);
  return delete x.id, /* @__PURE__ */ s.createElement("label", {
    ...p(x, I, k, m),
    ref: d,
    slot: e.slot || void 0,
    "data-selected": n || void 0,
    "data-indeterminate": e.isIndeterminate || void 0,
    "data-pressed": l || void 0,
    "data-hovered": b || void 0,
    "data-focused": u || void 0,
    "data-focus-visible": $ || void 0,
    "data-disabled": o || void 0,
    "data-readonly": r || void 0,
    "data-invalid": c || void 0,
    "data-required": e.isRequired || void 0
  }, /* @__PURE__ */ s.createElement(z, {
    elementType: "span"
  }, /* @__PURE__ */ s.createElement("input", {
    ...p(y, D),
    ref: a
  })), m.children);
});
export {
  se as Checkbox,
  J as CheckboxGroupStateContext
};
