import { CollectionRendererContext as T, DefaultCollectionRenderer as D, usePersistedKeys as S } from "./ui-components-library160.js";
import { useContextProps as M, useRenderProps as m, Provider as E, useSlottedContext as g } from "./ui-components-library119.js";
import { createLeafComponent as k, CollectionBuilder as w, Collection as K } from "./ui-components-library93.js";
import { createHideableComponent as N } from "./ui-components-library121.js";
import { mergeProps as R } from "./ui-components-library123.js";
import { filterDOMProps as v } from "./ui-components-library124.js";
import { useObjectRef as x } from "./ui-components-library138.js";
import { inertValue as O } from "./ui-components-library195.js";
import d, { forwardRef as y, createContext as H, useMemo as L, useContext as b } from "react";
import { useTab as z } from "./ui-components-library196.js";
import { useTabPanel as A } from "./ui-components-library197.js";
import { useTabList as I } from "./ui-components-library198.js";
import { useFocusRing as C } from "./ui-components-library126.js";
import { useHover as j } from "./ui-components-library127.js";
import { useTabListState as _ } from "./ui-components-library199.js";
const p = /* @__PURE__ */ H(null), u = /* @__PURE__ */ H(null), de = /* @__PURE__ */ y(function(t, o) {
  [t, o] = M(t, o, p);
  let { children: a, orientation: s = "horizontal" } = t;
  return a = L(() => typeof a == "function" ? a({
    orientation: s,
    defaultChildren: null
  }) : a, [
    a,
    s
  ]), /* @__PURE__ */ d.createElement(w, {
    content: a
  }, (l) => /* @__PURE__ */ d.createElement(B, {
    props: t,
    collection: l,
    tabsRef: o
  }));
});
function B({ props: e, tabsRef: t, collection: o }) {
  let { orientation: a = "horizontal" } = e, s = _({
    ...e,
    collection: o,
    children: void 0
  }), { focusProps: l, isFocused: n, isFocusVisible: i } = C({
    within: !0
  }), c = L(() => ({
    orientation: a,
    isFocusWithin: n,
    isFocusVisible: i
  }), [
    a,
    n,
    i
  ]), r = m({
    ...e,
    defaultClassName: "react-aria-Tabs",
    values: c
  });
  return /* @__PURE__ */ d.createElement("div", {
    ...v(e),
    ...l,
    ...r,
    ref: t,
    slot: e.slot || void 0,
    "data-focused": n || void 0,
    "data-orientation": a,
    "data-focus-visible": i || void 0,
    "data-disabled": s.isDisabled || void 0
  }, /* @__PURE__ */ d.createElement(E, {
    values: [
      [
        p,
        e
      ],
      [
        u,
        s
      ]
    ]
  }, r.children));
}
const ne = /* @__PURE__ */ y(function(t, o) {
  return b(u) ? /* @__PURE__ */ d.createElement(W, {
    props: t,
    forwardedRef: o
  }) : /* @__PURE__ */ d.createElement(K, t);
});
function W({ props: e, forwardedRef: t }) {
  let o = b(u), { CollectionRoot: a } = b(T), { orientation: s = "horizontal", keyboardActivation: l = "automatic" } = g(p), n = x(t), { tabListProps: i } = I({
    ...e,
    orientation: s,
    keyboardActivation: l
  }, o, n), c = m({
    ...e,
    children: null,
    defaultClassName: "react-aria-TabList",
    values: {
      orientation: s,
      state: o
    }
  }), r = v(e);
  return delete r.id, /* @__PURE__ */ d.createElement("div", {
    ...r,
    ...i,
    ref: n,
    ...c,
    "data-orientation": s || void 0
  }, /* @__PURE__ */ d.createElement(a, {
    collection: o.collection,
    persistedKeys: S(o.selectionManager.focusedKey)
  }));
}
const le = /* @__PURE__ */ k("item", (e, t, o) => {
  let a = b(u), s = x(t), { tabProps: l, isSelected: n, isDisabled: i, isPressed: c } = z({
    key: o.key,
    ...e
  }, a, s), { focusProps: r, isFocused: f, isFocusVisible: $ } = C(), { hoverProps: P, isHovered: h } = j({
    isDisabled: i,
    onHoverStart: e.onHoverStart,
    onHoverEnd: e.onHoverEnd,
    onHoverChange: e.onHoverChange
  }), F = m({
    ...e,
    id: void 0,
    children: o.rendered,
    defaultClassName: "react-aria-Tab",
    values: {
      isSelected: n,
      isDisabled: i,
      isFocused: f,
      isFocusVisible: $,
      isPressed: c,
      isHovered: h
    }
  }), V = o.props.href ? "a" : "div";
  return /* @__PURE__ */ d.createElement(V, {
    ...R(l, r, P, F),
    ref: s,
    "data-selected": n || void 0,
    "data-disabled": i || void 0,
    "data-focused": f || void 0,
    "data-focus-visible": $ || void 0,
    "data-pressed": c || void 0,
    "data-hovered": h || void 0
  }, F.children);
}), ce = /* @__PURE__ */ N(function(t, o) {
  const a = b(u);
  let s = x(o), { tabPanelProps: l } = A(t, a, s), { focusProps: n, isFocused: i, isFocusVisible: c } = C(), r = a.selectedKey === t.id, f = m({
    ...t,
    defaultClassName: "react-aria-TabPanel",
    values: {
      isFocused: i,
      isFocusVisible: c,
      isInert: !r,
      state: a
    }
  });
  if (!r && !t.shouldForceMount) return null;
  let $ = v(t);
  delete $.id;
  let P = r ? R($, l, n, f) : f;
  return /* @__PURE__ */ d.createElement("div", {
    ...P,
    ref: s,
    "data-focused": i || void 0,
    "data-focus-visible": c || void 0,
    // @ts-ignore
    inert: O(!r),
    "data-inert": r ? void 0 : "true"
  }, /* @__PURE__ */ d.createElement(E, {
    values: [
      [
        p,
        null
      ],
      [
        u,
        null
      ]
    ]
  }, /* @__PURE__ */ d.createElement(T.Provider, {
    value: D
  }, f.children)));
});
export {
  le as Tab,
  ne as TabList,
  u as TabListStateContext,
  ce as TabPanel,
  de as Tabs,
  p as TabsContext
};
