import { BaseCollection as w } from "./ui-components-library265.js";
import { Document as P } from "./ui-components-library266.js";
import { useCachedChildren as y } from "./ui-components-library161.js";
import { Hidden as g } from "./ui-components-library121.js";
import { createPortal as D } from "react-dom";
import { FocusableContext as S } from "./ui-components-library101.js";
import r, { forwardRef as v, useContext as d, createContext as $, useMemo as C, useCallback as s, useState as B, useRef as N } from "react";
import { useIsSSR as b } from "./ui-components-library267.js";
import { useLayoutEffect as F } from "./ui-components-library142.js";
import { s as I } from "./ui-components-library268.js";
const x = /* @__PURE__ */ $(!1), f = /* @__PURE__ */ $(null);
function Q(t) {
  if (d(f))
    return t.content;
  let { collection: o, document: l } = A(t.createCollection);
  return /* @__PURE__ */ r.createElement(r.Fragment, null, /* @__PURE__ */ r.createElement(g, null, /* @__PURE__ */ r.createElement(f.Provider, {
    value: l
  }, t.content)), /* @__PURE__ */ r.createElement(M, {
    render: t.children,
    collection: o
  }));
}
function M({ collection: t, render: e }) {
  return e(t);
}
function _(t, e, o) {
  let l = b(), n = N(l);
  n.current = l;
  let c = s(() => n.current ? o() : e(), [
    e,
    o
  ]);
  return I.useSyncExternalStore(t, c);
}
const k = typeof r.useSyncExternalStore == "function" ? r.useSyncExternalStore : _;
function A(t) {
  let [e] = B(() => new P((t == null ? void 0 : t()) || new w())), o = s((u) => e.subscribe(u), [
    e
  ]), l = s(() => {
    let u = e.getCollection();
    return e.isSSR && e.resetAfterSSR(), u;
  }, [
    e
  ]), n = s(() => (e.isSSR = !0, e.getCollection()), [
    e
  ]), c = k(o, l, n);
  return F(() => (e.isMounted = !0, () => {
    e.isMounted = !1;
  }), [
    e
  ]), {
    collection: c,
    document: e
  };
}
const m = /* @__PURE__ */ $(null);
function E(t, e, o, l, n, c) {
  let u = s((a) => {
    a == null || a.setProps(e, o, l, c);
  }, [
    e,
    o,
    l,
    c
  ]), i = d(m);
  if (i) {
    let a = i.ownerDocument.nodesByProps.get(e);
    return a || (a = i.ownerDocument.createElement(t), a.setProps(e, o, l, c), i.appendChild(a), i.ownerDocument.updateCollection(), i.ownerDocument.nodesByProps.set(e, a)), n ? /* @__PURE__ */ r.createElement(m.Provider, {
      value: a
    }, n) : null;
  }
  return /* @__PURE__ */ r.createElement(t, {
    ref: u
  }, n);
}
function U(t, e) {
  let o = ({ node: n }) => e(n.props, n.props.ref, n), l = v((n, c) => {
    let u = d(S);
    if (!d(x)) {
      if (e.length >= 3) throw new Error(e.name + " cannot be rendered outside a collection.");
      return e(n, c);
    }
    return E(t, n, c, "children" in n ? n.children : null, null, (a) => (
      // Forward FocusableContext to real DOM tree so tooltips work.
      /* @__PURE__ */ r.createElement(S.Provider, {
        value: u
      }, /* @__PURE__ */ r.createElement(o, {
        node: a
      }))
    ));
  });
  return l.displayName = e.name, l;
}
function X(t, e, o = R) {
  let l = ({ node: c }) => e(c.props, c.props.ref, c), n = v((c, u) => {
    let i = o(c);
    var a;
    return (a = E(t, c, u, null, i, (h) => /* @__PURE__ */ r.createElement(l, {
      node: h
    }))) !== null && a !== void 0 ? a : /* @__PURE__ */ r.createElement(r.Fragment, null);
  });
  return n.displayName = e.name, n;
}
function R(t) {
  return y({
    ...t,
    addIdAndValue: !0
  });
}
const p = /* @__PURE__ */ $(null);
function Y(t) {
  let e = d(p), o = ((e == null ? void 0 : e.dependencies) || []).concat(t.dependencies), l = t.idScope || (e == null ? void 0 : e.idScope), n = R({
    ...t,
    idScope: l,
    dependencies: o
  });
  return d(f) && (n = /* @__PURE__ */ r.createElement(L, null, n)), e = C(() => ({
    dependencies: o,
    idScope: l
  }), [
    l,
    ...o
  ]), /* @__PURE__ */ r.createElement(p.Provider, {
    value: e
  }, n);
}
function L({ children: t }) {
  let e = d(f), o = C(() => /* @__PURE__ */ r.createElement(f.Provider, {
    value: null
  }, /* @__PURE__ */ r.createElement(x.Provider, {
    value: !0
  }, t)), [
    t
  ]);
  return b() ? /* @__PURE__ */ r.createElement(m.Provider, {
    value: e
  }, o) : /* @__PURE__ */ D(o, e);
}
export {
  Y as Collection,
  Q as CollectionBuilder,
  X as createBranchComponent,
  U as createLeafComponent
};
