import { default as React } from 'react';
import { SelectProps as AriaSelectProps } from 'react-aria-components';
import { IItem } from './item';
export interface IDropdownCascader extends AriaSelectProps {
    items: IItem[];
    callback: (item: IItem) => void;
    label?: string;
}
declare function DropdownCascader({ label, items, callback, placeholder, className, disabledKeys, selectedKey, defaultSelectedKey, ...props }: Readonly<IDropdownCascader>): React.JSX.Element;
export default DropdownCascader;
