import { default as React } from 'react';
import { Key, ListBoxItemProps } from 'react-aria-components';
export interface BaseItem {
    text: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    icon?: React.ReactNode;
    dot?: string;
    itemValue?: any;
}
export interface IItem extends BaseItem, Omit<ListBoxItemProps, "children" | "value"> {
    id: Key;
}
declare const Item: React.FC<IItem>;
export default Item;
