import { default as React } from 'react';
import { BigNumberFieldProps } from './useBigNumberField';
interface BigNumberFieldComponentProps extends BigNumberFieldProps {
    variant?: "success" | "warning" | "error" | "info";
    message?: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    className?: string;
}
declare function BigNumberField({ variant, message, Icon, className, placeholder, label, isDisabled, id: propId, isReadOnly, ...props }: Readonly<BigNumberFieldComponentProps>): React.JSX.Element;
export default BigNumberField;
