import { default as React } from 'react';
import { InputProps, NumberFieldProps as AriaNumberFieldProps } from 'react-aria-components';
interface NumberFieldProps extends AriaNumberFieldProps {
    variant?: "success" | "warning" | "error" | "info";
    message?: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    placeholder?: InputProps["placeholder"];
    inputProps?: InputProps;
    label?: string;
}
declare function NumberField({ variant, message, Icon, className, placeholder, label, isDisabled, inputProps, ...props }: Readonly<NumberFieldProps>): React.JSX.Element;
export default NumberField;
