import { default as React } from 'react';
type VariantProp = {
    variant: "success" | "warning" | "error" | "info";
};
interface AlertProps extends VariantProp {
    title: string;
    msg: string;
    className?: string;
}
declare function Alert({ variant, title, msg, className }: Readonly<AlertProps>): React.JSX.Element;
export default Alert;
