import { default as React } from 'react';
import { ProgressBarProps } from 'react-aria-components';
interface CircularProps extends Omit<ProgressBarProps, "isIndeterminate" | "valueLabel" | "formatOptions"> {
    small?: boolean;
    value: number;
    animated?: boolean;
}
declare function Circular({ value, minValue, maxValue, small, animated, ...props }: Readonly<CircularProps>): React.JSX.Element;
export default Circular;
