import { default as React, ReactNode } from 'react';
import { ProgressBarProps } from 'react-aria-components';
interface LinearProps extends Omit<ProgressBarProps, "isIndeterminate" | "formatOptions"> {
    timerText?: ReactNode;
    value: number;
    animated?: boolean;
    width: number;
}
declare function Linear({ value, valueLabel, width, timerText, minValue, maxValue, animated, className, ...props }: Readonly<LinearProps>): React.JSX.Element;
export default Linear;
