import { default as React } from 'react';
export declare const colorRegex: RegExp;
export type VariantProp = {
    variant?: "accepted" | "refused" | string;
};
interface SpineProps extends VariantProp {
    line?: boolean;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    titleRef?: React.RefObject<HTMLHeadingElement>;
}
declare const Spine: React.FC<SpineProps>;
export default Spine;
