import { focusSafely as m } from "./ui-components-library175.js";
import { useFocus as $ } from "./ui-components-library338.js";
import { useKeyboard as p } from "./ui-components-library343.js";
import { getOwnerWindow as x } from "./ui-components-library275.js";
import { mergeProps as n } from "./ui-components-library123.js";
import { mergeRefs as h } from "./ui-components-library137.js";
import { useObjectRef as b } from "./ui-components-library138.js";
import { useSyncRef as P } from "./ui-components-library283.js";
import { isFocusable as F } from "./ui-components-library153.js";
import s, { forwardRef as v, useEffect as u, useRef as g, useContext as w } from "react";
let d = /* @__PURE__ */ s.createContext(null);
function N(r) {
  let t = w(d) || {};
  P(t, r);
  let { ref: a, ...l } = t;
  return l;
}
const S = /* @__PURE__ */ s.forwardRef(function(t, a) {
  let { children: l, ...c } = t, f = b(a), o = {
    ...c,
    ref: f
  };
  return /* @__PURE__ */ s.createElement(d.Provider, {
    value: o
  }, l);
});
function R(r, t) {
  let { focusProps: a } = $(r), { keyboardProps: l } = p(r), c = n(a, l), f = N(t), o = r.isDisabled ? {} : f, e = g(r.autoFocus);
  u(() => {
    e.current && t.current && m(t.current), e.current = !1;
  }, [
    t
  ]);
  let i = r.excludeFromTabOrder ? -1 : 0;
  return r.isDisabled && (i = void 0), {
    focusableProps: n({
      ...c,
      tabIndex: i
    }, o)
  };
}
const G = /* @__PURE__ */ v(({ children: r, ...t }, a) => {
  a = b(a);
  let { focusableProps: l } = R(t, a), c = s.Children.only(r);
  u(() => {
    let o = a.current;
    if (!o || !(o instanceof x(o).Element)) {
      console.error("<Focusable> child must forward its ref to a DOM element.");
      return;
    }
    if (!t.isDisabled && !F(o)) {
      console.warn("<Focusable> child must be focusable. Please ensure the tabIndex prop is passed through.");
      return;
    }
    if (o.localName !== "button" && o.localName !== "input" && o.localName !== "select" && o.localName !== "textarea" && o.localName !== "a" && o.localName !== "area" && o.localName !== "summary" && o.localName !== "img" && o.localName !== "svg") {
      let e = o.getAttribute("role");
      e ? (
        // https://w3c.github.io/aria/#widget_roles
        e !== "application" && e !== "button" && e !== "checkbox" && e !== "combobox" && e !== "gridcell" && e !== "link" && e !== "menuitem" && e !== "menuitemcheckbox" && e !== "menuitemradio" && e !== "option" && e !== "radio" && e !== "searchbox" && e !== "separator" && e !== "slider" && e !== "spinbutton" && e !== "switch" && e !== "tab" && e !== "tabpanel" && e !== "textbox" && e !== "treeitem" && // aria-describedby is also announced on these roles
        e !== "img" && e !== "meter" && e !== "progressbar" && console.warn(`<Focusable> child must have an interactive ARIA role. Got "${e}".`)
      ) : console.warn("<Focusable> child must have an interactive ARIA role.");
    }
  }, [
    a,
    t.isDisabled
  ]);
  let f = parseInt(s.version, 10) < 19 ? c.ref : c.props.ref;
  return /* @__PURE__ */ s.cloneElement(c, {
    ...n(l, c.props),
    // @ts-ignore
    ref: h(f, a)
  });
});
export {
  G as Focusable,
  d as FocusableContext,
  S as FocusableProvider,
  R as useFocusable
};
