import { useVisibleRangeDescription as $, hookData as g } from "./ui-components-library381.js";
import { startOfWeek as k, today as w } from "./ui-components-library80.js";
import { useMemo as P } from "react";
import { mergeProps as v } from "./ui-components-library123.js";
import { useLabels as x } from "./ui-components-library152.js";
import { useLocale as f } from "./ui-components-library130.js";
import { useDateFormatter as h } from "./ui-components-library382.js";
function K(r, e) {
  let { startDate: l = e.visibleRange.start, endDate: s = e.visibleRange.end, firstDayOfWeek: o } = r, { direction: t } = f(), d = (a) => {
    switch (a.key) {
      case "Enter":
      case " ":
        a.preventDefault(), e.selectFocusedDate();
        break;
      case "PageUp":
        a.preventDefault(), a.stopPropagation(), e.focusPreviousSection(a.shiftKey);
        break;
      case "PageDown":
        a.preventDefault(), a.stopPropagation(), e.focusNextSection(a.shiftKey);
        break;
      case "End":
        a.preventDefault(), a.stopPropagation(), e.focusSectionEnd();
        break;
      case "Home":
        a.preventDefault(), a.stopPropagation(), e.focusSectionStart();
        break;
      case "ArrowLeft":
        a.preventDefault(), a.stopPropagation(), t === "rtl" ? e.focusNextDay() : e.focusPreviousDay();
        break;
      case "ArrowUp":
        a.preventDefault(), a.stopPropagation(), e.focusPreviousRow();
        break;
      case "ArrowRight":
        a.preventDefault(), a.stopPropagation(), t === "rtl" ? e.focusPreviousDay() : e.focusNextDay();
        break;
      case "ArrowDown":
        a.preventDefault(), a.stopPropagation(), e.focusNextRow();
        break;
      case "Escape":
        "setAnchorDate" in e && (a.preventDefault(), e.setAnchorDate(null));
        break;
    }
  }, c = $(l, s, e.timeZone, !0), { ariaLabel: p, ariaLabelledBy: u } = g.get(e), b = x({
    "aria-label": [
      p,
      c
    ].filter(Boolean).join(", "),
    "aria-labelledby": u
  }), i = h({
    weekday: r.weekdayStyle || "narrow",
    timeZone: e.timeZone
  }), { locale: n } = f(), D = P(() => {
    let a = k(w(e.timeZone), n, o);
    return [
      ...new Array(7).keys()
    ].map((m) => {
      let y = a.add({
        days: m
      }).toDate(e.timeZone);
      return i.format(y);
    });
  }, [
    n,
    e.timeZone,
    i,
    o
  ]);
  return {
    gridProps: v(b, {
      role: "grid",
      "aria-readonly": e.isReadOnly || void 0,
      "aria-disabled": e.isDisabled || void 0,
      "aria-multiselectable": "highlightedRange" in e || void 0,
      onKeyDown: d,
      onFocus: () => e.setFocused(!0),
      onBlur: () => e.setFocused(!1)
    }),
    headerProps: {
      // Column headers are hidden to screen readers to make navigating with a touch screen reader easier.
      // The day names are already included in the label of each cell, so there's no need to announce them twice.
      "aria-hidden": !0
    },
    weekDays: D
  };
}
export {
  K as useCalendarGrid
};
