import { hookData as V, getEraFormat as Z } from "./ui-components-library381.js";
import A from "./ui-components-library383.js";
import { isSameDay as a, isEqualDay as U, isToday as k } from "./ui-components-library80.js";
import { mergeProps as w } from "./ui-components-library123.js";
import { focusWithoutScrolling as B } from "./ui-components-library276.js";
import { getScrollParent as _ } from "./ui-components-library284.js";
import { useDescription as j } from "./ui-components-library287.js";
import { scrollIntoViewport as q } from "./ui-components-library290.js";
import { useDeepMemo as z } from "./ui-components-library292.js";
import { getInteractionModality as L } from "./ui-components-library340.js";
import { usePress as W } from "./ui-components-library347.js";
import { useLocalizedStringFormatter as G } from "./ui-components-library156.js";
import { useDateFormatter as S } from "./ui-components-library382.js";
import { useMemo as b, useRef as $, useEffect as H } from "react";
function J(t) {
  return t && t.__esModule ? t.default : t;
}
function ce(t, e, l) {
  let { date: r, isDisabled: d } = t, { errorMessageId: I, selectedDateDescription: y } = V.get(e), n = G(J(A), "@react-aria/calendar"), P = S({
    weekday: "long",
    day: "numeric",
    month: "long",
    year: "numeric",
    era: Z(r),
    timeZone: e.timeZone
  }), c = e.isSelected(r), m = e.isCellFocused(r);
  d = d || e.isCellDisabled(r);
  let x = e.isCellUnavailable(r), s = !d && !x, f = e.isValueInvalid && !!("highlightedRange" in e ? !e.anchorDate && e.highlightedRange && r.compare(e.highlightedRange.start) >= 0 && r.compare(e.highlightedRange.end) <= 0 : e.value && a(e.value, r));
  f && (c = !0), r = z(r, U);
  let g = b(() => r.toDate(e.timeZone), [
    r,
    e.timeZone
  ]), R = k(r, e.timeZone), T = b(() => {
    let i = "";
    return "highlightedRange" in e && e.value && !e.anchorDate && (a(r, e.value.start) || a(r, e.value.end)) && (i = y + ", "), i += P.format(g), R ? i = n.format(c ? "todayDateSelected" : "todayDate", {
      date: i
    }) : c && (i = n.format("dateSelected", {
      date: i
    })), e.minValue && a(r, e.minValue) ? i += ", " + n.format("minimumDate") : e.maxValue && a(r, e.maxValue) && (i += ", " + n.format("maximumDate")), i;
  }, [
    P,
    g,
    n,
    c,
    R,
    r,
    e,
    y
  ]), D = "";
  "anchorDate" in e && m && !e.isReadOnly && s && (e.anchorDate ? D = n.format("finishRangeSelectionPrompt") : D = n.format("startRangeSelectionPrompt"));
  let C = j(D), h = $(!1), p = $(!1), u = $(void 0), { pressProps: E, isPressed: O } = W({
    // When dragging to select a range, we don't want dragging over the original anchor
    // again to trigger onPressStart. Cancel presses immediately when the pointer exits.
    shouldCancelOnPointerExit: "anchorDate" in e && !!e.anchorDate,
    preventFocusOnPress: !0,
    isDisabled: !s || e.isReadOnly,
    onPressStart(i) {
      if (e.isReadOnly) {
        e.setFocusedDate(r);
        return;
      }
      if ("highlightedRange" in e && !e.anchorDate && (i.pointerType === "mouse" || i.pointerType === "touch")) {
        if (e.highlightedRange && !f) {
          if (a(r, e.highlightedRange.start)) {
            e.setAnchorDate(e.highlightedRange.end), e.setFocusedDate(r), e.setDragging(!0), p.current = !0;
            return;
          } else if (a(r, e.highlightedRange.end)) {
            e.setAnchorDate(e.highlightedRange.start), e.setFocusedDate(r), e.setDragging(!0), p.current = !0;
            return;
          }
        }
        let o = () => {
          e.setDragging(!0), u.current = void 0, e.selectDate(r), e.setFocusedDate(r), h.current = !0;
        };
        i.pointerType === "touch" ? u.current = setTimeout(o, 200) : o();
      }
    },
    onPressEnd() {
      p.current = !1, h.current = !1, clearTimeout(u.current), u.current = void 0;
    },
    onPress() {
      !("anchorDate" in e) && !e.isReadOnly && (e.selectDate(r), e.setFocusedDate(r));
    },
    onPressUp(i) {
      if (!e.isReadOnly && ("anchorDate" in e && u.current && (e.selectDate(r), e.setFocusedDate(r)), "anchorDate" in e))
        if (p.current)
          e.setAnchorDate(r);
        else if (e.anchorDate && !h.current)
          e.selectDate(r), e.setFocusedDate(r);
        else if (i.pointerType === "keyboard" && !e.anchorDate) {
          e.selectDate(r);
          let o = r.add({
            days: 1
          });
          e.isInvalid(o) && (o = r.subtract({
            days: 1
          })), e.isInvalid(o) || e.setFocusedDate(o);
        } else i.pointerType === "virtual" && (e.selectDate(r), e.setFocusedDate(r));
    }
  }), v;
  d || (v = a(r, e.focusedDate) ? 0 : -1), H(() => {
    m && l.current && (B(l.current), L() !== "pointer" && document.activeElement === l.current && q(l.current, {
      containingElement: _(l.current)
    }));
  }, [
    m,
    l
  ]);
  let F = S({
    day: "numeric",
    timeZone: e.timeZone,
    calendar: r.calendar.identifier
  }), M = b(() => F.formatToParts(g).find((i) => i.type === "day").value, [
    F,
    g
  ]);
  return {
    cellProps: {
      role: "gridcell",
      "aria-disabled": !s || void 0,
      "aria-selected": c || void 0,
      "aria-invalid": f || void 0
    },
    buttonProps: w(E, {
      onFocus() {
        d || e.setFocusedDate(r);
      },
      tabIndex: v,
      role: "button",
      "aria-disabled": !s || void 0,
      "aria-label": T,
      "aria-invalid": f || void 0,
      "aria-describedby": [
        f ? I : void 0,
        C["aria-describedby"]
      ].filter(Boolean).join(" ") || void 0,
      onPointerEnter(i) {
        "highlightDate" in e && (i.pointerType !== "touch" || e.isDragging) && s && e.highlightDate(r);
      },
      onPointerDown(i) {
        "releasePointerCapture" in i.target && i.target.releasePointerCapture(i.pointerId);
      },
      onContextMenu(i) {
        i.preventDefault();
      }
    }),
    isPressed: O,
    isFocused: m,
    isSelected: c,
    isDisabled: d,
    isUnavailable: x,
    isOutsideVisibleRange: r.compare(e.visibleRange.start) < 0 || r.compare(e.visibleRange.end) > 0,
    isInvalid: f,
    formattedDate: M
  };
}
export {
  ce as useCalendarCell
};
