import { useRenderProps as I, useContextProps as S, Provider as C } from "./ui-components-library119.js";
import { Group as E, GroupContext as R } from "./ui-components-library61.js";
import { Input as y, InputContext as h } from "./ui-components-library62.js";
import { createCalendar as g } from "./ui-components-library129.js";
import { mergeProps as H } from "./ui-components-library123.js";
import { filterDOMProps as N } from "./ui-components-library124.js";
import { useObjectRef as O } from "./ui-components-library138.js";
import l, { createContext as u, forwardRef as c, useContext as n, cloneElement as V, useRef as G } from "react";
import { useDateSegment as _ } from "./ui-components-library144.js";
import { useDateField as j } from "./ui-components-library145.js";
import { useFocusRing as k } from "./ui-components-library126.js";
import { useHover as w } from "./ui-components-library127.js";
import { useLocale as L } from "./ui-components-library130.js";
import { useDateFieldState as M } from "./ui-components-library146.js";
const T = /* @__PURE__ */ u(null), $ = /* @__PURE__ */ u(null), p = /* @__PURE__ */ u(null), de = /* @__PURE__ */ c(function(e, t) {
  let o = n($), d = n(p);
  return o || d ? /* @__PURE__ */ l.createElement(v, {
    ...e,
    ref: t
  }) : /* @__PURE__ */ l.createElement(q, {
    ...e,
    ref: t
  });
}), q = /* @__PURE__ */ c((r, e) => {
  let [t, o] = S({
    slot: r.slot
  }, e, T), { locale: d } = L(), s = M({
    ...t,
    locale: d,
    createCalendar: g
  }), a = G(null), { fieldProps: i, inputProps: f } = j({
    ...t,
    inputRef: a
  }, s, o);
  return /* @__PURE__ */ l.createElement(C, {
    values: [
      [
        $,
        s
      ],
      [
        h,
        {
          ...f,
          ref: a
        }
      ],
      [
        R,
        {
          ...i,
          ref: o,
          isInvalid: s.isInvalid
        }
      ]
    ]
  }, /* @__PURE__ */ l.createElement(v, r));
}), v = /* @__PURE__ */ c((r, e) => {
  let { className: t, children: o } = r, d = n($), s = n(p), a = d ?? s;
  return /* @__PURE__ */ l.createElement(l.Fragment, null, /* @__PURE__ */ l.createElement(E, {
    ...r,
    ref: e,
    slot: r.slot || void 0,
    className: t ?? "react-aria-DateInput",
    isInvalid: a.isInvalid
  }, a.segments.map((i, f) => /* @__PURE__ */ V(o(i), {
    key: f
  }))), /* @__PURE__ */ l.createElement(y, null));
}), le = /* @__PURE__ */ c(function({ segment: e, ...t }, o) {
  let d = n($), s = n(p), a = d ?? s, i = O(o), { segmentProps: f } = _(e, a, i), { focusProps: F, isFocused: b, isFocusVisible: m } = k(), { hoverProps: D, isHovered: x } = w({
    ...t,
    isDisabled: a.isDisabled || e.type === "literal"
  }), P = I({
    ...t,
    values: {
      ...e,
      isReadOnly: !e.isEditable,
      isInvalid: a.isInvalid,
      isDisabled: a.isDisabled,
      isHovered: x,
      isFocused: b,
      isFocusVisible: m
    },
    defaultChildren: e.text,
    defaultClassName: "react-aria-DateSegment"
  });
  return /* @__PURE__ */ l.createElement("span", {
    ...H(N(t), f, F, D),
    ...P,
    style: f.style,
    ref: i,
    "data-placeholder": e.isPlaceholder || void 0,
    "data-invalid": a.isInvalid || void 0,
    "data-readonly": !e.isEditable || void 0,
    "data-disabled": a.isDisabled || void 0,
    "data-type": e.type,
    "data-hovered": x || void 0,
    "data-focused": b || void 0,
    "data-focus-visible": m || void 0
  });
});
export {
  T as DateFieldContext,
  $ as DateFieldStateContext,
  de as DateInput,
  le as DateSegment,
  p as TimeFieldStateContext
};
