import { useDefaultProps as U, getValidationResult as _, getFormatOptions as Z, getPlaceholderTime as F } from "./ui-components-library365.js";
import { toCalendarDateTime as k, toCalendarDate as B } from "./ui-components-library300.js";
import { DateFormatter as w } from "./ui-components-library312.js";
import { useFormValidationState as M } from "./ui-components-library366.js";
import { useOverlayTriggerState as R } from "./ui-components-library176.js";
import { useControlledState as j } from "./ui-components-library207.js";
import { useState as I, useMemo as E } from "react";
function W(e) {
  let m = R(e), [t, s] = j(e.value, e.defaultValue || null, e.onChange), u = t || e.placeholderValue || null, [i, r] = U(u, e.granularity), V = t != null ? t.toDate(r ?? "UTC") : null, c = i === "hour" || i === "minute" || i === "second";
  var $;
  let b = ($ = e.shouldCloseOnSelect) !== null && $ !== void 0 ? $ : !0, [o, g] = I(null), [n, S] = I(null);
  if (t && (o = t, "hour" in t && (n = t)), u && !(i in u)) throw new Error("Invalid granularity " + i + " for value " + u.toString());
  let T = (t == null ? void 0 : t.calendar.identifier) === "gregory" && t.era === "BC", d = E(() => ({
    granularity: i,
    timeZone: r,
    hideTimeZone: e.hideTimeZone,
    hourCycle: e.hourCycle,
    shouldForceLeadingZeros: e.shouldForceLeadingZeros,
    showEra: T
  }), [
    i,
    e.hourCycle,
    e.shouldForceLeadingZeros,
    r,
    e.hideTimeZone,
    T
  ]), { minValue: x, maxValue: D, isDateUnavailable: y } = e, L = E(() => _(t, x, D, y, d), [
    t,
    x,
    D,
    y,
    d
  ]), f = M({
    ...e,
    value: t,
    builtinValidation: L
  }), C = f.displayValidation.isInvalid, P = e.validationState || (C ? "invalid" : null), h = (a, l) => {
    s("timeZone" in l ? l.set(B(a)) : k(a, l)), g(null), S(null), f.commitValidation();
  };
  return {
    ...f,
    value: t,
    setValue: s,
    dateValue: o,
    timeValue: n,
    setDateValue: (a) => {
      let l = typeof b == "function" ? b() : b;
      c ? n || l ? h(a, n || F(e.defaultValue || e.placeholderValue)) : g(a) : (s(a), f.commitValidation()), l && m.setOpen(!1);
    },
    setTimeValue: (a) => {
      o && a ? h(o, a) : S(a);
    },
    granularity: i,
    hasTime: c,
    ...m,
    setOpen(a) {
      !a && !t && o && c && h(o, n || F(e.defaultValue || e.placeholderValue)), m.setOpen(a);
    },
    validationState: P,
    isInvalid: C,
    formatValue(a, l) {
      if (!V) return "";
      let v = Z(l, d);
      return new w(a, v).format(V);
    },
    getDateFormatter(a, l) {
      let v = {
        ...d,
        ...l
      }, O = Z({}, v);
      return new w(a, O);
    }
  };
}
export {
  W as useDatePickerState
};
