import { CollectionRendererContext as H, SectionContext as ae } from "./ui-components-library160.js";
import { useContextProps as re, useRenderProps as h, Provider as z, DEFAULT_SLOT as de, useSlot as le } from "./ui-components-library119.js";
import { DragAndDropContext as C, DropIndicatorContext as ie, useRenderDropIndicator as K, useDndPersistedKeys as ne } from "./ui-components-library163.js";
import { HeaderContext as se } from "./ui-components-library158.js";
import { SeparatorContext as ce } from "./ui-components-library164.js";
import { TextContext as fe } from "./ui-components-library64.js";
import { UNSTABLE_InternalAutocompleteContext as ue } from "./ui-components-library118.js";
import { CollectionBuilder as pe, Collection as $e, createLeafComponent as ge } from "./ui-components-library93.js";
import { mergeProps as O } from "./ui-components-library123.js";
import { mergeRefs as be } from "./ui-components-library137.js";
import { filterDOMProps as U } from "./ui-components-library124.js";
import { useObjectRef as w } from "./ui-components-library138.js";
import d, { forwardRef as j, createContext as q, useContext as p, useMemo as B, useRef as I, useEffect as W } from "react";
import { UNSTABLE_useFilteredListState as me, useListState as De } from "./ui-components-library165.js";
import { useLocale as ve } from "./ui-components-library130.js";
import { useCollator as xe } from "./ui-components-library166.js";
import { ListKeyboardDelegate as ye } from "./ui-components-library167.js";
import { useListBox as Pe } from "./ui-components-library168.js";
import { useOption as Se } from "./ui-components-library169.js";
import { useListBoxSection as he } from "./ui-components-library170.js";
import { useFocusRing as Ce } from "./ui-components-library126.js";
import { FocusScope as Le } from "./ui-components-library171.js";
import { useHover as ke } from "./ui-components-library127.js";
const G = /* @__PURE__ */ q(null), L = /* @__PURE__ */ q(null), ot = /* @__PURE__ */ j(function(e, o) {
  [e, o] = re(e, o, G);
  let a = p(L);
  return a ? /* @__PURE__ */ d.createElement(J, {
    state: a,
    props: e,
    listBoxRef: o
  }) : /* @__PURE__ */ d.createElement(pe, {
    content: /* @__PURE__ */ d.createElement($e, e)
  }, (l) => /* @__PURE__ */ d.createElement(Ee, {
    props: e,
    listBoxRef: o,
    collection: l
  }));
});
function Ee({ props: r, listBoxRef: e, collection: o }) {
  r = {
    ...r,
    collection: o,
    children: null,
    items: null
  };
  let { layoutDelegate: a } = p(H), l = De({
    ...r,
    layoutDelegate: a
  });
  return /* @__PURE__ */ d.createElement(J, {
    state: l,
    props: r,
    listBoxRef: e
  });
}
function J({ state: r, props: e, listBoxRef: o }) {
  let { filter: a, collectionProps: l, collectionRef: n } = p(ue) || {};
  e = B(() => l ? {
    ...e,
    ...l
  } : e, [
    e,
    l
  ]);
  let { dragAndDropHooks: t, layout: f = "stack", orientation: $ = "vertical" } = e;
  o = w(B(() => be(o, n !== void 0 ? n : null), [
    n,
    o
  ]));
  let u = me(r, a), { collection: s, selectionManager: g } = u, i = !!(t != null && t.useDraggableCollectionState), b = !!(t != null && t.useDroppableCollectionState), { direction: D } = ve(), { disabledBehavior: m, disabledKeys: c } = g, x = xe({
    usage: "search",
    sensitivity: "base"
  }), { isVirtualized: y, layoutDelegate: P, dropTargetDelegate: Q, CollectionRoot: X } = p(H), A = B(() => e.keyboardDelegate || new ye({
    collection: s,
    collator: x,
    ref: o,
    disabledKeys: c,
    disabledBehavior: m,
    layout: f,
    orientation: $,
    direction: D,
    layoutDelegate: P
  }), [
    s,
    x,
    o,
    m,
    c,
    $,
    D,
    e.keyboardDelegate,
    f,
    P
  ]), { listBoxProps: Y } = Pe({
    ...e,
    shouldSelectOnPressUp: i || e.shouldSelectOnPressUp,
    keyboardDelegate: A,
    isVirtualized: y
  }, u, o), Z = I(i), ee = I(b);
  W(() => {
    Z.current !== i && console.warn("Drag hooks were provided during one render, but not another. This should be avoided as it may produce unexpected behavior."), ee.current !== b && console.warn("Drop hooks were provided during one render, but not another. This should be avoided as it may produce unexpected behavior.");
  }, [
    i,
    b
  ]);
  let k, v, S, E = !1, M = null, F = I(null);
  if (i && t) {
    k = t.useDraggableCollectionState({
      collection: s,
      selectionManager: g,
      preview: t.renderDragPreview ? F : void 0
    }), t.useDraggableCollection({}, k, o);
    let T = t.DragPreview;
    M = t.renderDragPreview ? /* @__PURE__ */ d.createElement(T, {
      ref: F
    }, t.renderDragPreview) : null;
  }
  if (b && t) {
    v = t.useDroppableCollectionState({
      collection: s,
      selectionManager: g
    });
    let T = t.dropTargetDelegate || Q || new t.ListDropTargetDelegate(s, o, {
      orientation: $,
      layout: f,
      direction: D
    });
    S = t.useDroppableCollection({
      keyboardDelegate: A,
      dropTargetDelegate: T
    }, v, o), E = v.isDropTarget({
      type: "root"
    });
  }
  let { focusProps: te, isFocused: R, isFocusVisible: V } = Ce(), N = {
    isDropTarget: E,
    isEmpty: u.collection.size === 0,
    isFocused: R,
    isFocusVisible: V,
    layout: e.layout || "stack",
    state: u
  }, oe = h({
    className: e.className,
    style: e.style,
    defaultClassName: "react-aria-ListBox",
    values: N
  }), _ = null;
  return u.collection.size === 0 && e.renderEmptyState && (_ = /* @__PURE__ */ d.createElement("div", {
    // eslint-disable-next-line
    role: "option",
    style: {
      display: "contents"
    }
  }, e.renderEmptyState(N))), /* @__PURE__ */ d.createElement(Le, null, /* @__PURE__ */ d.createElement("div", {
    ...U(e),
    ...O(Y, te, S == null ? void 0 : S.collectionProps),
    ...oe,
    ref: o,
    slot: e.slot || void 0,
    onScroll: e.onScroll,
    "data-drop-target": E || void 0,
    "data-empty": u.collection.size === 0 || void 0,
    "data-focused": R || void 0,
    "data-focus-visible": V || void 0,
    "data-layout": e.layout || "stack",
    "data-orientation": e.orientation || "vertical"
  }, /* @__PURE__ */ d.createElement(z, {
    values: [
      [
        G,
        e
      ],
      [
        L,
        u
      ],
      [
        C,
        {
          dragAndDropHooks: t,
          dragState: k,
          dropState: v
        }
      ],
      [
        ce,
        {
          elementType: "div"
        }
      ],
      [
        ie,
        {
          render: Be
        }
      ],
      [
        ae,
        {
          name: "ListBoxSection",
          render: Te
        }
      ]
    ]
  }, /* @__PURE__ */ d.createElement(X, {
    collection: s,
    scrollRef: o,
    persistedKeys: ne(g, t, v),
    renderDropIndicator: K(t, v)
  })), _, M));
}
function Te(r, e, o, a = "react-aria-ListBoxSection") {
  let l = p(L), { dragAndDropHooks: n, dropState: t } = p(C), { CollectionBranch: f } = p(H), [$, u] = le();
  var s;
  let { headingProps: g, groupProps: i } = he({
    heading: u,
    "aria-label": (s = r["aria-label"]) !== null && s !== void 0 ? s : void 0
  }), b = h({
    defaultClassName: a,
    className: r.className,
    style: r.style,
    values: {}
  });
  return /* @__PURE__ */ d.createElement("section", {
    ...U(r),
    ...i,
    ...b,
    ref: e
  }, /* @__PURE__ */ d.createElement(se.Provider, {
    value: {
      ...g,
      ref: $
    }
  }, /* @__PURE__ */ d.createElement(f, {
    collection: l.collection,
    parent: o,
    renderDropIndicator: K(n, t)
  })));
}
const at = /* @__PURE__ */ ge("item", function(e, o, a) {
  let l = w(o), n = p(L), { dragAndDropHooks: t, dragState: f, dropState: $ } = p(C), { optionProps: u, labelProps: s, descriptionProps: g, ...i } = Se({
    key: a.key,
    "aria-label": e == null ? void 0 : e["aria-label"]
  }, n, l), { hoverProps: b, isHovered: D } = ke({
    isDisabled: !i.allowsSelection && !i.hasAction,
    onHoverStart: a.props.onHoverStart,
    onHoverChange: a.props.onHoverChange,
    onHoverEnd: a.props.onHoverEnd
  }), m = null;
  f && t && (m = t.useDraggableItem({
    key: a.key
  }, f));
  let c = null;
  $ && t && (c = t.useDroppableItem({
    target: {
      type: "item",
      key: a.key,
      dropPosition: "on"
    }
  }, $, l));
  let x = f && f.isDragging(a.key), y = h({
    ...e,
    id: void 0,
    children: e.children,
    defaultClassName: "react-aria-ListBoxItem",
    values: {
      ...i,
      isHovered: D,
      selectionMode: n.selectionManager.selectionMode,
      selectionBehavior: n.selectionManager.selectionBehavior,
      allowsDragging: !!f,
      isDragging: x,
      isDropTarget: c == null ? void 0 : c.isDropTarget
    }
  });
  W(() => {
    a.textValue || console.warn("A `textValue` prop is required for <ListBoxItem> elements with non-plain text children in order to support accessibility features such as type to select.");
  }, [
    a.textValue
  ]);
  let P = e.href ? "a" : "div";
  return /* @__PURE__ */ d.createElement(P, {
    ...O(u, b, m == null ? void 0 : m.dragProps, c == null ? void 0 : c.dropProps),
    ...y,
    ref: l,
    "data-allows-dragging": !!f || void 0,
    "data-selected": i.isSelected || void 0,
    "data-disabled": i.isDisabled || void 0,
    "data-hovered": D || void 0,
    "data-focused": i.isFocused || void 0,
    "data-focus-visible": i.isFocusVisible || void 0,
    "data-pressed": i.isPressed || void 0,
    "data-dragging": x || void 0,
    "data-drop-target": (c == null ? void 0 : c.isDropTarget) || void 0,
    "data-selection-mode": n.selectionManager.selectionMode === "none" ? void 0 : n.selectionManager.selectionMode
  }, /* @__PURE__ */ d.createElement(z, {
    values: [
      [
        fe,
        {
          slots: {
            [de]: s,
            label: s,
            description: g
          }
        }
      ]
    ]
  }, y.children));
});
function Be(r, e) {
  e = w(e);
  let { dragAndDropHooks: o, dropState: a } = p(C), { dropIndicatorProps: l, isHidden: n, isDropTarget: t } = o.useDropIndicator(r, a, e);
  return n ? null : /* @__PURE__ */ d.createElement(He, {
    ...r,
    dropIndicatorProps: l,
    isDropTarget: t,
    ref: e
  });
}
function Ie(r, e) {
  let { dropIndicatorProps: o, isDropTarget: a, ...l } = r, n = h({
    ...l,
    defaultClassName: "react-aria-DropIndicator",
    values: {
      isDropTarget: a
    }
  });
  return /* @__PURE__ */ d.createElement("div", {
    ...o,
    ...n,
    // eslint-disable-next-line
    role: "option",
    ref: e,
    "data-drop-target": a || void 0
  });
}
const He = /* @__PURE__ */ j(Ie);
export {
  ot as ListBox,
  G as ListBoxContext,
  at as ListBoxItem,
  L as ListStateContext
};
