import { useControlledState as Q } from "./ui-components-library207.js";
import { snapValueToStep as u, clamp as y } from "./ui-components-library180.js";
import { useFormValidationState as U } from "./ui-components-library366.js";
import { NumberFormatter as C } from "./ui-components-library373.js";
import { NumberParser as W } from "./ui-components-library374.js";
import { useState as w, useMemo as p, useCallback as X } from "react";
function ie($) {
  let { minValue: e, maxValue: t, step: n, formatOptions: c, value: l, defaultValue: o = NaN, onChange: M, locale: r, isDisabled: S, isReadOnly: O } = $;
  l === null && (l = NaN), l !== void 0 && !isNaN(l) && (n !== void 0 && !isNaN(n) ? l = u(l, e, t, n) : l = y(l, e, t)), isNaN(o) || (n !== void 0 && !isNaN(n) ? o = u(o, e, t, n) : o = y(o, e, t));
  let [m, f] = Q(l, isNaN(o) ? NaN : o, M), [V, d] = w(() => isNaN(m) ? "" : new C(r, c).format(m)), b = p(() => new W(r, c), [
    r,
    c
  ]), F = p(() => b.getNumberingSystem(V), [
    b,
    V
  ]), D = p(() => new C(r, {
    ...c,
    numberingSystem: F
  }), [
    r,
    c,
    F
  ]), I = p(() => D.resolvedOptions(), [
    D
  ]), N = X((a) => isNaN(a) || a === null ? "" : D.format(a), [
    D
  ]), x = U({
    ...$,
    value: m
  }), s = n !== void 0 && !isNaN(n) ? n : 1;
  I.style === "percent" && (n === void 0 || isNaN(n)) && (s = 0.01);
  let [L, R] = w(m), [j, k] = w(r), [q, z] = w(c);
  (!Object.is(m, L) || r !== j || c !== q) && (d(N(m)), R(m), k(r), z(c));
  let i = p(() => b.parse(V), [
    b,
    V
  ]), A = () => {
    if (!V.length) {
      f(NaN), d(l === void 0 ? "" : N(m));
      return;
    }
    if (isNaN(i)) {
      d(N(m));
      return;
    }
    let a;
    n === void 0 || isNaN(n) ? a = y(i, e, t) : a = u(i, e, t, n), a = b.parse(N(a)), f(a), d(N(l === void 0 ? a : m));
  }, T = (a, v = 0) => {
    let g = i;
    if (isNaN(g)) {
      let h = isNaN(v) ? 0 : v;
      return u(h, e, t, s);
    } else {
      let h = u(g, e, t, s);
      return a === "+" && h > g || a === "-" && h < g ? h : u(P(a, g, s), e, t, s);
    }
  }, B = () => {
    let a = T("+", e);
    a === m && d(N(a)), f(a), x.commitValidation();
  }, E = () => {
    let a = T("-", t);
    a === m && d(N(a)), f(a), x.commitValidation();
  }, G = () => {
    t != null && (f(u(t, e, t, s)), x.commitValidation());
  }, H = () => {
    e != null && (f(e), x.commitValidation());
  }, J = p(() => !S && !O && (isNaN(i) || t === void 0 || isNaN(t) || u(i, e, t, s) > i || P("+", i, s) <= t), [
    S,
    O,
    e,
    t,
    s,
    i
  ]), K = p(() => !S && !O && (isNaN(i) || e === void 0 || isNaN(e) || u(i, e, t, s) < i || P("-", i, s) >= e), [
    S,
    O,
    e,
    t,
    s,
    i
  ]);
  return {
    ...x,
    validate: (a) => b.isValidPartialNumber(a, e, t),
    increment: B,
    incrementToMax: G,
    decrement: E,
    decrementToMin: H,
    canIncrement: J,
    canDecrement: K,
    minValue: e,
    maxValue: t,
    numberValue: i,
    setNumberValue: f,
    setInputValue: d,
    inputValue: V,
    commit: A
  };
}
function P($, e, t) {
  let n = $ === "+" ? e + t : e - t;
  if (e % 1 !== 0 || t % 1 !== 0) {
    const c = e.toString().split("."), l = t.toString().split("."), o = c[1] && c[1].length || 0, M = l[1] && l[1].length || 0, r = Math.pow(10, Math.max(o, M));
    e = Math.round(e * r), t = Math.round(t * r), n = $ === "+" ? e + t : e - t, n /= r;
  }
  return n;
}
export {
  ie as useNumberFieldState
};
