import { sliderData as X, getSliderThumbId as L } from "./ui-components-library424.js";
import { mergeProps as B } from "./ui-components-library123.js";
import { useGlobalListeners as E } from "./ui-components-library280.js";
import { clamp as S } from "./ui-components-library180.js";
import { useRef as x } from "react";
import { setInteractionModality as Y } from "./ui-components-library340.js";
import { useMove as C } from "./ui-components-library345.js";
import { useLabel as V } from "./ui-components-library393.js";
import { useLocale as z } from "./ui-components-library130.js";
function ee(s, r, f) {
  let { labelProps: a, fieldProps: D } = V(s), i = s.orientation === "vertical";
  var g;
  X.set(r, {
    id: (g = a.id) !== null && g !== void 0 ? g : D.id,
    "aria-describedby": s["aria-describedby"],
    "aria-details": s["aria-details"]
  });
  let { direction: _ } = z(), { addGlobalListener: v, removeGlobalListener: $ } = E();
  const t = x(null), M = _ === "rtl", m = x(null), { moveProps: k } = C({
    onMoveStart() {
      m.current = null;
    },
    onMove({ deltaX: e, deltaY: n }) {
      if (!f.current) return;
      let { height: l, width: p } = f.current.getBoundingClientRect(), b = i ? l : p;
      m.current == null && t.current != null && (m.current = r.getThumbPercent(t.current) * b);
      let c = i ? n : e;
      if ((i || M) && (c = -c), m.current += c, t.current != null && f.current) {
        const T = S(m.current / b, 0, 1);
        r.setThumbPercent(t.current, T);
      }
    },
    onMoveEnd() {
      t.current != null && (r.setThumbDragging(t.current, !1), t.current = null);
    }
  });
  let I = x(void 0), P = (e, n, l, p) => {
    if (f.current && !s.isDisabled && r.values.every((b, c) => !r.isThumbDragging(c))) {
      let { height: b, width: c, top: T, left: K } = f.current.getBoundingClientRect(), F = i ? b : c, w = ((i ? p : l) - (i ? T : K)) / F;
      (_ === "rtl" || i) && (w = 1 - w);
      let h = r.getPercentValue(w), o, u = r.values.findIndex((y) => h - y < 0);
      if (u === 0) o = u;
      else if (u === -1) o = r.values.length - 1;
      else {
        let y = r.values[u - 1], G = r.values[u];
        Math.abs(y - h) < Math.abs(G - h) ? o = u - 1 : o = u;
      }
      o >= 0 && r.isThumbEditable(o) ? (e.preventDefault(), t.current = o, r.setFocusedThumb(o), I.current = n, r.setThumbDragging(t.current, !0), r.setThumbValue(o, h), v(window, "mouseup", d, !1), v(window, "touchend", d, !1), v(window, "pointerup", d, !1)) : t.current = null;
    }
  }, d = (e) => {
    var n, l;
    ((l = e.pointerId) !== null && l !== void 0 ? l : (n = e.changedTouches) === null || n === void 0 ? void 0 : n[0].identifier) === I.current && (t.current != null && (r.setThumbDragging(t.current, !1), t.current = null), $(window, "mouseup", d, !1), $(window, "touchend", d, !1), $(window, "pointerup", d, !1));
  };
  return "htmlFor" in a && a.htmlFor && (delete a.htmlFor, a.onClick = () => {
    var e;
    (e = document.getElementById(L(r, 0))) === null || e === void 0 || e.focus(), Y("keyboard");
  }), {
    labelProps: a,
    // The root element of the Slider will have role="group" to group together
    // all the thumb inputs in the Slider.  The label of the Slider will
    // be used to label the group.
    groupProps: {
      role: "group",
      ...D
    },
    trackProps: B({
      onMouseDown(e) {
        e.button !== 0 || e.altKey || e.ctrlKey || e.metaKey || P(e, void 0, e.clientX, e.clientY);
      },
      onPointerDown(e) {
        e.pointerType === "mouse" && (e.button !== 0 || e.altKey || e.ctrlKey || e.metaKey) || P(e, e.pointerId, e.clientX, e.clientY);
      },
      onTouchStart(e) {
        P(e, e.changedTouches[0].identifier, e.changedTouches[0].clientX, e.changedTouches[0].clientY);
      },
      style: {
        position: "relative",
        touchAction: "none"
      }
    }, k),
    outputProps: {
      htmlFor: r.values.map((e, n) => L(r, n)).join(" "),
      "aria-live": "off"
    }
  };
}
export {
  ee as useSlider
};
