import { sliderData as N, getSliderThumbId as O } from "./ui-components-library424.js";
import { mergeProps as k } from "./ui-components-library123.js";
import { focusWithoutScrolling as Q } from "./ui-components-library276.js";
import { useGlobalListeners as X } from "./ui-components-library280.js";
import { useFormReset as Y } from "./ui-components-library293.js";
import { clamp as Z } from "./ui-components-library180.js";
import { useCallback as ee, useEffect as re, useRef as _ } from "react";
import { useKeyboard as ae } from "./ui-components-library343.js";
import { useMove as ie } from "./ui-components-library345.js";
import { useFocusable as te } from "./ui-components-library101.js";
import { useLabel as oe } from "./ui-components-library393.js";
import { useLocale as ne } from "./ui-components-library130.js";
function Te(i, a) {
  let { index: r = 0, isRequired: z, validationState: E, isInvalid: G, trackRef: V, inputRef: u, orientation: M = a.orientation, name: B } = i, l = i.isDisabled || a.isDisabled, d = M === "vertical", { direction: S } = ne(), { addGlobalListener: g, removeGlobalListener: h } = X(), $ = N.get(a);
  var T;
  const { labelProps: q, fieldProps: C } = oe({
    ...i,
    id: O(a, r),
    "aria-labelledby": `${$.id} ${(T = i["aria-labelledby"]) !== null && T !== void 0 ? T : ""}`.trim()
  }), R = a.values[r], b = ee(() => {
    u.current && Q(u.current);
  }, [
    u
  ]), v = a.focusedThumb === r;
  re(() => {
    v && b();
  }, [
    v,
    b
  ]);
  let P = S === "rtl", s = _(null), { keyboardProps: U } = ae({
    onKeyDown(e) {
      let { getThumbMaxValue: t, getThumbMinValue: o, decrementThumb: c, incrementThumb: w, setThumbValue: m, setThumbDragging: f, pageSize: p } = a;
      if (!/^(PageUp|PageDown|Home|End)$/.test(e.key)) {
        e.continuePropagation();
        return;
      }
      switch (e.preventDefault(), f(r, !0), e.key) {
        case "PageUp":
          w(r, p);
          break;
        case "PageDown":
          c(r, p);
          break;
        case "Home":
          m(r, o(r));
          break;
        case "End":
          m(r, t(r));
          break;
      }
      f(r, !1);
    }
  }), { moveProps: j } = ie({
    onMoveStart() {
      s.current = null, a.setThumbDragging(r, !0);
    },
    onMove({ deltaX: e, deltaY: t, pointerType: o, shiftKey: c }) {
      const { getThumbPercent: w, setThumbPercent: m, decrementThumb: f, incrementThumb: p, step: I, pageSize: K } = a;
      if (!V.current) return;
      let { width: W, height: J } = V.current.getBoundingClientRect(), L = d ? J : W;
      if (s.current == null && (s.current = w(r) * L), o === "keyboard")
        e > 0 && P || e < 0 && !P || t > 0 ? f(r, c ? K : I) : p(r, c ? K : I);
      else {
        let D = d ? t : e;
        (d || P) && (D = -D), s.current += D, m(r, Z(s.current / L, 0, 1));
      }
    },
    onMoveEnd() {
      a.setThumbDragging(r, !1);
    }
  });
  a.setThumbEditable(r, !l);
  const { focusableProps: H } = te(k(i, {
    onFocus: () => a.setFocusedThumb(r),
    onBlur: () => a.setFocusedThumb(void 0)
  }), u);
  let F = _(void 0), x = (e) => {
    b(), F.current = e, a.setThumbDragging(r, !0), g(window, "mouseup", n, !1), g(window, "touchend", n, !1), g(window, "pointerup", n, !1);
  }, n = (e) => {
    var t, o;
    ((o = e.pointerId) !== null && o !== void 0 ? o : (t = e.changedTouches) === null || t === void 0 ? void 0 : t[0].identifier) === F.current && (b(), a.setThumbDragging(r, !1), h(window, "mouseup", n, !1), h(window, "touchend", n, !1), h(window, "pointerup", n, !1));
  }, y = a.getThumbPercent(r);
  (d || S === "rtl") && (y = 1 - y);
  let A = l ? {} : k(U, j, {
    onMouseDown: (e) => {
      e.button !== 0 || e.altKey || e.ctrlKey || e.metaKey || x();
    },
    onPointerDown: (e) => {
      e.button !== 0 || e.altKey || e.ctrlKey || e.metaKey || x(e.pointerId);
    },
    onTouchStart: (e) => {
      x(e.changedTouches[0].identifier);
    }
  });
  return Y(u, R, (e) => {
    a.setThumbValue(r, e);
  }), {
    inputProps: k(H, C, {
      type: "range",
      tabIndex: l ? void 0 : 0,
      min: a.getThumbMinValue(r),
      max: a.getThumbMaxValue(r),
      step: a.step,
      value: R,
      name: B,
      disabled: l,
      "aria-orientation": M,
      "aria-valuetext": a.getThumbValueLabel(r),
      "aria-required": z || void 0,
      "aria-invalid": G || E === "invalid" || void 0,
      "aria-errormessage": i["aria-errormessage"],
      "aria-describedby": [
        $["aria-describedby"],
        i["aria-describedby"]
      ].filter(Boolean).join(" "),
      "aria-details": [
        $["aria-details"],
        i["aria-details"]
      ].filter(Boolean).join(" "),
      onChange: (e) => {
        a.setThumbValue(r, parseFloat(e.target.value));
      }
    }),
    thumbProps: {
      ...A,
      style: {
        position: "absolute",
        [d ? "top" : "left"]: `${y * 100}%`,
        transform: "translate(-50%, -50%)",
        touchAction: "none"
      }
    },
    labelProps: q,
    isDragging: a.isThumbDragging(r),
    isDisabled: l,
    isFocused: v
  };
}
export {
  Te as useSliderThumb
};
