import { calculatePosition as D } from "./ui-components-library411.js";
import { useCloseOnScroll as G } from "./ui-components-library412.js";
import { useState as J, useRef as U, useEffect as K, useCallback as j } from "react";
import { useLayoutEffect as z } from "./ui-components-library142.js";
import { useResizeObserver as k } from "./ui-components-library147.js";
import { useLocale as M } from "./ui-components-library130.js";
let e = typeof document < "u" ? window.visualViewport : null;
function te(n) {
  let { direction: y } = M(), { arrowSize: w = 0, targetRef: c, overlayRef: i, scrollRef: s = i, placement: H = "bottom", containerPadding: P = 12, shouldFlip: L = !0, boundaryElement: b = typeof document < "u" ? document.body : null, offset: C = 0, crossOffset: B = 0, shouldUpdatePosition: S = !0, isOpen: v = !0, onClose: p, maxHeight: $, arrowBoundaryOffset: T = 0 } = n, [t, I] = J(null), F = [
    S,
    H,
    i.current,
    c.current,
    s.current,
    P,
    L,
    b,
    C,
    B,
    v,
    y,
    $,
    T,
    w
  ], N = U(e == null ? void 0 : e.scale);
  K(() => {
    v && (N.current = e == null ? void 0 : e.scale);
  }, [
    v
  ]);
  let a = j(() => {
    if (S === !1 || !v || !i.current || !c.current || !b || (e == null ? void 0 : e.scale) !== N.current) return;
    let o = null;
    if (s.current && s.current.contains(document.activeElement)) {
      var d;
      let r = (d = document.activeElement) === null || d === void 0 ? void 0 : d.getBoundingClientRect(), g = s.current.getBoundingClientRect();
      var u;
      if (o = {
        type: "top",
        offset: ((u = r == null ? void 0 : r.top) !== null && u !== void 0 ? u : 0) - g.top
      }, o.offset > g.height / 2) {
        o.type = "bottom";
        var R;
        o.offset = ((R = r == null ? void 0 : r.bottom) !== null && R !== void 0 ? R : 0) - g.bottom;
      }
    }
    let l = i.current;
    if (!$ && i.current) {
      var O;
      l.style.top = "0px", l.style.bottom = "";
      var E;
      l.style.maxHeight = ((E = (O = window.visualViewport) === null || O === void 0 ? void 0 : O.height) !== null && E !== void 0 ? E : window.innerHeight) + "px";
    }
    let f = D({
      placement: W(H, y),
      overlayNode: i.current,
      targetNode: c.current,
      scrollNode: s.current || i.current,
      padding: P,
      shouldFlip: L,
      boundaryElement: b,
      offset: C,
      crossOffset: B,
      maxHeight: $,
      arrowSize: w,
      arrowBoundaryOffset: T
    });
    if (f.position) {
      if (l.style.top = "", l.style.bottom = "", l.style.left = "", l.style.right = "", Object.keys(f.position).forEach((r) => l.style[r] = f.position[r] + "px"), l.style.maxHeight = f.maxHeight != null ? f.maxHeight + "px" : "", o && document.activeElement && s.current) {
        let r = document.activeElement.getBoundingClientRect(), g = s.current.getBoundingClientRect(), A = r[o.type] - g[o.type];
        s.current.scrollTop += A - o.offset;
      }
      I(f);
    }
  }, F);
  z(a, F), Q(a), k({
    ref: i,
    onResize: a
  }), k({
    ref: c,
    onResize: a
  });
  let m = U(!1);
  z(() => {
    let o, d = () => {
      m.current = !0, clearTimeout(o), o = setTimeout(() => {
        m.current = !1;
      }, 500), a();
    }, u = () => {
      m.current && d();
    };
    return e == null || e.addEventListener("resize", d), e == null || e.addEventListener("scroll", u), () => {
      e == null || e.removeEventListener("resize", d), e == null || e.removeEventListener("scroll", u);
    };
  }, [
    a
  ]);
  let q = j(() => {
    m.current || p == null || p();
  }, [
    p,
    m
  ]);
  G({
    triggerRef: c,
    isOpen: v,
    onClose: p && q
  });
  var x, h;
  return {
    overlayProps: {
      style: {
        position: "absolute",
        zIndex: 1e5,
        ...t == null ? void 0 : t.position,
        maxHeight: (x = t == null ? void 0 : t.maxHeight) !== null && x !== void 0 ? x : "100vh"
      }
    },
    placement: (h = t == null ? void 0 : t.placement) !== null && h !== void 0 ? h : null,
    arrowProps: {
      "aria-hidden": "true",
      role: "presentation",
      style: {
        left: t == null ? void 0 : t.arrowOffsetLeft,
        top: t == null ? void 0 : t.arrowOffsetTop
      }
    },
    updatePosition: a
  };
}
function Q(n) {
  z(() => (window.addEventListener("resize", n, !1), () => {
    window.removeEventListener("resize", n, !1);
  }), [
    n
  ]);
}
function W(n, y) {
  return y === "rtl" ? n.replace("start", "right").replace("end", "left") : n.replace("start", "left").replace("end", "right");
}
export {
  te as useOverlayPosition
};
