class a {
  get childNodes() {
    throw new Error("childNodes is not supported");
  }
  clone() {
    let t = new a(this.type, this.key);
    return t.value = this.value, t.level = this.level, t.hasChildNodes = this.hasChildNodes, t.rendered = this.rendered, t.textValue = this.textValue, t["aria-label"] = this["aria-label"], t.index = this.index, t.parentKey = this.parentKey, t.prevKey = this.prevKey, t.nextKey = this.nextKey, t.firstChildKey = this.firstChildKey, t.lastChildKey = this.lastChildKey, t.props = this.props, t.render = this.render, t.colSpan = this.colSpan, t.colIndex = this.colIndex, t;
  }
  constructor(t, e) {
    this.value = null, this.level = 0, this.hasChildNodes = !1, this.rendered = null, this.textValue = "", this["aria-label"] = void 0, this.index = 0, this.parentKey = null, this.prevKey = null, this.nextKey = null, this.firstChildKey = null, this.lastChildKey = null, this.props = {}, this.colSpan = null, this.colIndex = null, this.type = t, this.key = e;
  }
}
class d {
  get size() {
    return this.keyMap.size;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  *[Symbol.iterator]() {
    let t = this.firstKey != null ? this.keyMap.get(this.firstKey) : void 0;
    for (; t; )
      yield t, t = t.nextKey != null ? this.keyMap.get(t.nextKey) : void 0;
  }
  getChildren(t) {
    let e = this.keyMap;
    return {
      *[Symbol.iterator]() {
        let l = e.get(t), n = (l == null ? void 0 : l.firstChildKey) != null ? e.get(l.firstChildKey) : null;
        for (; n; )
          yield n, n = n.nextKey != null ? e.get(n.nextKey) : void 0;
      }
    };
  }
  getKeyBefore(t) {
    let e = this.keyMap.get(t);
    if (!e) return null;
    if (e.prevKey != null) {
      for (e = this.keyMap.get(e.prevKey); e && e.type !== "item" && e.lastChildKey != null; ) e = this.keyMap.get(e.lastChildKey);
      var l;
      return (l = e == null ? void 0 : e.key) !== null && l !== void 0 ? l : null;
    }
    return e.parentKey;
  }
  getKeyAfter(t) {
    let e = this.keyMap.get(t);
    if (!e) return null;
    if (e.type !== "item" && e.firstChildKey != null) return e.firstChildKey;
    for (; e; ) {
      if (e.nextKey != null) return e.nextKey;
      if (e.parentKey != null) e = this.keyMap.get(e.parentKey);
      else return null;
    }
    return null;
  }
  getFirstKey() {
    return this.firstKey;
  }
  getLastKey() {
    let t = this.lastKey != null ? this.keyMap.get(this.lastKey) : null;
    for (; (t == null ? void 0 : t.lastChildKey) != null; ) t = this.keyMap.get(t.lastChildKey);
    var e;
    return (e = t == null ? void 0 : t.key) !== null && e !== void 0 ? e : null;
  }
  getItem(t) {
    var e;
    return (e = this.keyMap.get(t)) !== null && e !== void 0 ? e : null;
  }
  at() {
    throw new Error("Not implemented");
  }
  clone() {
    let t = this.constructor, e = new t();
    return e.keyMap = new Map(this.keyMap), e.firstKey = this.firstKey, e.lastKey = this.lastKey, e;
  }
  addNode(t) {
    if (this.frozen) throw new Error("Cannot add a node to a frozen collection");
    this.keyMap.set(t.key, t);
  }
  removeNode(t) {
    if (this.frozen) throw new Error("Cannot remove a node to a frozen collection");
    this.keyMap.delete(t);
  }
  commit(t, e, l = !1) {
    if (this.frozen) throw new Error("Cannot commit a frozen collection");
    this.firstKey = t, this.lastKey = e, this.frozen = !l;
  }
  // TODO: this is pretty specific to menu, will need to check if it is generic enough
  // Will need to handle varying levels I assume but will revisit after I get searchable menu working for base menu
  // TODO: an alternative is to simply walk the collection and add all item nodes that match the filter and any sections/separators we encounter
  // to an array, then walk that new array and fix all the next/Prev keys while adding them to the new collection
  UNSTABLE_filter(t) {
    let e = new d(), l = null;
    for (let n of this)
      if (n.type === "section" && n.hasChildNodes) {
        let i = n.clone(), r = null;
        for (let o of this.getChildren(n.key)) if (h(o, t, this, e)) {
          let s = o.clone();
          r == null && (i.firstChildKey = s.key), e.firstKey == null && (e.firstKey = i.key), r && r.parentKey === s.parentKey ? (r.nextKey = s.key, s.prevKey = r.key) : s.prevKey = null, s.nextKey = null, e.addNode(s), r = s;
        }
        r && (r.type !== "header" ? (i.lastChildKey = r.key, l == null ? i.prevKey = null : (l.type === "section" || l.type === "separator") && (l.nextKey = i.key, i.prevKey = l.key), i.nextKey = null, l = i, e.addNode(i)) : (e.firstKey === i.key && (e.firstKey = null), e.removeNode(r.key)));
      } else if (n.type === "separator") {
        let i = n.clone();
        i.nextKey = null, (l == null ? void 0 : l.type) === "section" && (l.nextKey = i.key, i.prevKey = l.key, l = i, e.addNode(i));
      } else {
        let i = n.clone();
        h(i, t, this, e) && (e.firstKey == null && (e.firstKey = i.key), l != null && l.type !== "section" && l.type !== "separator" && l.parentKey === i.parentKey ? (l.nextKey = i.key, i.prevKey = l.key) : i.prevKey = null, i.nextKey = null, e.addNode(i), l = i);
      }
    if ((l == null ? void 0 : l.type) === "separator" && l.nextKey === null) {
      let n;
      l.prevKey != null && (n = e.getItem(l.prevKey), n.nextKey = null), e.removeNode(l.key), l = n;
    }
    return e.lastKey = (l == null ? void 0 : l.key) || null, e;
  }
  constructor() {
    this.keyMap = /* @__PURE__ */ new Map(), this.firstKey = null, this.lastKey = null, this.frozen = !1;
  }
}
function h(y, t, e, l) {
  if (y.type === "subdialogtrigger" || y.type === "submenutrigger") {
    let n = [
      ...e.getChildren(y.key)
    ][0];
    if (n && t(n.textValue)) {
      let i = n.clone();
      return l.addNode(i), !0;
    } else return !1;
  } else return y.type === "header" ? !0 : t(y.textValue);
}
export {
  d as BaseCollection,
  a as CollectionNode
};
