import { CollectionNode as v } from "./ui-components-library265.js";
class p {
  *[Symbol.iterator]() {
    let t = this.firstChild;
    for (; t; )
      yield t, t = t.nextSibling;
  }
  get firstChild() {
    return this._firstChild;
  }
  set firstChild(t) {
    this._firstChild = t, this.ownerDocument.markDirty(this);
  }
  get lastChild() {
    return this._lastChild;
  }
  set lastChild(t) {
    this._lastChild = t, this.ownerDocument.markDirty(this);
  }
  get previousSibling() {
    return this._previousSibling;
  }
  set previousSibling(t) {
    this._previousSibling = t, this.ownerDocument.markDirty(this);
  }
  get nextSibling() {
    return this._nextSibling;
  }
  set nextSibling(t) {
    this._nextSibling = t, this.ownerDocument.markDirty(this);
  }
  get parentNode() {
    return this._parentNode;
  }
  set parentNode(t) {
    this._parentNode = t, this.ownerDocument.markDirty(this);
  }
  get isConnected() {
    var t;
    return ((t = this.parentNode) === null || t === void 0 ? void 0 : t.isConnected) || !1;
  }
  appendChild(t) {
    this.ownerDocument.startTransaction(), t.parentNode && t.parentNode.removeChild(t), this.firstChild == null && (this.firstChild = t), this.lastChild ? (this.lastChild.nextSibling = t, t.index = this.lastChild.index + 1, t.previousSibling = this.lastChild) : (t.previousSibling = null, t.index = 0), t.parentNode = this, t.nextSibling = null, this.lastChild = t, this.ownerDocument.markDirty(this), t.hasSetProps && this.ownerDocument.addNode(t), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  insertBefore(t, i) {
    if (i == null) return this.appendChild(t);
    this.ownerDocument.startTransaction(), t.parentNode && t.parentNode.removeChild(t), t.nextSibling = i, t.previousSibling = i.previousSibling, t.index = i.index, this.firstChild === i ? this.firstChild = t : i.previousSibling && (i.previousSibling.nextSibling = t), i.previousSibling = t, t.parentNode = i.parentNode;
    let n = i;
    for (; n; )
      n.index++, n = n.nextSibling;
    t.hasSetProps && this.ownerDocument.addNode(t), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  removeChild(t) {
    if (t.parentNode !== this || !this.ownerDocument.isMounted) return;
    this.ownerDocument.startTransaction();
    let i = t.nextSibling;
    for (; i; )
      i.index--, i = i.nextSibling;
    t.nextSibling && (t.nextSibling.previousSibling = t.previousSibling), t.previousSibling && (t.previousSibling.nextSibling = t.nextSibling), this.firstChild === t && (this.firstChild = t.nextSibling), this.lastChild === t && (this.lastChild = t.previousSibling), t.parentNode = null, t.nextSibling = null, t.previousSibling = null, t.index = 0, this.ownerDocument.removeNode(t), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  addEventListener() {
  }
  removeEventListener() {
  }
  constructor(t) {
    this._firstChild = null, this._lastChild = null, this._previousSibling = null, this._nextSibling = null, this._parentNode = null, this.ownerDocument = t;
  }
}
class a extends p {
  get index() {
    return this._index;
  }
  set index(t) {
    this._index = t, this.ownerDocument.markDirty(this);
  }
  get level() {
    return this.parentNode instanceof a ? this.parentNode.level + (this.node.type === "item" ? 1 : 0) : 0;
  }
  updateNode() {
    var t, i, n, o;
    let e = this.ownerDocument.getMutableNode(this);
    e.index = this.index, e.level = this.level, e.parentKey = this.parentNode instanceof a ? this.parentNode.node.key : null;
    var l;
    e.prevKey = (l = (t = this.previousSibling) === null || t === void 0 ? void 0 : t.node.key) !== null && l !== void 0 ? l : null;
    var d;
    e.nextKey = (d = (i = this.nextSibling) === null || i === void 0 ? void 0 : i.node.key) !== null && d !== void 0 ? d : null, e.hasChildNodes = !!this.firstChild;
    var r;
    e.firstChildKey = (r = (n = this.firstChild) === null || n === void 0 ? void 0 : n.node.key) !== null && r !== void 0 ? r : null;
    var s;
    if (e.lastChildKey = (s = (o = this.lastChild) === null || o === void 0 ? void 0 : o.node.key) !== null && s !== void 0 ? s : null, (e.colSpan != null || e.colIndex != null) && this.nextSibling) {
      var h, u;
      let c = ((h = e.colIndex) !== null && h !== void 0 ? h : e.index) + ((u = e.colSpan) !== null && u !== void 0 ? u : 1);
      if (c !== this.nextSibling.node.colIndex) {
        let b = this.ownerDocument.getMutableNode(this.nextSibling);
        b.colIndex = c;
      }
    }
  }
  setProps(t, i, n, o) {
    let e = this.ownerDocument.getMutableNode(this), { value: l, textValue: d, id: r, ...s } = t;
    if (s.ref = i, e.props = s, e.rendered = n, e.render = o, e.value = l, e.textValue = d || (typeof s.children == "string" ? s.children : "") || t["aria-label"] || "", r != null && r !== e.key) {
      if (this.hasSetProps) throw new Error("Cannot change the id of an item");
      e.key = r;
    }
    s.colSpan != null && (e.colSpan = s.colSpan), this.hasSetProps || (this.ownerDocument.addNode(this), this.ownerDocument.endTransaction(), this.hasSetProps = !0), this.ownerDocument.queueUpdate();
  }
  get style() {
    return {};
  }
  hasAttribute() {
  }
  setAttribute() {
  }
  setAttributeNS() {
  }
  removeAttribute() {
  }
  constructor(t, i) {
    super(i), this.nodeType = 8, this._index = 0, this.hasSetProps = !1, this.node = new v(t, `react-aria-${++i.nodeId}`), this.ownerDocument.startTransaction();
  }
}
class f extends p {
  get isConnected() {
    return this.isMounted;
  }
  createElement(t) {
    return new a(t, this);
  }
  /**
  * Lazily gets a mutable instance of a Node. If the node has already
  * been cloned during this update cycle, it just returns the existing one.
  */
  getMutableNode(t) {
    let i = t.node;
    return this.mutatedNodes.has(t) || (i = t.node.clone(), this.mutatedNodes.add(t), t.node = i), this.markDirty(t), i;
  }
  getMutableCollection() {
    return !this.isSSR && !this.collectionMutated && (this.collection = this.collection.clone(), this.collectionMutated = !0), this.collection;
  }
  markDirty(t) {
    this.dirtyNodes.add(t);
  }
  startTransaction() {
    this.transactionCount++;
  }
  endTransaction() {
    this.transactionCount--;
  }
  addNode(t) {
    let i = this.getMutableCollection();
    if (!i.getItem(t.node.key)) {
      i.addNode(t.node);
      for (let n of t) this.addNode(n);
    }
    this.markDirty(t);
  }
  removeNode(t) {
    for (let n of t) this.removeNode(n);
    this.getMutableCollection().removeNode(t.node.key), this.markDirty(t);
  }
  /** Finalizes the collection update, updating all nodes and freezing the collection. */
  getCollection() {
    return this.transactionCount > 0 ? this.collection : (this.updateCollection(), this.collection);
  }
  updateCollection() {
    for (let e of this.dirtyNodes) e instanceof a && e.isConnected && e.updateNode();
    if (this.dirtyNodes.clear(), this.mutatedNodes.size || this.collectionMutated) {
      var t, i;
      let e = this.getMutableCollection();
      for (let l of this.mutatedNodes) l.isConnected && e.addNode(l.node);
      this.mutatedNodes.clear();
      var n, o;
      e.commit((n = (t = this.firstChild) === null || t === void 0 ? void 0 : t.node.key) !== null && n !== void 0 ? n : null, (o = (i = this.lastChild) === null || i === void 0 ? void 0 : i.node.key) !== null && o !== void 0 ? o : null, this.isSSR);
    }
    this.collectionMutated = !1;
  }
  queueUpdate() {
    if (!(this.dirtyNodes.size === 0 || this.transactionCount > 0))
      for (let t of this.subscriptions) t();
  }
  subscribe(t) {
    return this.subscriptions.add(t), () => this.subscriptions.delete(t);
  }
  resetAfterSSR() {
    this.isSSR && (this.isSSR = !1, this.firstChild = null, this.lastChild = null, this.nodeId = 0);
  }
  constructor(t) {
    super(null), this.nodeType = 11, this.ownerDocument = this, this.dirtyNodes = /* @__PURE__ */ new Set(), this.isSSR = !1, this.nodeId = 0, this.nodesByProps = /* @__PURE__ */ new WeakMap(), this.isMounted = !0, this.mutatedNodes = /* @__PURE__ */ new Set(), this.subscriptions = /* @__PURE__ */ new Set(), this.transactionCount = 0, this.collection = t, this.collectionMutated = !0;
  }
}
export {
  p as BaseNode,
  f as Document,
  a as ElementNode
};
