import { addZoned as Z, subtractZoned as k, setZoned as C, cycleZoned as M, constrain as $, addTime as W, subtractTime as z, setTime as u, cycleTime as l, constrainTime as A, add as m, subtract as p, set as y, cycleDate as b } from "./ui-components-library297.js";
import { compareTime as x, compareDate as T } from "./ui-components-library80.js";
import { zonedDateTimeToString as g, timeToString as j, dateToString as E, dateTimeToString as G } from "./ui-components-library298.js";
import { GregorianCalendar as I } from "./ui-components-library299.js";
import { zonedToDate as O, toZoned as _, toDate as v, toCalendarDateTime as q } from "./ui-components-library300.js";
import { _class_private_field_init as d } from "./ui-components-library301.js";
function f(a) {
  let t = typeof a[0] == "object" ? a.shift() : new I(), e;
  if (typeof a[0] == "string") e = a.shift();
  else {
    let r = t.getEras();
    e = r[r.length - 1];
  }
  let i = a.shift(), s = a.shift(), h = a.shift();
  return [
    t,
    e,
    i,
    s,
    h
  ];
}
var B = /* @__PURE__ */ new WeakMap();
class c {
  /** Returns a copy of this date. */
  copy() {
    return this.era ? new c(this.calendar, this.era, this.year, this.month, this.day) : new c(this.calendar, this.year, this.month, this.day);
  }
  /** Returns a new `CalendarDate` with the given duration added to it. */
  add(t) {
    return m(this, t);
  }
  /** Returns a new `CalendarDate` with the given duration subtracted from it. */
  subtract(t) {
    return p(this, t);
  }
  /** Returns a new `CalendarDate` with the given fields set to the provided values. Other fields will be constrained accordingly. */
  set(t) {
    return y(this, t);
  }
  /**
  * Returns a new `CalendarDate` with the given field adjusted by a specified amount.
  * When the resulting value reaches the limits of the field, it wraps around.
  */
  cycle(t, e, i) {
    return b(this, t, e, i);
  }
  /** Converts the date to a native JavaScript Date object, with the time set to midnight in the given time zone. */
  toDate(t) {
    return v(this, t);
  }
  /** Converts the date to an ISO 8601 formatted string. */
  toString() {
    return E(this);
  }
  /** Compares this date with another. A negative result indicates that this date is before the given one, and a positive date indicates that it is after. */
  compare(t) {
    return T(this, t);
  }
  constructor(...t) {
    d(this, B, {
      writable: !0,
      value: void 0
    });
    let [e, i, s, h, r] = f(t);
    this.calendar = e, this.era = i, this.year = s, this.month = h, this.day = r, $(this);
  }
}
var F = /* @__PURE__ */ new WeakMap();
class w {
  /** Returns a copy of this time. */
  copy() {
    return new w(this.hour, this.minute, this.second, this.millisecond);
  }
  /** Returns a new `Time` with the given duration added to it. */
  add(t) {
    return W(this, t);
  }
  /** Returns a new `Time` with the given duration subtracted from it. */
  subtract(t) {
    return z(this, t);
  }
  /** Returns a new `Time` with the given fields set to the provided values. Other fields will be constrained accordingly. */
  set(t) {
    return u(this, t);
  }
  /**
  * Returns a new `Time` with the given field adjusted by a specified amount.
  * When the resulting value reaches the limits of the field, it wraps around.
  */
  cycle(t, e, i) {
    return l(this, t, e, i);
  }
  /** Converts the time to an ISO 8601 formatted string. */
  toString() {
    return j(this);
  }
  /** Compares this time with another. A negative result indicates that this time is before the given one, and a positive time indicates that it is after. */
  compare(t) {
    return x(this, t);
  }
  constructor(t = 0, e = 0, i = 0, s = 0) {
    d(this, F, {
      writable: !0,
      value: void 0
    }), this.hour = t, this.minute = e, this.second = i, this.millisecond = s, A(this);
  }
}
var H = /* @__PURE__ */ new WeakMap();
class n {
  /** Returns a copy of this date. */
  copy() {
    return this.era ? new n(this.calendar, this.era, this.year, this.month, this.day, this.hour, this.minute, this.second, this.millisecond) : new n(this.calendar, this.year, this.month, this.day, this.hour, this.minute, this.second, this.millisecond);
  }
  /** Returns a new `CalendarDateTime` with the given duration added to it. */
  add(t) {
    return m(this, t);
  }
  /** Returns a new `CalendarDateTime` with the given duration subtracted from it. */
  subtract(t) {
    return p(this, t);
  }
  /** Returns a new `CalendarDateTime` with the given fields set to the provided values. Other fields will be constrained accordingly. */
  set(t) {
    return y(u(this, t), t);
  }
  /**
  * Returns a new `CalendarDateTime` with the given field adjusted by a specified amount.
  * When the resulting value reaches the limits of the field, it wraps around.
  */
  cycle(t, e, i) {
    switch (t) {
      case "era":
      case "year":
      case "month":
      case "day":
        return b(this, t, e, i);
      default:
        return l(this, t, e, i);
    }
  }
  /** Converts the date to a native JavaScript Date object in the given time zone. */
  toDate(t, e) {
    return v(this, t, e);
  }
  /** Converts the date to an ISO 8601 formatted string. */
  toString() {
    return G(this);
  }
  /** Compares this date with another. A negative result indicates that this date is before the given one, and a positive date indicates that it is after. */
  compare(t) {
    let e = T(this, t);
    return e === 0 ? x(this, q(t)) : e;
  }
  constructor(...t) {
    d(this, H, {
      writable: !0,
      value: void 0
    });
    let [e, i, s, h, r] = f(t);
    this.calendar = e, this.era = i, this.year = s, this.month = h, this.day = r, this.hour = t.shift() || 0, this.minute = t.shift() || 0, this.second = t.shift() || 0, this.millisecond = t.shift() || 0, $(this);
  }
}
var J = /* @__PURE__ */ new WeakMap();
class o {
  /** Returns a copy of this date. */
  copy() {
    return this.era ? new o(this.calendar, this.era, this.year, this.month, this.day, this.timeZone, this.offset, this.hour, this.minute, this.second, this.millisecond) : new o(this.calendar, this.year, this.month, this.day, this.timeZone, this.offset, this.hour, this.minute, this.second, this.millisecond);
  }
  /** Returns a new `ZonedDateTime` with the given duration added to it. */
  add(t) {
    return Z(this, t);
  }
  /** Returns a new `ZonedDateTime` with the given duration subtracted from it. */
  subtract(t) {
    return k(this, t);
  }
  /** Returns a new `ZonedDateTime` with the given fields set to the provided values. Other fields will be constrained accordingly. */
  set(t, e) {
    return C(this, t, e);
  }
  /**
  * Returns a new `ZonedDateTime` with the given field adjusted by a specified amount.
  * When the resulting value reaches the limits of the field, it wraps around.
  */
  cycle(t, e, i) {
    return M(this, t, e, i);
  }
  /** Converts the date to a native JavaScript Date object. */
  toDate() {
    return O(this);
  }
  /** Converts the date to an ISO 8601 formatted string, including the UTC offset and time zone identifier. */
  toString() {
    return g(this);
  }
  /** Converts the date to an ISO 8601 formatted string in UTC. */
  toAbsoluteString() {
    return this.toDate().toISOString();
  }
  /** Compares this date with another. A negative result indicates that this date is before the given one, and a positive date indicates that it is after. */
  compare(t) {
    return this.toDate().getTime() - _(t, this.timeZone).toDate().getTime();
  }
  constructor(...t) {
    d(this, J, {
      writable: !0,
      value: void 0
    });
    let [e, i, s, h, r] = f(t), D = t.shift(), S = t.shift();
    this.calendar = e, this.era = i, this.year = s, this.month = h, this.day = r, this.timeZone = D, this.offset = S, this.hour = t.shift() || 0, this.minute = t.shift() || 0, this.second = t.shift() || 0, this.millisecond = t.shift() || 0, $(this);
  }
}
export {
  c as CalendarDate,
  n as CalendarDateTime,
  w as Time,
  o as ZonedDateTime
};
