import { toCalendarDateTime as M, toAbsolute as h, epochFromDate as Y, fromAbsolute as $, toCalendar as i } from "./ui-components-library300.js";
import { GregorianCalendar as Z } from "./ui-components-library299.js";
const y = 36e5;
function k(e, r) {
  let n = e.copy(), a = "hour" in n ? p(n, r) : 0;
  x(n, r.years || 0), n.calendar.balanceYearMonth && n.calendar.balanceYearMonth(n, e), n.month += r.months || 0, D(n), v(n), n.day += (r.weeks || 0) * 7, n.day += r.days || 0, n.day += a, U(n), n.calendar.balanceDate && n.calendar.balanceDate(n), n.year < 1 && (n.year = 1, n.month = 1, n.day = 1);
  let c = n.calendar.getYearsInEra(n);
  if (n.year > c) {
    var l, t;
    let d = (l = (t = n.calendar).isInverseEra) === null || l === void 0 ? void 0 : l.call(t, n);
    n.year = c, n.month = d ? 1 : n.calendar.getMonthsInYear(n), n.day = d ? 1 : n.calendar.getDaysInMonth(n);
  }
  n.month < 1 && (n.month = 1, n.day = 1);
  let o = n.calendar.getMonthsInYear(n);
  return n.month > o && (n.month = o, n.day = n.calendar.getDaysInMonth(n)), n.day = Math.max(1, Math.min(n.calendar.getDaysInMonth(n), n.day)), n;
}
function x(e, r) {
  var n, a;
  !((n = (a = e.calendar).isInverseEra) === null || n === void 0) && n.call(a, e) && (r = -r), e.year += r;
}
function D(e) {
  for (; e.month < 1; )
    x(e, -1), e.month += e.calendar.getMonthsInYear(e);
  let r = 0;
  for (; e.month > (r = e.calendar.getMonthsInYear(e)); )
    e.month -= r, x(e, 1);
}
function U(e) {
  for (; e.day < 1; )
    e.month--, D(e), e.day += e.calendar.getDaysInMonth(e);
  for (; e.day > e.calendar.getDaysInMonth(e); )
    e.day -= e.calendar.getDaysInMonth(e), e.month++, D(e);
}
function v(e) {
  e.month = Math.max(1, Math.min(e.calendar.getMonthsInYear(e), e.month)), e.day = Math.max(1, Math.min(e.calendar.getDaysInMonth(e), e.day));
}
function w(e) {
  e.calendar.constrainDate && e.calendar.constrainDate(e), e.year = Math.max(1, Math.min(e.calendar.getYearsInEra(e), e.year)), v(e);
}
function g(e) {
  let r = {};
  for (let n in e) typeof e[n] == "number" && (r[n] = -e[n]);
  return r;
}
function q(e, r) {
  return k(e, g(r));
}
function O(e, r) {
  let n = e.copy();
  return r.era != null && (n.era = r.era), r.year != null && (n.year = r.year), r.month != null && (n.month = r.month), r.day != null && (n.day = r.day), w(n), n;
}
function I(e, r) {
  let n = e.copy();
  return r.hour != null && (n.hour = r.hour), r.minute != null && (n.minute = r.minute), r.second != null && (n.second = r.second), r.millisecond != null && (n.millisecond = r.millisecond), N(n), n;
}
function F(e) {
  e.second += Math.floor(e.millisecond / 1e3), e.millisecond = b(e.millisecond, 1e3), e.minute += Math.floor(e.second / 60), e.second = b(e.second, 60), e.hour += Math.floor(e.minute / 60), e.minute = b(e.minute, 60);
  let r = Math.floor(e.hour / 24);
  return e.hour = b(e.hour, 24), r;
}
function N(e) {
  e.millisecond = Math.max(0, Math.min(e.millisecond, 1e3)), e.second = Math.max(0, Math.min(e.second, 59)), e.minute = Math.max(0, Math.min(e.minute, 59)), e.hour = Math.max(0, Math.min(e.hour, 23));
}
function b(e, r) {
  let n = e % r;
  return n < 0 && (n += r), n;
}
function p(e, r) {
  return e.hour += r.hours || 0, e.minute += r.minutes || 0, e.second += r.seconds || 0, e.millisecond += r.milliseconds || 0, F(e);
}
function P(e, r) {
  let n = e.copy();
  return p(n, r), n;
}
function z(e, r) {
  return P(e, g(r));
}
function V(e, r, n, a) {
  let c = e.copy();
  switch (r) {
    case "era": {
      let o = e.calendar.getEras(), d = o.indexOf(e.era);
      if (d < 0) throw new Error("Invalid era: " + e.era);
      d = s(d, n, 0, o.length - 1, a == null ? void 0 : a.round), c.era = o[d], w(c);
      break;
    }
    case "year":
      var l, t;
      !((l = (t = c.calendar).isInverseEra) === null || l === void 0) && l.call(t, c) && (n = -n), c.year = s(e.year, n, -1 / 0, 9999, a == null ? void 0 : a.round), c.year === -1 / 0 && (c.year = 1), c.calendar.balanceYearMonth && c.calendar.balanceYearMonth(c, e);
      break;
    case "month":
      c.month = s(e.month, n, 1, e.calendar.getMonthsInYear(e), a == null ? void 0 : a.round);
      break;
    case "day":
      c.day = s(e.day, n, 1, e.calendar.getDaysInMonth(e), a == null ? void 0 : a.round);
      break;
    default:
      throw new Error("Unsupported field " + r);
  }
  return e.calendar.balanceDate && e.calendar.balanceDate(c), w(c), c;
}
function G(e, r, n, a) {
  let c = e.copy();
  switch (r) {
    case "hour": {
      let l = e.hour, t = 0, o = 23;
      if ((a == null ? void 0 : a.hourCycle) === 12) {
        let d = l >= 12;
        t = d ? 12 : 0, o = d ? 23 : 11;
      }
      c.hour = s(l, n, t, o, a == null ? void 0 : a.round);
      break;
    }
    case "minute":
      c.minute = s(e.minute, n, 0, 59, a == null ? void 0 : a.round);
      break;
    case "second":
      c.second = s(e.second, n, 0, 59, a == null ? void 0 : a.round);
      break;
    case "millisecond":
      c.millisecond = s(e.millisecond, n, 0, 999, a == null ? void 0 : a.round);
      break;
    default:
      throw new Error("Unsupported field " + r);
  }
  return c;
}
function s(e, r, n, a, c = !1) {
  if (c) {
    e += Math.sign(r), e < n && (e = a);
    let l = Math.abs(r);
    r > 0 ? e = Math.ceil(e / l) * l : e = Math.floor(e / l) * l, e > a && (e = n);
  } else
    e += r, e < n ? e = a - (n - e - 1) : e > a && (e = n + (e - a - 1));
  return e;
}
function H(e, r) {
  let n;
  if (r.years != null && r.years !== 0 || r.months != null && r.months !== 0 || r.weeks != null && r.weeks !== 0 || r.days != null && r.days !== 0) {
    let c = k(M(e), {
      years: r.years,
      months: r.months,
      weeks: r.weeks,
      days: r.days
    });
    n = h(c, e.timeZone);
  } else
    n = Y(e) - e.offset;
  n += r.milliseconds || 0, n += (r.seconds || 0) * 1e3, n += (r.minutes || 0) * 6e4, n += (r.hours || 0) * 36e5;
  let a = $(n, e.timeZone);
  return i(a, e.calendar);
}
function B(e, r) {
  return H(e, g(r));
}
function J(e, r, n, a) {
  switch (r) {
    case "hour": {
      let c = 0, l = 23;
      if ((a == null ? void 0 : a.hourCycle) === 12) {
        let f = e.hour >= 12;
        c = f ? 12 : 0, l = f ? 23 : 11;
      }
      let t = M(e), o = i(I(t, {
        hour: c
      }), new Z()), d = [
        h(o, e.timeZone, "earlier"),
        h(o, e.timeZone, "later")
      ].filter((f) => $(f, e.timeZone).day === o.day)[0], m = i(I(t, {
        hour: l
      }), new Z()), E = [
        h(m, e.timeZone, "earlier"),
        h(m, e.timeZone, "later")
      ].filter((f) => $(f, e.timeZone).day === m.day).pop(), u = Y(e) - e.offset, C = Math.floor(u / y), A = u % y;
      return u = s(C, n, Math.floor(d / y), Math.floor(E / y), a == null ? void 0 : a.round) * y + A, i($(u, e.timeZone), e.calendar);
    }
    case "minute":
    case "second":
    case "millisecond":
      return G(e, r, n, a);
    case "era":
    case "year":
    case "month":
    case "day": {
      let c = V(M(e), r, n, a), l = h(c, e.timeZone);
      return i($(l, e.timeZone), e.calendar);
    }
    default:
      throw new Error("Unsupported field " + r);
  }
}
function K(e, r, n) {
  let a = M(e), c = I(O(a, r), r);
  if (c.compare(a) === 0) return e;
  let l = h(c, e.timeZone, n);
  return i($(l, e.timeZone), e.calendar);
}
export {
  k as add,
  P as addTime,
  H as addZoned,
  w as constrain,
  N as constrainTime,
  V as cycleDate,
  G as cycleTime,
  J as cycleZoned,
  g as invertDuration,
  O as set,
  I as setTime,
  K as setZoned,
  q as subtract,
  z as subtractTime,
  B as subtractZoned
};
