import { j as s } from "./ui-components-library39.js";
import { useMemo as d } from "react";
import { Label as k } from "./ui-components-library46.js";
import { ProgressBar as b } from "./ui-components-library94.js";
import { clsx as a } from "./ui-components-library47.js";
import { cn as $, isUndefined as l } from "./ui-components-library41.js";
import h from "./ui-components-library95.js";
function P({
  value: r,
  valueLabel: o,
  width: e,
  timerText: c,
  minValue: t = 0,
  maxValue: n = 100,
  animated: f = !0,
  className: x,
  ...p
}) {
  const m = d(
    () => r / (n - t) * 100,
    [r, t, n]
  ), i = `M ${8 / 2} ${8 / 2} h ${e - 8}`;
  return /* @__PURE__ */ s.jsxs(
    b,
    {
      className: $(
        "box-border flex flex-col items-center",
        "text-klerosUIComponentsStroke text-sm",
        x
      ),
      ...p,
      value: r,
      valueLabel: o,
      minValue: t,
      maxValue: n,
      children: [
        /* @__PURE__ */ s.jsx(
          k,
          {
            className: a(
              "text-klerosUIComponentsPrimaryText text-base break-words",
              l(o) && "hidden"
            ),
            children: o ?? `Progress ${m}`
          }
        ),
        /* @__PURE__ */ s.jsxs("div", { className: "flex flex-col items-start", children: [
          /* @__PURE__ */ s.jsxs(
            "svg",
            {
              className: "mx-auto my-2.5 block fill-none",
              height: 8,
              strokeWidth: 8,
              width: e,
              strokeLinecap: "round",
              children: [
                /* @__PURE__ */ s.jsx("path", { d: i, className: "stroke-klerosUIComponentsStroke" }),
                !l(r) && /* @__PURE__ */ s.jsx(
                  "path",
                  {
                    className: a(
                      "stroke-klerosUIComponentsSuccess",
                      f && "animate-progress-fill"
                    ),
                    width: m * e / 100,
                    strokeDasharray: `${m * e / 100}, ${e * 1e3}`,
                    d: i
                  }
                )
              ]
            }
          ),
          c && /* @__PURE__ */ s.jsxs(
            "div",
            {
              className: a(
                "mt-1.25 flex items-center justify-center",
                "text-klerosUIComponentsError text-base leading-4 font-semibold"
              ),
              children: [
                /* @__PURE__ */ s.jsx(h, { className: "fill-klerosUIComponentsError mr-[9.75px]" }),
                c
              ]
            }
          )
        ] })
      ]
    }
  );
}
export {
  P as default
};
