import { CalendarDate as f } from "./ui-components-library296.js";
import { GregorianCalendar as c, getExtendedYear as s, fromExtendedYear as g } from "./ui-components-library299.js";
const n = 1911;
function i(r) {
  return r.era === "minguo" ? r.year + n : 1 - r.year + n;
}
function o(r) {
  let e = r - n;
  return e > 0 ? [
    "minguo",
    e
  ] : [
    "before_minguo",
    1 - e
  ];
}
class m extends c {
  fromJulianDay(e) {
    let a = super.fromJulianDay(e), t = s(a.era, a.year), [u, $] = o(t);
    return new f(this, u, $, a.month, a.day);
  }
  toJulianDay(e) {
    return super.toJulianDay(b(e));
  }
  getEras() {
    return [
      "before_minguo",
      "minguo"
    ];
  }
  balanceDate(e) {
    let [a, t] = o(i(e));
    e.era = a, e.year = t;
  }
  isInverseEra(e) {
    return e.era === "before_minguo";
  }
  getDaysInMonth(e) {
    return super.getDaysInMonth(b(e));
  }
  getYearsInEra(e) {
    return e.era === "before_minguo" ? 9999 : 9999 - n;
  }
  constructor(...e) {
    super(...e), this.identifier = "roc";
  }
}
function b(r) {
  let [e, a] = g(i(r));
  return new f(e, a, r.month, r.day);
}
export {
  m as TaiwanCalendar
};
