import { ignoreFocusEvent as E } from "./ui-components-library339.js";
import { getOwnerWindow as i, getOwnerDocument as l } from "./ui-components-library275.js";
import { isMac as h } from "./ui-components-library278.js";
import { isVirtualClick as k } from "./ui-components-library291.js";
import { useEffect as m, useState as x } from "react";
import { useIsSSR as H } from "./ui-components-library267.js";
let a = null, u = /* @__PURE__ */ new Set(), f = /* @__PURE__ */ new Map(), d = !1, p = !1;
const I = {
  Tab: !0,
  Escape: !0
};
function v(t, r) {
  for (let e of u) e(t, r);
}
function S(t) {
  return !(t.metaKey || !h() && t.altKey || t.ctrlKey || t.key === "Control" || t.key === "Shift" || t.key === "Meta");
}
function c(t) {
  d = !0, S(t) && (a = "keyboard", v("keyboard", t));
}
function o(t) {
  a = "pointer", (t.type === "mousedown" || t.type === "pointerdown") && (d = !0, v("pointer", t));
}
function y(t) {
  k(t) && (d = !0, a = "virtual");
}
function L(t) {
  t.target === window || t.target === document || E || !t.isTrusted || (!d && !p && (a = "virtual", v("virtual", t)), d = !1, p = !1);
}
function w() {
  E || (d = !1, p = !0);
}
function s(t) {
  if (typeof window > "u" || f.get(i(t))) return;
  const r = i(t), e = l(t);
  let n = r.HTMLElement.prototype.focus;
  r.HTMLElement.prototype.focus = function() {
    d = !0, n.apply(this, arguments);
  }, e.addEventListener("keydown", c, !0), e.addEventListener("keyup", c, !0), e.addEventListener("click", y, !0), r.addEventListener("focus", L, !0), r.addEventListener("blur", w, !1), typeof PointerEvent < "u" ? (e.addEventListener("pointerdown", o, !0), e.addEventListener("pointermove", o, !0), e.addEventListener("pointerup", o, !0)) : (e.addEventListener("mousedown", o, !0), e.addEventListener("mousemove", o, !0), e.addEventListener("mouseup", o, !0)), r.addEventListener("beforeunload", () => {
    g(t);
  }, {
    once: !0
  }), f.set(r, {
    focus: n
  });
}
const g = (t, r) => {
  const e = i(t), n = l(t);
  r && n.removeEventListener("DOMContentLoaded", r), f.has(e) && (e.HTMLElement.prototype.focus = f.get(e).focus, n.removeEventListener("keydown", c, !0), n.removeEventListener("keyup", c, !0), n.removeEventListener("click", y, !0), e.removeEventListener("focus", L, !0), e.removeEventListener("blur", w, !1), typeof PointerEvent < "u" ? (n.removeEventListener("pointerdown", o, !0), n.removeEventListener("pointermove", o, !0), n.removeEventListener("pointerup", o, !0)) : (n.removeEventListener("mousedown", o, !0), n.removeEventListener("mousemove", o, !0), n.removeEventListener("mouseup", o, !0)), f.delete(e));
};
function F(t) {
  const r = l(t);
  let e;
  return r.readyState !== "loading" ? s(t) : (e = () => {
    s(t);
  }, r.addEventListener("DOMContentLoaded", e)), () => g(t, e);
}
typeof document < "u" && F();
function K() {
  return a !== "pointer";
}
function A() {
  return a;
}
function _(t) {
  a = t, v(t, null);
}
function G() {
  s();
  let [t, r] = x(a);
  return m(() => {
    let e = () => {
      r(a);
    };
    return u.add(e), () => {
      u.delete(e);
    };
  }, []), H() ? null : t;
}
const O = /* @__PURE__ */ new Set([
  "checkbox",
  "radio",
  "range",
  "color",
  "file",
  "image",
  "button",
  "submit",
  "reset"
]);
function C(t, r, e) {
  let n = l(e == null ? void 0 : e.target);
  const b = typeof window < "u" ? i(e == null ? void 0 : e.target).HTMLInputElement : HTMLInputElement, $ = typeof window < "u" ? i(e == null ? void 0 : e.target).HTMLTextAreaElement : HTMLTextAreaElement, M = typeof window < "u" ? i(e == null ? void 0 : e.target).HTMLElement : HTMLElement, T = typeof window < "u" ? i(e == null ? void 0 : e.target).KeyboardEvent : KeyboardEvent;
  return t = t || n.activeElement instanceof b && !O.has(n.activeElement.type) || n.activeElement instanceof $ || n.activeElement instanceof M && n.activeElement.isContentEditable, !(t && r === "keyboard" && e instanceof T && !I[e.key]);
}
function R(t, r, e) {
  s(), m(() => {
    let n = (b, $) => {
      C(!!(e != null && e.isTextInput), b, $) && t(K());
    };
    return u.add(n), () => {
      u.delete(n);
    };
  }, r);
}
export {
  F as addWindowFocusTracking,
  A as getInteractionModality,
  f as hasSetupGlobalListeners,
  K as isFocusVisible,
  _ as setInteractionModality,
  R as useFocusVisibleListener,
  G as useInteractionModality
};
