import { usePress as $ } from "./ui-components-library347.js";
import { getOwnerDocument as b } from "./ui-components-library275.js";
import { mergeProps as g } from "./ui-components-library123.js";
import { focusWithoutScrolling as P } from "./ui-components-library276.js";
import { useGlobalListeners as L } from "./ui-components-library280.js";
import { useDescription as x } from "./ui-components-library287.js";
import { useRef as y } from "react";
const D = 500;
function R(p) {
  let { isDisabled: o, onLongPressStart: s, onLongPressEnd: n, onLongPress: r, threshold: c = D, accessibilityDescription: f } = p;
  const t = y(void 0);
  let { addGlobalListener: i, removeGlobalListener: d } = L(), { pressProps: u } = $({
    isDisabled: o,
    onPressStart(e) {
      if (e.continuePropagation(), (e.pointerType === "mouse" || e.pointerType === "touch") && (s && s({
        ...e,
        type: "longpressstart"
      }), t.current = setTimeout(() => {
        e.target.dispatchEvent(new PointerEvent("pointercancel", {
          bubbles: !0
        })), b(e.target).activeElement !== e.target && P(e.target), r && r({
          ...e,
          type: "longpress"
        }), t.current = void 0;
      }, c), e.pointerType === "touch")) {
        let a = (m) => {
          m.preventDefault();
        };
        i(e.target, "contextmenu", a, {
          once: !0
        }), i(window, "pointerup", () => {
          setTimeout(() => {
            d(e.target, "contextmenu", a);
          }, 30);
        }, {
          once: !0
        });
      }
    },
    onPressEnd(e) {
      t.current && clearTimeout(t.current), n && (e.pointerType === "mouse" || e.pointerType === "touch") && n({
        ...e,
        type: "longpressend"
      });
    }
  }), l = x(r && !o ? f : void 0);
  return {
    longPressProps: g(u, l)
  };
}
export {
  R as useLongPress
};
