import { NATIVE_DRAG_TYPES as y, CUSTOM_DRAG_TYPE as d, GENERIC_TYPE as l, DROP_OPERATION as m } from "./ui-components-library358.js";
import { useInteractionModality as g } from "./ui-components-library340.js";
const h = Symbol();
function w(e) {
  return e || (e = "virtual"), e === "pointer" && (e = "virtual"), e === "virtual" && typeof window < "u" && "ontouchstart" in window && (e = "touch"), e;
}
function v() {
  return w(g());
}
function P(e, i) {
  let c = /* @__PURE__ */ new Map(), t = !1, r = [];
  for (let s of i) {
    let n = Object.keys(s);
    n.length > 1 && (t = !0);
    let f = {};
    for (let o of n) {
      let a = c.get(o);
      a ? t = !0 : (a = [], c.set(o, a));
      let $ = s[o];
      f[o] = $, a.push($);
    }
    r.push(f);
  }
  for (let [s, n] of c) if (y.has(s)) {
    let f = n.join(`
`);
    e.items.add(f, s);
  } else
    e.items.add(n[0], s);
  if (t) {
    let s = JSON.stringify(r);
    e.items.add(s, d);
  }
}
class S {
  has(i) {
    return this.includesUnknownTypes || i === h && this.types.has(l) ? !0 : typeof i == "string" && this.types.has(i);
  }
  constructor(i) {
    this.types = /* @__PURE__ */ new Set();
    let c = !1;
    for (let t of i.items) t.type !== d && (t.kind === "file" && (c = !0), t.type ? this.types.add(t.type) : this.types.add(l));
    this.includesUnknownTypes = !c && i.types.includes("Files");
  }
}
function A(e) {
  let i = [];
  if (!e) return i;
  let c = !1;
  if (e.types.includes(d)) try {
    let t = e.getData(d), r = JSON.parse(t);
    for (let s of r) i.push({
      kind: "text",
      types: new Set(Object.keys(s)),
      getText: (n) => Promise.resolve(s[n])
    });
    c = !0;
  } catch {
  }
  if (!c) {
    let t = /* @__PURE__ */ new Map();
    for (let r of e.items)
      if (r.kind === "string")
        t.set(r.type || l, e.getData(r.type));
      else if (r.kind === "file")
        if (typeof r.webkitGetAsEntry == "function") {
          let s = r.webkitGetAsEntry();
          if (!s) continue;
          s.isFile ? i.push(p(r.getAsFile())) : s.isDirectory && i.push(u(s));
        } else
          i.push(p(r.getAsFile()));
    t.size > 0 && i.push({
      kind: "text",
      types: new Set(t.keys()),
      getText: (r) => Promise.resolve(t.get(r))
    });
  }
  return i;
}
function b(e) {
  return typeof e.text == "function" ? e.text() : new Promise((i, c) => {
    let t = new FileReader();
    t.onload = () => {
      i(t.result);
    }, t.onerror = c, t.readAsText(e);
  });
}
function p(e) {
  if (!e) throw new Error("No file provided");
  return {
    kind: "file",
    type: e.type || l,
    name: e.name,
    getText: () => b(e),
    getFile: () => Promise.resolve(e)
  };
}
function u(e) {
  return {
    kind: "directory",
    name: e.name,
    getEntries: () => x(e)
  };
}
async function* x(e) {
  let i = e.createReader(), c;
  do {
    c = await new Promise((t, r) => {
      i.readEntries(t, r);
    });
    for (let t of c)
      if (t.isFile) {
        let r = await D(t);
        yield p(r);
      } else t.isDirectory && (yield u(t));
  } while (c.length > 0);
}
function D(e) {
  return new Promise((i, c) => e.file(i, c));
}
let E = {
  draggingKeys: /* @__PURE__ */ new Set()
};
function F(e) {
  E = e;
}
function O(e) {
}
let R = m.none;
export {
  h as DIRECTORY_DRAG_TYPE,
  S as DragTypes,
  R as globalAllowedDropOperations,
  E as globalDndState,
  A as readFromDataTransfer,
  F as setGlobalDnDState,
  O as setGlobalDropEffect,
  v as useDragModality,
  P as writeToDataTransfer
};
