import s from "./ui-components-library383.js";
import { isSameDay as c, startOfMonth as R, endOfMonth as p } from "./ui-components-library80.js";
import { useLocalizedStringFormatter as h } from "./ui-components-library156.js";
import { useDateFormatter as m } from "./ui-components-library382.js";
import { useMemo as b } from "react";
function x(e) {
  return e && e.__esModule ? e.default : e;
}
const D = /* @__PURE__ */ new WeakMap();
function d(e) {
  return (e == null ? void 0 : e.calendar.identifier) === "gregory" && e.era === "BC" ? "short" : void 0;
}
function _(e) {
  let a = h(x(s), "@react-aria/calendar"), r, t;
  var l;
  "highlightedRange" in e ? { start: r, end: t } = e.highlightedRange || {} : r = t = (l = e.value) !== null && l !== void 0 ? l : void 0;
  let o = m({
    weekday: "long",
    month: "long",
    year: "numeric",
    day: "numeric",
    era: d(r) || d(t),
    timeZone: e.timeZone
  }), n = "anchorDate" in e ? e.anchorDate : null;
  return b(() => {
    if (!n && r && t)
      if (c(r, t)) {
        let i = o.format(r.toDate(e.timeZone));
        return a.format("selectedDateDescription", {
          date: i
        });
      } else {
        let i = $(o, a, r, t, e.timeZone);
        return a.format("selectedRangeDescription", {
          dateRange: i
        });
      }
    return "";
  }, [
    r,
    t,
    n,
    e.timeZone,
    a,
    o
  ]);
}
function S(e, a, r, t) {
  let l = h(x(s), "@react-aria/calendar"), o = d(e) || d(a), n = m({
    month: "long",
    year: "numeric",
    era: o,
    calendar: e.calendar.identifier,
    timeZone: r
  }), i = m({
    month: "long",
    year: "numeric",
    day: "numeric",
    era: o,
    calendar: e.calendar.identifier,
    timeZone: r
  });
  return b(() => {
    if (c(e, R(e))) {
      if (c(a, p(e))) return n.format(e.toDate(r));
      if (c(a, p(a))) return t ? $(n, l, e, a, r) : n.formatRange(e.toDate(r), a.toDate(r));
    }
    return t ? $(i, l, e, a, r) : i.formatRange(e.toDate(r), a.toDate(r));
  }, [
    e,
    a,
    n,
    i,
    l,
    r,
    t
  ]);
}
function $(e, a, r, t, l) {
  let o = e.formatRangeToParts(r.toDate(l), t.toDate(l)), n = -1;
  for (let f = 0; f < o.length; f++) {
    let u = o[f];
    if (u.source === "shared" && u.type === "literal") n = f;
    else if (u.source === "endRange") break;
  }
  let i = "", g = "";
  for (let f = 0; f < o.length; f++)
    f < n ? i += o[f].value : f > n && (g += o[f].value);
  return a.format("dateRange", {
    startDate: i,
    endDate: g
  });
}
export {
  d as getEraFormat,
  D as hookData,
  _ as useSelectedDateDescription,
  S as useVisibleRangeDescription
};
