import V from "./ui-components-library889.js";
import { clearAnnouncer as A, announce as K } from "./ui-components-library120.js";
import { useRef as g, useEffect as B } from "react";
import { useGlobalListeners as L } from "./ui-components-library280.js";
import { useEffectEvent as T } from "./ui-components-library289.js";
import { useLocalizedStringFormatter as M } from "./ui-components-library156.js";
function S(a) {
  return a && a.__esModule ? a.default : a;
}
function O(a) {
  const f = g(void 0);
  let { value: n, textValue: $, minValue: i, maxValue: u, isDisabled: k, isReadOnly: D, isRequired: E, onIncrement: t, onIncrementPage: s, onDecrement: r, onDecrementPage: l, onDecrementToMin: c, onIncrementToMax: d } = a;
  const F = M(S(V), "@react-aria/spinbutton"), o = () => clearTimeout(f.current);
  B(() => () => o(), []);
  let I = (e) => {
    if (!(e.ctrlKey || e.metaKey || e.shiftKey || e.altKey || D))
      switch (e.key) {
        case "PageUp":
          if (s) {
            e.preventDefault(), s == null || s();
            break;
          }
        // fallthrough!
        case "ArrowUp":
        case "Up":
          t && (e.preventDefault(), t == null || t());
          break;
        case "PageDown":
          if (l) {
            e.preventDefault(), l == null || l();
            break;
          }
        // fallthrough
        case "ArrowDown":
        case "Down":
          r && (e.preventDefault(), r == null || r());
          break;
        case "Home":
          c && (e.preventDefault(), c == null || c());
          break;
        case "End":
          d && (e.preventDefault(), d == null || d());
          break;
      }
  }, m = g(!1), p = () => {
    m.current = !0;
  }, v = () => {
    m.current = !1;
  }, b = $ === "" ? F.format("Empty") : ($ || `${n}`).replace("-", "−");
  B(() => {
    m.current && (A("assertive"), K(b, "assertive"));
  }, [
    b
  ]);
  const x = T((e) => {
    o(), t == null || t(), f.current = window.setTimeout(() => {
      (u === void 0 || isNaN(u) || n === void 0 || isNaN(n) || n < u) && x(60);
    }, e);
  }), w = T((e) => {
    o(), r == null || r(), f.current = window.setTimeout(() => {
      (i === void 0 || isNaN(i) || n === void 0 || isNaN(n) || n > i) && w(60);
    }, e);
  });
  let P = (e) => {
    e.preventDefault();
  }, { addGlobalListener: y, removeAllGlobalListeners: N } = L();
  return {
    spinButtonProps: {
      role: "spinbutton",
      "aria-valuenow": n !== void 0 && !isNaN(n) ? n : void 0,
      "aria-valuetext": b,
      "aria-valuemin": i,
      "aria-valuemax": u,
      "aria-disabled": k || void 0,
      "aria-readonly": D || void 0,
      "aria-required": E || void 0,
      onKeyDown: I,
      onFocus: p,
      onBlur: v
    },
    incrementButtonProps: {
      onPressStart: () => {
        x(400), y(window, "contextmenu", P);
      },
      onPressEnd: () => {
        o(), N();
      },
      onFocus: p,
      onBlur: v
    },
    decrementButtonProps: {
      onPressStart: () => {
        w(400), y(window, "contextmenu", P);
      },
      onPressEnd: () => {
        o(), N();
      },
      onFocus: p,
      onBlur: v
    }
  };
}
export {
  O as useSpinButton
};
