const s = Symbol.for("react-aria.i18n.locale"), d = Symbol.for("react-aria.i18n.strings");
let o;
class l {
  /** Returns a localized string for the given key and locale. */
  getStringForLocale(t, r) {
    let i = this.getStringsForLocale(r)[t];
    if (!i) throw new Error(`Could not find intl message ${t} in ${r} locale`);
    return i;
  }
  /** Returns all localized strings for the given locale. */
  getStringsForLocale(t) {
    let r = this.strings[t];
    return r || (r = c(t, this.strings, this.defaultLocale), this.strings[t] = r), r;
  }
  static getGlobalDictionaryForPackage(t) {
    if (typeof window > "u") return null;
    let r = window[s];
    if (o === void 0) {
      let i = window[d];
      if (!i) return null;
      o = {};
      for (let a in i) o[a] = new l({
        [r]: i[a]
      }, r);
    }
    let e = o == null ? void 0 : o[t];
    if (!e) throw new Error(`Strings for package "${t}" were not included by LocalizedStringProvider. Please add it to the list passed to createLocalizedStringDictionary.`);
    return e;
  }
  constructor(t, r = "en-US") {
    this.strings = Object.fromEntries(Object.entries(t).filter(([, e]) => e)), this.defaultLocale = r;
  }
}
function c(n, t, r = "en-US") {
  if (t[n]) return t[n];
  let e = g(n);
  if (t[e]) return t[e];
  for (let i in t)
    if (i.startsWith(e + "-")) return t[i];
  return t[r];
}
function g(n) {
  return Intl.Locale ? new Intl.Locale(n).language : n.split("-")[0];
}
export {
  l as LocalizedStringDictionary
};
