import { listMap as X, getRowId as M } from "./ui-components-library398.js";
import { useSlotId as Y } from "./ui-components-library122.js";
import { chain as j } from "./ui-components-library271.js";
import { mergeProps as I } from "./ui-components-library123.js";
import { useSyntheticLinkProps as q } from "./ui-components-library277.js";
import { getScrollParent as u } from "./ui-components-library284.js";
import { scrollIntoViewport as p } from "./ui-components-library290.js";
import { getFocusableTreeWalker as L } from "./ui-components-library171.js";
import { isFocusVisible as H } from "./ui-components-library340.js";
import { focusSafely as c } from "./ui-components-library175.js";
import { getLastItem as J } from "./ui-components-library355.js";
import { useRef as Q } from "react";
import { useSelectableItem as Z } from "./ui-components-library403.js";
import { useLocale as _ } from "./ui-components-library130.js";
const D = {
  expand: {
    ltr: "ArrowRight",
    rtl: "ArrowLeft"
  },
  collapse: {
    ltr: "ArrowLeft",
    rtl: "ArrowRight"
  }
};
function be(b, r, n) {
  var v, m;
  let { node: e, isVirtualized: P, shouldSelectOnPressUp: V } = b, { direction: d } = _(), { onAction: f, linkBehavior: F, keyboardNavigationBehavior: $ } = X.get(r), y = Y(), g = Q(null), z = () => {
    var o;
    n.current !== null && (g.current != null && e.key !== g.current || !(!((o = n.current) === null || o === void 0) && o.contains(document.activeElement))) && c(n.current);
  }, E = {}, s = b.hasChildItems, B = r.selectionManager.isLink(e.key);
  if (e != null && "expandedKeys" in r) {
    var k, K, x;
    let o = (k = (K = r.collection).getChildren) === null || k === void 0 ? void 0 : k.call(K, e.key);
    s = s || [
      ...o ?? []
    ].length > 1, f == null && !B && r.selectionManager.selectionMode === "none" && s && (f = () => r.toggleKey(e.key));
    let i = s ? r.expandedKeys.has(e.key) : void 0, a = 1;
    var h;
    if (e.level > 0 && (e == null ? void 0 : e.parentKey) != null) {
      let t = r.collection.getItem(e.parentKey);
      if (t) {
        var w, A;
        let l = (w = (A = r.collection).getChildren) === null || w === void 0 ? void 0 : w.call(A, t.key);
        a = J(l).index + 1;
      }
    } else a = ((h = (x = [
      ...r.collection
    ].filter((t) => t.level === 0).at(-1)) === null || x === void 0 ? void 0 : x.index) !== null && h !== void 0 ? h : 0) + 1;
    E = {
      "aria-expanded": i,
      "aria-level": e.level + 1,
      "aria-posinset": (e == null ? void 0 : e.index) + 1,
      "aria-setsize": a
    };
  }
  let { itemProps: C, ...N } = Z({
    selectionManager: r.selectionManager,
    key: e.key,
    ref: n,
    isVirtualized: P,
    shouldSelectOnPressUp: V,
    onAction: f || !((v = e.props) === null || v === void 0) && v.onAction ? j((m = e.props) === null || m === void 0 ? void 0 : m.onAction, f ? () => f(e.key) : void 0) : void 0,
    focus: z,
    linkBehavior: F
  }), O = (o) => {
    if (!o.currentTarget.contains(o.target) || !n.current || !document.activeElement) return;
    let i = L(n.current);
    if (i.currentNode = document.activeElement, "expandedKeys" in r && document.activeElement === n.current) {
      if (o.key === D.expand[d] && r.selectionManager.focusedKey === e.key && s && !r.expandedKeys.has(e.key)) {
        r.toggleKey(e.key), o.stopPropagation();
        return;
      } else if (o.key === D.collapse[d] && r.selectionManager.focusedKey === e.key && s && r.expandedKeys.has(e.key)) {
        r.toggleKey(e.key), o.stopPropagation();
        return;
      }
    }
    switch (o.key) {
      case "ArrowLeft":
        if ($ === "arrow") {
          let t = d === "rtl" ? i.nextNode() : i.previousNode();
          if (t)
            o.preventDefault(), o.stopPropagation(), c(t), p(t, {
              containingElement: u(n.current)
            });
          else if (o.preventDefault(), o.stopPropagation(), d === "rtl")
            c(n.current), p(n.current, {
              containingElement: u(n.current)
            });
          else {
            i.currentNode = n.current;
            let l = R(i);
            l && (c(l), p(l, {
              containingElement: u(n.current)
            }));
          }
        }
        break;
      case "ArrowRight":
        if ($ === "arrow") {
          let t = d === "rtl" ? i.previousNode() : i.nextNode();
          if (t)
            o.preventDefault(), o.stopPropagation(), c(t), p(t, {
              containingElement: u(n.current)
            });
          else if (o.preventDefault(), o.stopPropagation(), d === "ltr")
            c(n.current), p(n.current, {
              containingElement: u(n.current)
            });
          else {
            i.currentNode = n.current;
            let l = R(i);
            l && (c(l), p(l, {
              containingElement: u(n.current)
            }));
          }
        }
        break;
      case "ArrowUp":
      case "ArrowDown":
        if (!o.altKey && n.current.contains(o.target)) {
          var a;
          o.stopPropagation(), o.preventDefault(), (a = n.current.parentElement) === null || a === void 0 || a.dispatchEvent(new KeyboardEvent(o.nativeEvent.type, o.nativeEvent));
        }
        break;
      case "Tab":
        if ($ === "tab") {
          let t = L(n.current, {
            tabbable: !0
          });
          t.currentNode = document.activeElement, (o.shiftKey ? t.previousNode() : t.nextNode()) && o.stopPropagation();
        }
    }
  }, U = (o) => {
    if (g.current = e.key, o.target !== n.current) {
      H() || r.selectionManager.setFocusedKey(e.key);
      return;
    }
  }, T = q(e.props), G = N.hasAction ? T : {}, S = I(C, G, {
    role: "row",
    onKeyDownCapture: O,
    onFocus: U,
    // 'aria-label': [(node.textValue || undefined), rowAnnouncement].filter(Boolean).join(', '),
    "aria-label": e.textValue || void 0,
    "aria-selected": r.selectionManager.canSelectItem(e.key) ? r.selectionManager.isSelected(e.key) : void 0,
    "aria-disabled": r.selectionManager.isDisabled(e.key) || void 0,
    "aria-labelledby": y && e.textValue ? `${M(r, e.key)} ${y}` : void 0,
    id: M(r, e.key)
  });
  P && (S["aria-rowindex"] = e.index + 1);
  let W = {
    role: "gridcell",
    "aria-colindex": 1
  };
  return {
    rowProps: {
      ...I(S, E)
    },
    gridCellProps: W,
    descriptionProps: {
      id: y
    },
    ...N
  };
}
function R(b) {
  let r = null, n = null;
  do
    n = b.lastChild(), n && (r = n);
  while (n);
  return r;
}
export {
  be as useGridListItem
};
