import d from "./ui-components-library407.js";
import { useId as P } from "./ui-components-library122.js";
import { focusWithoutScrolling as b } from "./ui-components-library276.js";
import { useLongPress as $ } from "./ui-components-library351.js";
import { useLocalizedStringFormatter as m } from "./ui-components-library156.js";
import { useOverlayTrigger as y } from "./ui-components-library408.js";
function D(o) {
  return o && o.__esModule ? o.default : o;
}
function k(o, r, n) {
  let { type: p = "menu", isDisabled: t, trigger: s = "press" } = o, i = P(), { triggerProps: a, overlayProps: l } = y({
    type: p
  }, r, n), g = (e) => {
    if (!t && !(s === "longPress" && !e.altKey) && n && n.current)
      switch (e.key) {
        case "Enter":
        case " ":
          if (s === "longPress") return;
        // fallthrough
        case "ArrowDown":
          "continuePropagation" in e || e.stopPropagation(), e.preventDefault(), r.toggle("first");
          break;
        case "ArrowUp":
          "continuePropagation" in e || e.stopPropagation(), e.preventDefault(), r.toggle("last");
          break;
        default:
          "continuePropagation" in e && e.continuePropagation();
      }
  }, u = m(D(d), "@react-aria/menu"), { longPressProps: c } = $({
    isDisabled: t || s !== "longPress",
    accessibilityDescription: u.format("longPressMessage"),
    onLongPressStart() {
      r.close();
    },
    onLongPress() {
      r.open("first");
    }
  }), f = {
    preventFocusOnPress: !0,
    onPressStart(e) {
      e.pointerType !== "touch" && e.pointerType !== "keyboard" && !t && (b(e.target), r.open(e.pointerType === "virtual" ? "first" : null));
    },
    onPress(e) {
      e.pointerType === "touch" && !t && r.toggle();
    }
  };
  return delete a.onPress, {
    // @ts-ignore - TODO we pass out both DOMAttributes AND AriaButtonProps, but useButton will discard the longPress event handlers, it's only through PressResponder magic that this works for RSP and RAC. it does not work in aria examples
    menuTriggerProps: {
      ...a,
      ...s === "press" ? f : c,
      id: i,
      onKeyDown: g
    },
    menuProps: {
      ...l,
      "aria-labelledby": i,
      autoFocus: r.focusStrategy || !0,
      onClose: r.close
    }
  };
}
export {
  k as useMenuTrigger
};
