import { isWebKit as ot } from "./ui-components-library278.js";
import { clamp as G } from "./ui-components-library180.js";
const P = {
  top: "top",
  bottom: "top",
  left: "left",
  right: "left"
}, z = {
  top: "bottom",
  bottom: "top",
  left: "right",
  right: "left"
}, it = {
  top: "left",
  left: "top"
}, K = {
  top: "height",
  left: "width"
}, B = {
  width: "totalWidth",
  height: "totalHeight"
}, H = {};
let u = typeof document < "u" ? window.visualViewport : null;
function j(e) {
  let t = 0, o = 0, c = 0, i = 0, a = 0, f = 0, l = {};
  var $;
  let p = (($ = u == null ? void 0 : u.scale) !== null && $ !== void 0 ? $ : 1) > 1;
  if (e.tagName === "BODY") {
    let h = document.documentElement;
    c = h.clientWidth, i = h.clientHeight;
    var s;
    t = (s = u == null ? void 0 : u.width) !== null && s !== void 0 ? s : c;
    var g;
    o = (g = u == null ? void 0 : u.height) !== null && g !== void 0 ? g : i, l.top = h.scrollTop || e.scrollTop, l.left = h.scrollLeft || e.scrollLeft, u && (a = u.offsetTop, f = u.offsetLeft);
  } else
    ({ width: t, height: o, top: a, left: f } = M(e)), l.top = e.scrollTop, l.left = e.scrollLeft, c = t, i = o;
  if (ot() && (e.tagName === "BODY" || e.tagName === "HTML") && p) {
    l.top = 0, l.left = 0;
    var d;
    a = (d = u == null ? void 0 : u.pageTop) !== null && d !== void 0 ? d : 0;
    var r;
    f = (r = u == null ? void 0 : u.pageLeft) !== null && r !== void 0 ? r : 0;
  }
  return {
    width: t,
    height: o,
    totalWidth: c,
    totalHeight: i,
    scroll: l,
    top: a,
    left: f
  };
}
function ct(e) {
  return {
    top: e.scrollTop,
    left: e.scrollLeft,
    width: e.scrollWidth,
    height: e.scrollHeight
  };
}
function q(e, t, o, c, i, a, f) {
  var l;
  let $ = (l = i.scroll[e]) !== null && l !== void 0 ? l : 0, p = c[K[e]], s = c.scroll[P[e]] + a, g = p + c.scroll[P[e]] - a, d = t - $ + f[e] - c[P[e]], r = t - $ + o + f[e] - c[P[e]];
  return d < s ? s - d : r > g ? Math.max(g - r, s - d) : 0;
}
function rt(e) {
  let t = window.getComputedStyle(e);
  return {
    top: parseInt(t.marginTop, 10) || 0,
    bottom: parseInt(t.marginBottom, 10) || 0,
    left: parseInt(t.marginLeft, 10) || 0,
    right: parseInt(t.marginRight, 10) || 0
  };
}
function J(e) {
  if (H[e]) return H[e];
  let [t, o] = e.split(" "), c = P[t] || "right", i = it[c];
  P[o] || (o = "center");
  let a = K[c], f = K[i];
  return H[e] = {
    placement: t,
    crossPlacement: o,
    axis: c,
    crossAxis: i,
    size: a,
    crossSize: f
  }, H[e];
}
function Z(e, t, o, c, i, a, f, l, $, p) {
  let { placement: s, crossPlacement: g, axis: d, crossAxis: r, size: h, crossSize: v } = c, n = {};
  var w;
  n[r] = (w = e[r]) !== null && w !== void 0 ? w : 0;
  var m, x, E, T;
  g === "center" ? n[r] += (((m = e[v]) !== null && m !== void 0 ? m : 0) - ((x = o[v]) !== null && x !== void 0 ? x : 0)) / 2 : g !== r && (n[r] += ((E = e[v]) !== null && E !== void 0 ? E : 0) - ((T = o[v]) !== null && T !== void 0 ? T : 0)), n[r] += a;
  const _ = e[r] - o[v] + $ + p, I = e[r] + e[v] - $ - p;
  if (n[r] = G(n[r], _, I), s === d) {
    const b = l ? f[h] : t[B[h]];
    n[z[d]] = Math.floor(b - e[d] + i);
  } else n[d] = Math.floor(e[d] + e[h] + i);
  return n;
}
function at(e, t, o, c, i, a, f, l) {
  const $ = c ? o.height : t[B.height];
  var p;
  let s = e.top != null ? o.top + e.top : o.top + ($ - ((p = e.bottom) !== null && p !== void 0 ? p : 0) - f);
  var g, d, r, h, v, n;
  let w = l !== "top" ? (
    // We want the distance between the top of the overlay to the bottom of the boundary
    Math.max(0, t.height + t.top + ((g = t.scroll.top) !== null && g !== void 0 ? g : 0) - s - (((d = i.top) !== null && d !== void 0 ? d : 0) + ((r = i.bottom) !== null && r !== void 0 ? r : 0) + a))
  ) : Math.max(0, s + f - (t.top + ((h = t.scroll.top) !== null && h !== void 0 ? h : 0)) - (((v = i.top) !== null && v !== void 0 ? v : 0) + ((n = i.bottom) !== null && n !== void 0 ? n : 0) + a));
  return Math.min(t.height - a * 2, w);
}
function Q(e, t, o, c, i, a) {
  let { placement: f, axis: l, size: $ } = a;
  var p, s;
  if (f === l) return Math.max(0, o[l] - e[l] - ((p = e.scroll[l]) !== null && p !== void 0 ? p : 0) + t[l] - ((s = c[l]) !== null && s !== void 0 ? s : 0) - c[z[l]] - i);
  var g;
  return Math.max(0, e[$] + e[l] + e.scroll[l] - t[l] - o[l] - o[$] - ((g = c[l]) !== null && g !== void 0 ? g : 0) - c[z[l]] - i);
}
function nt(e, t, o, c, i, a, f, l, $, p, s, g, d, r, h, v) {
  let n = J(e), { size: w, crossAxis: m, crossSize: x, placement: E, crossPlacement: T } = n, _ = Z(t, l, o, n, s, g, p, d, h, v), I = s, b = Q(l, p, t, i, a + s, n);
  if (f && c[w] > b) {
    let X = J(`${z[E]} ${T}`), lt = Z(t, l, o, X, s, g, p, d, h, v);
    Q(l, p, t, i, a + s, X) > b && (n = X, _ = lt, I = s);
  }
  let L = "bottom";
  n.axis === "top" ? n.placement === "top" ? L = "top" : n.placement === "bottom" && (L = "bottom") : n.crossAxis === "top" && (n.crossPlacement === "top" ? L = "bottom" : n.crossPlacement === "bottom" && (L = "top"));
  let S = q(m, _[m], o[x], l, $, a, p);
  _[m] += S;
  let C = at(_, l, p, d, i, a, o.height, L);
  r && r < C && (C = r), o.height = Math.min(o.height, C), _ = Z(t, l, o, n, I, g, p, d, h, v), S = q(m, _[m], o[x], l, $, a, p), _[m] += S;
  let A = {}, k = t[m] + 0.5 * t[x] - _[m] - i[P[m]];
  const V = h / 2 + v;
  var F, N, R, Y;
  const D = P[m] === "left" ? ((F = i.left) !== null && F !== void 0 ? F : 0) + ((N = i.right) !== null && N !== void 0 ? N : 0) : ((R = i.top) !== null && R !== void 0 ? R : 0) + ((Y = i.bottom) !== null && Y !== void 0 ? Y : 0), O = o[x] - D - h / 2 - v, y = t[m] + h / 2 - (_[m] + i[P[m]]), tt = t[m] + t[x] - h / 2 - (_[m] + i[P[m]]), et = G(k, y, tt);
  return A[m] = G(et, V, O), {
    position: _,
    maxHeight: C,
    arrowOffsetLeft: A.left,
    arrowOffsetTop: A.top,
    placement: n.placement
  };
}
function dt(e) {
  let { placement: t, targetNode: o, overlayNode: c, scrollNode: i, padding: a, shouldFlip: f, boundaryElement: l, offset: $, crossOffset: p, maxHeight: s, arrowSize: g = 0, arrowBoundaryOffset: d = 0 } = e, r = c instanceof HTMLElement ? pt(c) : document.documentElement, h = r === document.documentElement;
  const v = window.getComputedStyle(r).position;
  let n = !!v && v !== "static", w = h ? M(o) : U(o, r);
  if (!h) {
    let { marginTop: A, marginLeft: k } = window.getComputedStyle(o);
    w.top += parseInt(A, 10) || 0, w.left += parseInt(k, 10) || 0;
  }
  let m = M(c), x = rt(c);
  var E, T;
  m.width += ((E = x.left) !== null && E !== void 0 ? E : 0) + ((T = x.right) !== null && T !== void 0 ? T : 0);
  var _, I;
  m.height += ((_ = x.top) !== null && _ !== void 0 ? _ : 0) + ((I = x.bottom) !== null && I !== void 0 ? I : 0);
  let b = ct(i), L = j(l), S = j(r), C = l.tagName === "BODY" ? M(r) : U(r, l);
  return r.tagName === "HTML" && l.tagName === "BODY" && (S.scroll.top = 0, S.scroll.left = 0), nt(t, w, m, b, x, a, f, L, S, C, $, p, n, s, g, d);
}
function M(e) {
  let { top: t, left: o, width: c, height: i } = e.getBoundingClientRect(), { scrollTop: a, scrollLeft: f, clientTop: l, clientLeft: $ } = document.documentElement;
  return {
    top: t + a - l,
    left: o + f - $,
    width: c,
    height: i
  };
}
function U(e, t) {
  let o = window.getComputedStyle(e), c;
  if (o.position === "fixed") {
    let { top: i, left: a, width: f, height: l } = e.getBoundingClientRect();
    c = {
      top: i,
      left: a,
      width: f,
      height: l
    };
  } else {
    c = M(e);
    let i = M(t), a = window.getComputedStyle(t);
    i.top += (parseInt(a.borderTopWidth, 10) || 0) - t.scrollTop, i.left += (parseInt(a.borderLeftWidth, 10) || 0) - t.scrollLeft, c.top -= i.top, c.left -= i.left;
  }
  return c.top -= parseInt(o.marginTop, 10) || 0, c.left -= parseInt(o.marginLeft, 10) || 0, c;
}
function pt(e) {
  let t = e.offsetParent;
  if (t && t === document.body && window.getComputedStyle(t).position === "static" && !W(t) && (t = document.documentElement), t == null)
    for (t = e.parentElement; t && !W(t); ) t = t.parentElement;
  return t || document.documentElement;
}
function W(e) {
  let t = window.getComputedStyle(e);
  return t.transform !== "none" || /transform|perspective/.test(t.willChange) || t.filter !== "none" || t.contain === "paint" || "backdropFilter" in t && t.backdropFilter !== "none" || "WebkitBackdropFilter" in t && t.WebkitBackdropFilter !== "none";
}
export {
  dt as calculatePosition,
  nt as calculatePositionInternal
};
