import { getItemElement as V, useCollectionId as ue, isNonContiguousSelectionModifier as H } from "./ui-components-library422.js";
import { useTypeSelect as se } from "./ui-components-library420.js";
import { mergeProps as G } from "./ui-components-library123.js";
import { focusWithoutScrolling as j } from "./ui-components-library276.js";
import { useRouter as ae } from "./ui-components-library277.js";
import { useUpdateLayoutEffect as q } from "./ui-components-library282.js";
import { useEvent as w } from "./ui-components-library288.js";
import { scrollIntoView as de, scrollIntoViewport as J } from "./ui-components-library290.js";
import { useEffectEvent as Q } from "./ui-components-library289.js";
import { FOCUS_EVENT as pe, CLEAR_FOCUS_EVENT as ve } from "./ui-components-library294.js";
import { isCtrlKeyPressed as $ } from "./ui-components-library295.js";
import { flushSync as ye } from "react-dom";
import { useRef as K, useEffect as X } from "react";
import { getInteractionModality as Y } from "./ui-components-library340.js";
import { focusSafely as Z } from "./ui-components-library175.js";
import { getFocusableTreeWalker as be } from "./ui-components-library171.js";
import { moveVirtualFocus as me } from "./ui-components-library363.js";
import { useLocale as $e } from "./ui-components-library130.js";
function Ne(g) {
  let { selectionManager: e, keyboardDelegate: o, ref: i, autoFocus: S = !1, shouldFocusWrap: F = !1, disallowEmptySelection: _ = !1, disallowSelectAll: ee = !1, selectOnFocus: b = e.selectionBehavior === "replace", disallowTypeAhead: le = !1, shouldUseVirtualFocus: y, allowsTabNavigation: oe = !1, isVirtualized: C, scrollRef: s = i, linkBehavior: N = "action" } = g, { direction: x } = $e(), te = ae(), re = (l) => {
    var r;
    if (l.altKey && l.key === "Tab" && l.preventDefault(), !(!((r = i.current) === null || r === void 0) && r.contains(l.target))) return;
    const c = (t, p) => {
      if (t != null) {
        if (e.isLink(t) && N === "selection" && b && !H(l)) {
          ye(() => {
            e.setFocusedKey(t, p);
          });
          let v = V(i, t), W = e.getItemProps(t);
          v && te.open(v, l, W.href, W.routerOptions);
          return;
        }
        if (e.setFocusedKey(t, p), e.isLink(t) && N === "override") return;
        l.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(t) : b && !H(l) && e.replaceSelection(t);
      }
    };
    switch (l.key) {
      case "ArrowDown":
        if (o.getKeyBelow) {
          var f, u, n;
          let t = e.focusedKey != null ? (f = o.getKeyBelow) === null || f === void 0 ? void 0 : f.call(o, e.focusedKey) : (u = o.getFirstKey) === null || u === void 0 ? void 0 : u.call(o);
          t == null && F && (t = (n = o.getFirstKey) === null || n === void 0 ? void 0 : n.call(o, e.focusedKey)), t != null && (l.preventDefault(), c(t));
        }
        break;
      case "ArrowUp":
        if (o.getKeyAbove) {
          var a, d, P;
          let t = e.focusedKey != null ? (a = o.getKeyAbove) === null || a === void 0 ? void 0 : a.call(o, e.focusedKey) : (d = o.getLastKey) === null || d === void 0 ? void 0 : d.call(o);
          t == null && F && (t = (P = o.getLastKey) === null || P === void 0 ? void 0 : P.call(o, e.focusedKey)), t != null && (l.preventDefault(), c(t));
        }
        break;
      case "ArrowLeft":
        if (o.getKeyLeftOf) {
          var k, A, I;
          let t = e.focusedKey != null ? (k = o.getKeyLeftOf) === null || k === void 0 ? void 0 : k.call(o, e.focusedKey) : null;
          t == null && F && (t = x === "rtl" ? (A = o.getFirstKey) === null || A === void 0 ? void 0 : A.call(o, e.focusedKey) : (I = o.getLastKey) === null || I === void 0 ? void 0 : I.call(o, e.focusedKey)), t != null && (l.preventDefault(), c(t, x === "rtl" ? "first" : "last"));
        }
        break;
      case "ArrowRight":
        if (o.getKeyRightOf) {
          var M, R, O;
          let t = e.focusedKey != null ? (M = o.getKeyRightOf) === null || M === void 0 ? void 0 : M.call(o, e.focusedKey) : null;
          t == null && F && (t = x === "rtl" ? (R = o.getLastKey) === null || R === void 0 ? void 0 : R.call(o, e.focusedKey) : (O = o.getFirstKey) === null || O === void 0 ? void 0 : O.call(o, e.focusedKey)), t != null && (l.preventDefault(), c(t, x === "rtl" ? "last" : "first"));
        }
        break;
      case "Home":
        if (o.getFirstKey) {
          if (e.focusedKey === null && l.shiftKey) return;
          l.preventDefault();
          let t = o.getFirstKey(e.focusedKey, $(l));
          e.setFocusedKey(t), t != null && ($(l) && l.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(t) : b && e.replaceSelection(t));
        }
        break;
      case "End":
        if (o.getLastKey) {
          if (e.focusedKey === null && l.shiftKey) return;
          l.preventDefault();
          let t = o.getLastKey(e.focusedKey, $(l));
          e.setFocusedKey(t), t != null && ($(l) && l.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(t) : b && e.replaceSelection(t));
        }
        break;
      case "PageDown":
        if (o.getKeyPageBelow && e.focusedKey != null) {
          let t = o.getKeyPageBelow(e.focusedKey);
          t != null && (l.preventDefault(), c(t));
        }
        break;
      case "PageUp":
        if (o.getKeyPageAbove && e.focusedKey != null) {
          let t = o.getKeyPageAbove(e.focusedKey);
          t != null && (l.preventDefault(), c(t));
        }
        break;
      case "a":
        $(l) && e.selectionMode === "multiple" && ee !== !0 && (l.preventDefault(), e.selectAll());
        break;
      case "Escape":
        !_ && e.selectedKeys.size !== 0 && (l.stopPropagation(), l.preventDefault(), e.clearSelection());
        break;
      case "Tab":
        if (!oe) {
          if (l.shiftKey) i.current.focus();
          else {
            let t = be(i.current, {
              tabbable: !0
            }), p, v;
            do
              v = t.lastChild(), v && (p = v);
            while (v);
            p && !p.contains(document.activeElement) && j(p);
          }
          break;
        }
    }
  }, h = K({
    top: 0,
    left: 0
  });
  w(s, "scroll", C ? void 0 : () => {
    var l, r, c, f;
    h.current = {
      top: (c = (l = s.current) === null || l === void 0 ? void 0 : l.scrollTop) !== null && c !== void 0 ? c : 0,
      left: (f = (r = s.current) === null || r === void 0 ? void 0 : r.scrollLeft) !== null && f !== void 0 ? f : 0
    };
  });
  let ce = (l) => {
    if (e.isFocused) {
      l.currentTarget.contains(l.target) || e.setFocused(!1);
      return;
    }
    if (l.currentTarget.contains(l.target)) {
      if (e.setFocused(!0), e.focusedKey == null) {
        var r, c;
        let n = (d) => {
          d != null && (e.setFocusedKey(d), b && !e.isSelected(d) && e.replaceSelection(d));
        }, a = l.relatedTarget;
        var f, u;
        a && l.currentTarget.compareDocumentPosition(a) & Node.DOCUMENT_POSITION_FOLLOWING ? n((f = e.lastSelectedKey) !== null && f !== void 0 ? f : (r = o.getLastKey) === null || r === void 0 ? void 0 : r.call(o)) : n((u = e.firstSelectedKey) !== null && u !== void 0 ? u : (c = o.getFirstKey) === null || c === void 0 ? void 0 : c.call(o));
      } else !C && s.current && (s.current.scrollTop = h.current.top, s.current.scrollLeft = h.current.left);
      if (e.focusedKey != null && s.current) {
        let n = V(i, e.focusedKey);
        n instanceof HTMLElement && (!n.contains(document.activeElement) && !y && j(n), Y() === "keyboard" && J(n, {
          containingElement: i.current
        }));
      }
    }
  }, ie = (l) => {
    l.currentTarget.contains(l.relatedTarget) || e.setFocused(!1);
  }, m = K(!1);
  w(i, pe, y ? (l) => {
    let { detail: r } = l;
    l.stopPropagation(), e.setFocused(!0), (r == null ? void 0 : r.focusStrategy) === "first" && (m.current = !0);
  } : void 0);
  let U = Q(() => {
    var l, r;
    let c = (r = (l = o.getFirstKey) === null || l === void 0 ? void 0 : l.call(o)) !== null && r !== void 0 ? r : null;
    c == null ? (me(i.current), e.collection.size > 0 && (m.current = !1)) : (e.setFocusedKey(c), m.current = !1);
  });
  q(() => {
    m.current && U();
  }, [
    e.collection,
    U
  ]);
  let z = Q(() => {
    e.collection.size > 0 && (m.current = !1);
  });
  q(() => {
    z();
  }, [
    e.focusedKey,
    z
  ]), w(i, ve, y ? (l) => {
    var r;
    l.stopPropagation(), e.setFocused(!1), !((r = l.detail) === null || r === void 0) && r.clearFocusKey && e.setFocusedKey(null);
  } : void 0);
  const B = K(S), T = K(!1);
  X(() => {
    if (B.current) {
      var l, r;
      let u = null;
      var c;
      S === "first" && (u = (c = (l = o.getFirstKey) === null || l === void 0 ? void 0 : l.call(o)) !== null && c !== void 0 ? c : null);
      var f;
      S === "last" && (u = (f = (r = o.getLastKey) === null || r === void 0 ? void 0 : r.call(o)) !== null && f !== void 0 ? f : null);
      let n = e.selectedKeys;
      if (n.size) {
        for (let a of n) if (e.canSelectItem(a)) {
          u = a;
          break;
        }
      }
      e.setFocused(!0), e.setFocusedKey(u), u == null && !y && i.current && Z(i.current), e.collection.size > 0 && (B.current = !1, T.current = !0);
    }
  });
  let D = K(e.focusedKey);
  X(() => {
    if (e.isFocused && e.focusedKey != null && (e.focusedKey !== D.current || T.current) && s.current && i.current) {
      let l = Y(), r = V(i, e.focusedKey);
      if (!(r instanceof HTMLElement))
        return;
      (l === "keyboard" || T.current) && (de(s.current, r), l !== "virtual" && J(r, {
        containingElement: i.current
      }));
    }
    !y && e.isFocused && e.focusedKey == null && D.current != null && i.current && Z(i.current), D.current = e.focusedKey, T.current = !1;
  }), w(i, "react-aria-focus-scope-restore", (l) => {
    l.preventDefault(), e.setFocused(!0);
  });
  let E = {
    onKeyDown: re,
    onFocus: ce,
    onBlur: ie,
    onMouseDown(l) {
      s.current === l.target && l.preventDefault();
    }
  }, { typeSelectProps: fe } = se({
    keyboardDelegate: o,
    selectionManager: e
  });
  le || (E = G(fe, E));
  let L;
  y || (L = e.focusedKey == null ? 0 : -1);
  let ne = ue(e.collection);
  return {
    collectionProps: G(E, {
      tabIndex: L,
      "data-collection": ne
    })
  };
}
export {
  Ne as useSelectableCollection
};
