var E = {};
E = {
  dragDescriptionKeyboard: "按 Enter 开始拖动。",
  dragDescriptionKeyboardAlt: "按 Alt + Enter 开始拖动。",
  dragDescriptionLongPress: "长按以开始拖动。",
  dragDescriptionTouch: "双击开始拖动。",
  dragDescriptionVirtual: "单击开始拖动。",
  dragItem: (u) => `拖动 ${u.itemText}`,
  dragSelectedItems: (u, e) => `拖动 ${e.plural(u.count, {
    one: () => `${e.number(u.count)} 选中项目`,
    other: () => `${e.number(u.count)} 选中项目`
  })}`,
  dragSelectedKeyboard: (u, e) => `按 Enter 以拖动 ${e.plural(u.count, {
    one: () => `${e.number(u.count)} 个选定项`,
    other: () => `${e.number(u.count)} 个选定项`
  })}。`,
  dragSelectedKeyboardAlt: (u, e) => `按 Alt + Enter 以拖动 ${e.plural(u.count, {
    one: () => `${e.number(u.count)} 个选定项`,
    other: () => `${e.number(u.count)} 个选定项`
  })}。`,
  dragSelectedLongPress: (u, e) => `长按以拖动 ${e.plural(u.count, {
    one: () => `${e.number(u.count)} 个选定项`,
    other: () => `${e.number(u.count)} 个选定项`
  })}。`,
  dragStartedKeyboard: "已开始拖动。按 Tab 导航到放置目标，然后按 Enter 放置或按 Escape 取消。",
  dragStartedTouch: "已开始拖动。导航到放置目标，然后双击放置。",
  dragStartedVirtual: "已开始拖动。导航到放置目标，然后单击或按 Enter 放置。",
  dropCanceled: "放置已取消。",
  dropComplete: "放置已完成。",
  dropDescriptionKeyboard: "按 Enter 放置。按 Escape 取消拖动。",
  dropDescriptionTouch: "双击放置。",
  dropDescriptionVirtual: "单击放置。",
  dropIndicator: "放置标记",
  dropOnItem: (u) => `放置于 ${u.itemText}`,
  dropOnRoot: "放置于",
  endDragKeyboard: "正在拖动。按 Enter 取消拖动。",
  endDragTouch: "正在拖动。双击取消拖动。",
  endDragVirtual: "正在拖动。单击取消拖动。",
  insertAfter: (u) => `插入到 ${u.itemText} 之后`,
  insertBefore: (u) => `插入到 ${u.itemText} 之前`,
  insertBetween: (u) => `插入到 ${u.beforeItemText} 和 ${u.afterItemText} 之间`
};
export {
  E as default
};
