import { useEffect as A, useState as V, useRef as Q } from "react";
import { BigNumber as u } from "./ui-components-library212.js";
const N = {
  prefix: "",
  decimalSeparator: ".",
  groupSeparator: ",",
  groupSize: 3,
  secondaryGroupSize: 0,
  fractionGroupSeparator: " ",
  fractionGroupSize: 0,
  suffix: ""
};
function ee(d) {
  A(() => {
    const e = {
      ...N,
      ...d.formatOptions
    };
    u.config({
      EXPONENTIAL_AT: 1e9,
      FORMAT: e
    });
  }, [d.formatOptions]);
  const {
    value: p,
    defaultValue: T,
    minValue: F,
    maxValue: R,
    step: O = "1",
    onChange: n,
    isDisabled: g,
    isReadOnly: w,
    isWheelDisabled: q,
    id: v
  } = d, S = new u(O.toString()).abs(), a = F !== void 0 ? new u(F.toString()) : void 0, s = R !== void 0 ? new u(R.toString()) : void 0, [D, o] = V(() => p !== void 0 ? new u(p.toString()).toFormat() : T !== void 0 ? new u(T.toString()).toFormat() : ""), [y, m] = V(!1), [i, l] = V(() => {
    try {
      if (p !== void 0)
        return new u(p.toString());
      if (T !== void 0)
        return new u(T.toString());
    } catch (e) {
      console.error("Error parsing initial BigNumber value:", e);
    }
    return null;
  }), c = Q(null);
  A(() => {
    if (p !== void 0) {
      o(p.toString());
      try {
        l(new u(p.toString()));
      } catch (e) {
        console.error("Error updating BigNumber value:", e), l(null);
      }
    }
  }, [p]), A(() => (c.current !== null && (window.clearTimeout(c.current), c.current = null), i !== null && !y && (c.current = window.setTimeout(() => {
    o(i.toFormat()), m(!0), c.current = null;
  }, 3e3)), () => {
    c.current !== null && (window.clearTimeout(c.current), c.current = null);
  }), [i, y]);
  const x = () => g || w ? !1 : s === void 0 || i === null ? !0 : i.plus(S).isLessThanOrEqualTo(s), E = () => g || w ? !1 : a === void 0 || i === null ? !0 : i.minus(S).isGreaterThanOrEqualTo(a), k = (e) => {
    let r = e;
    return a !== void 0 && e.isLessThan(a) && (r = a), s !== void 0 && e.isGreaterThan(s) && (r = s), r;
  }, P = () => {
    if (!x()) return;
    let e;
    i === null ? e = S : e = i.plus(S), s !== void 0 && e.isGreaterThan(s) && (e = s), l(e), o(e.toString()), m(!1), n == null || n(e);
  }, h = () => {
    if (!E()) return;
    let e;
    i === null ? e = S.negated() : e = i.minus(S), a !== void 0 && e.isLessThan(a) && (e = a), l(e), o(e.toString()), m(!1), n == null || n(e);
  }, B = (e) => e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), M = (e) => {
    if (!e) return "";
    const r = {
      ...N,
      ...d.formatOptions
    };
    let t = e;
    r.prefix && t.startsWith(r.prefix) && (t = t.substring(r.prefix.length)), r.suffix && t.endsWith(r.suffix) && (t = t.substring(0, t.length - r.suffix.length));
    const f = new RegExp(
      B(r.groupSeparator),
      "g"
    );
    if (t = t.replace(f, ""), r.decimalSeparator !== ".") {
      const b = new RegExp(
        B(r.decimalSeparator),
        "g"
      );
      t = t.replace(b, ".");
    }
    return t.trim();
  }, I = (e) => e === "" || e === "-" ? !0 : /^-?\d*\.?\d*$/.test(e), G = (e) => {
    const r = e.target.value;
    if (y) {
      m(!1);
      const t = M(r);
      if (I(t))
        try {
          if (t === "" || t === "-") {
            o(t), l(null), t === "" && (n == null || n(new u(0)));
            return;
          }
          const f = new u(t), b = k(f);
          b.isEqualTo(f) ? o(t) : o(b.toString()), l(b), n == null || n(b);
        } catch (f) {
          console.error("Error parsing unformatted value:", f), o(t), l(null);
        }
      return;
    }
    if (I(r))
      try {
        if (r === "" || r === "-") {
          o(r), l(null), r === "" && (n == null || n(new u(0)));
          return;
        }
        const t = new u(r), f = k(t);
        f.isEqualTo(t) ? o(r) : o(f.toString()), l(f), n == null || n(f);
      } catch (t) {
        console.error("Error parsing input as BigNumber:", t), o(r), l(null);
      }
  }, L = (e) => {
    c.current !== null && (window.clearTimeout(c.current), c.current = null), y && i !== null && (o(i.toString()), m(!1));
  }, $ = () => {
    i !== null ? (o(i.toFormat()), m(!0)) : D !== "" && D !== "-" && o("");
  }, W = (e) => {
    if (g || w) return;
    const r = [
      "Backspace",
      "Delete",
      "Tab",
      "Escape",
      "Enter",
      ".",
      "-",
      "ArrowLeft",
      "ArrowRight",
      "ArrowUp",
      "ArrowDown",
      "Home",
      "End"
    ];
    if (e.ctrlKey && ["a", "c", "v", "x"].includes(e.key) || r.includes(e.key) || // Allow numbers
    /^\d$/.test(e.key)) {
      if (e.key === "-" && e.currentTarget.selectionStart !== 0) {
        e.preventDefault();
        return;
      }
      if (e.key === "." && D.includes(".")) {
        e.preventDefault();
        return;
      }
      switch (e.key) {
        case "ArrowUp":
          e.preventDefault(), P();
          break;
        case "ArrowDown":
          e.preventDefault(), h();
          break;
        case "Home":
          a !== void 0 && (e.preventDefault(), l(a), o(a.toString()), m(!1), n == null || n(a));
          break;
        case "End":
          s !== void 0 && (e.preventDefault(), l(s), o(s.toString()), m(!1), n == null || n(s));
          break;
      }
      return;
    }
    e.preventDefault();
  }, K = (e) => {
    g || w || q || Math.abs(e.deltaY) <= Math.abs(e.deltaX) || (e.deltaY > 0 ? P() : e.deltaY < 0 && h());
  }, z = () => {
    const e = {
      role: "spinbutton",
      "aria-valuemin": (a == null ? void 0 : a.toString()) || "",
      "aria-valuemax": (s == null ? void 0 : s.toString()) || "",
      "aria-valuenow": (i == null ? void 0 : i.toString()) || "",
      "aria-valuetext": (i == null ? void 0 : i.toString()) || ""
    };
    return g && (e["aria-disabled"] = !0), w && (e["aria-readonly"] = !0), d.isRequired && (e["aria-required"] = !0), e;
  }, U = () => ({
    id: v,
    type: "text",
    inputMode: "decimal",
    value: D,
    onChange: G,
    onFocus: L,
    onBlur: $,
    onKeyDown: W,
    onWheel: K,
    disabled: g || w,
    readOnly: w,
    required: d.isRequired,
    placeholder: d.placeholder,
    ...z(),
    ...d.inputProps
  }), Y = () => ({
    htmlFor: v
  }), _ = () => ({
    type: "button",
    "aria-label": "Increment",
    "aria-controls": v,
    slot: "increment",
    isDisabled: !x(),
    onPress: P
  }), H = () => ({
    type: "button",
    "aria-label": "Decrement",
    "aria-controls": v,
    slot: "decrement",
    isDisabled: !E(),
    onPress: h
  }), X = () => ({
    "aria-disabled": g || void 0
  }), j = () => ({
    id: d.description ? `${v}-description` : void 0,
    slot: "description"
  }), J = () => ({
    id: d.errorMessage ? `${v}-error` : void 0
  });
  return {
    inputProps: U(),
    labelProps: Y(),
    incrementButtonProps: _(),
    decrementButtonProps: H(),
    groupProps: X(),
    descriptionProps: j(),
    errorMessageProps: J(),
    inputValue: D,
    numberValue: i,
    canIncrement: x(),
    canDecrement: E()
  };
}
export {
  ee as useBigNumberField
};
