import { useContextProps as $, useSlottedContext as E, useSlot as F, removeDataAttributes as B, useRenderProps as D, Provider as I } from "./ui-components-library119.js";
import { FieldErrorContext as M } from "./ui-components-library48.js";
import { FormContext as O } from "./ui-components-library136.js";
import { InputContext as c } from "./ui-components-library62.js";
import { LabelContext as g } from "./ui-components-library46.js";
import { TextAreaContext as _ } from "./ui-components-library69.js";
import { TextContext as q } from "./ui-components-library64.js";
import { createHideableComponent as A } from "./ui-components-library121.js";
import { mergeProps as S } from "./ui-components-library123.js";
import { filterDOMProps as H } from "./ui-components-library124.js";
import b, { createContext as L, useRef as k, useState as N, useCallback as V } from "react";
import { useTextField as j } from "./ui-components-library200.js";
const w = /* @__PURE__ */ L(null), re = /* @__PURE__ */ A(function(e, t) {
  [e, t] = $(e, t, w);
  let { validationBehavior: u } = E(O) || {};
  var a, r;
  let x = (r = (a = e.validationBehavior) !== null && a !== void 0 ? a : u) !== null && r !== void 0 ? r : "native", p = k(null), [m, i] = $({}, p, c), [v, P] = F(!e["aria-label"] && !e["aria-labelledby"]), [C, R] = N("input"), { labelProps: T, inputProps: l, descriptionProps: y, errorMessageProps: h, ...d } = j({
    ...B(e),
    inputElementType: C,
    label: P,
    validationBehavior: x
  }, i), n = V((o) => {
    i.current = o, o && R(o instanceof HTMLTextAreaElement ? "textarea" : "input");
  }, [
    i
  ]), f = D({
    ...e,
    values: {
      isDisabled: e.isDisabled || !1,
      isInvalid: d.isInvalid,
      isReadOnly: e.isReadOnly || !1,
      isRequired: e.isRequired || !1
    },
    defaultClassName: "react-aria-TextField"
  }), s = H(e);
  return delete s.id, /* @__PURE__ */ b.createElement("div", {
    ...s,
    ...f,
    ref: t,
    slot: e.slot || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-invalid": d.isInvalid || void 0,
    "data-readonly": e.isReadOnly || void 0,
    "data-required": e.isRequired || void 0
  }, /* @__PURE__ */ b.createElement(I, {
    values: [
      [
        g,
        {
          ...T,
          ref: v
        }
      ],
      [
        c,
        {
          ...S(l, m),
          ref: n
        }
      ],
      [
        _,
        {
          ...l,
          ref: n
        }
      ],
      [
        q,
        {
          slots: {
            description: y,
            errorMessage: h
          }
        }
      ],
      [
        M,
        d
      ]
    ]
  }, f.children));
});
export {
  re as TextField,
  w as TextFieldContext
};
