import { ButtonContext as S } from "./ui-components-library42.js";
import { useContextProps as n, useSlottedContext as D, useSlot as F, removeDataAttributes as I, useRenderProps as R, Provider as g } from "./ui-components-library119.js";
import { FieldErrorContext as M } from "./ui-components-library48.js";
import { FormContext as _ } from "./ui-components-library136.js";
import { GroupContext as E } from "./ui-components-library61.js";
import { InputContext as b } from "./ui-components-library62.js";
import { LabelContext as y } from "./ui-components-library46.js";
import { TextContext as O } from "./ui-components-library64.js";
import { createHideableComponent as A } from "./ui-components-library121.js";
import { mergeProps as G } from "./ui-components-library123.js";
import { filterDOMProps as H } from "./ui-components-library124.js";
import $, { createContext as L, useRef as N } from "react";
import { useSearchFieldState as T } from "./ui-components-library185.js";
import { useSearchField as V } from "./ui-components-library186.js";
const j = /* @__PURE__ */ L(null), re = /* @__PURE__ */ A(function(e, r) {
  [e, r] = n(e, r, j);
  let { validationBehavior: c } = D(_) || {};
  var o, i;
  let d = (i = (o = e.validationBehavior) !== null && o !== void 0 ? o : c) !== null && i !== void 0 ? i : "native", p = N(null), [m, l] = n({}, p, b), [u, x] = F(!e["aria-label"] && !e["aria-labelledby"]), a = T({
    ...e,
    validationBehavior: d
  }), { labelProps: v, inputProps: P, clearButtonProps: h, descriptionProps: C, errorMessageProps: B, ...t } = V({
    ...I(e),
    label: x,
    validationBehavior: d
  }, a, l), s = R({
    ...e,
    values: {
      isEmpty: a.value === "",
      isDisabled: e.isDisabled || !1,
      isInvalid: t.isInvalid || !1,
      state: a
    },
    defaultClassName: "react-aria-SearchField"
  }), f = H(e);
  return delete f.id, /* @__PURE__ */ $.createElement("div", {
    ...f,
    ...s,
    ref: r,
    slot: e.slot || void 0,
    "data-empty": a.value === "" || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-invalid": t.isInvalid || void 0
  }, /* @__PURE__ */ $.createElement(g, {
    values: [
      [
        y,
        {
          ...v,
          ref: u
        }
      ],
      [
        b,
        {
          ...G(P, m),
          ref: l
        }
      ],
      [
        S,
        h
      ],
      [
        O,
        {
          slots: {
            description: C,
            errorMessage: B
          }
        }
      ],
      [
        E,
        {
          isInvalid: t.isInvalid,
          isDisabled: e.isDisabled || !1
        }
      ],
      [
        M,
        t
      ]
    ]
  }, s.children));
});
export {
  re as SearchField,
  j as SearchFieldContext
};
