import { useContextProps as h, useSlot as y, useRenderProps as b, Provider as T, useSlottedContext as w } from "./ui-components-library119.js";
import { LabelContext as N } from "./ui-components-library46.js";
import { mergeProps as S } from "./ui-components-library123.js";
import { filterDOMProps as O } from "./ui-components-library124.js";
import i, { forwardRef as $, createContext as m, useRef as V, useContext as g } from "react";
import { useNumberFormatter as j } from "./ui-components-library190.js";
import { useSliderState as q } from "./ui-components-library191.js";
import { useSlider as z } from "./ui-components-library192.js";
import { useSliderThumb as A } from "./ui-components-library193.js";
import { useHover as M } from "./ui-components-library127.js";
import { useFocusRing as B } from "./ui-components-library126.js";
import { VisuallyHidden as G } from "./ui-components-library135.js";
const J = /* @__PURE__ */ m(null), p = /* @__PURE__ */ m(null), D = /* @__PURE__ */ m(null), I = /* @__PURE__ */ m(null), oe = /* @__PURE__ */ $(function(e, t) {
  [e, t] = h(e, t, J);
  let r = V(null), o = j(e.formatOptions), a = q({
    ...e,
    numberFormatter: o
  }), [s, d] = y(!e["aria-label"] && !e["aria-labelledby"]), { groupProps: l, trackProps: n, labelProps: f, outputProps: u } = z({
    ...e,
    label: d
  }, a, r), v = b({
    ...e,
    values: {
      orientation: a.orientation,
      isDisabled: a.isDisabled,
      state: a
    },
    defaultClassName: "react-aria-Slider"
  }), c = O(e);
  return delete c.id, /* @__PURE__ */ i.createElement(T, {
    values: [
      [
        p,
        a
      ],
      [
        D,
        {
          ...n,
          ref: r
        }
      ],
      [
        I,
        u
      ],
      [
        N,
        {
          ...f,
          ref: s
        }
      ]
    ]
  }, /* @__PURE__ */ i.createElement("div", {
    ...c,
    ...l,
    ...v,
    ref: t,
    slot: e.slot || void 0,
    "data-orientation": a.orientation,
    "data-disabled": a.isDisabled || void 0
  }));
}), le = /* @__PURE__ */ $(function(e, t) {
  [e, t] = h(e, t, I);
  let { children: r, style: o, className: a, ...s } = e, d = g(p), l = b({
    className: a,
    style: o,
    children: r,
    defaultChildren: d.getThumbValueLabel(0),
    defaultClassName: "react-aria-SliderOutput",
    values: {
      orientation: d.orientation,
      isDisabled: d.isDisabled,
      state: d
    }
  });
  return /* @__PURE__ */ i.createElement("output", {
    ...s,
    ...l,
    ref: t,
    "data-orientation": d.orientation || void 0,
    "data-disabled": d.isDisabled || void 0
  });
}), ie = /* @__PURE__ */ $(function(e, t) {
  [e, t] = h(e, t, D);
  let r = g(p), { onHoverStart: o, onHoverEnd: a, onHoverChange: s, ...d } = e, { hoverProps: l, isHovered: n } = M({
    onHoverStart: o,
    onHoverEnd: a,
    onHoverChange: s
  }), f = b({
    ...e,
    defaultClassName: "react-aria-SliderTrack",
    values: {
      orientation: r.orientation,
      isDisabled: r.isDisabled,
      isHovered: n,
      state: r
    }
  });
  return /* @__PURE__ */ i.createElement("div", {
    ...S(d, l),
    ...f,
    ref: t,
    "data-hovered": n || void 0,
    "data-orientation": r.orientation || void 0,
    "data-disabled": r.isDisabled || void 0
  });
}), se = /* @__PURE__ */ $(function(e, t) {
  let { inputRef: r = null } = e, o = g(p), { ref: a } = w(D), { index: s = 0 } = e, d = V(null), l = r || d, [n, f] = y(!e["aria-label"] && !e["aria-labelledby"]), { thumbProps: u, inputProps: v, labelProps: c, isDragging: C, isFocused: H, isDisabled: R } = A({
    ...e,
    index: s,
    trackRef: a,
    inputRef: l,
    label: f
  }, o), { focusProps: L, isFocusVisible: E } = B(), { hoverProps: _, isHovered: F } = M(e), P = b({
    ...e,
    defaultClassName: "react-aria-SliderThumb",
    values: {
      state: o,
      isHovered: F,
      isDragging: C,
      isFocused: H,
      isFocusVisible: E,
      isDisabled: R
    }
  }), k = O(e);
  return delete k.id, /* @__PURE__ */ i.createElement("div", {
    ...S(k, u, _),
    ...P,
    ref: t,
    style: {
      ...u.style,
      ...P.style
    },
    "data-hovered": F || void 0,
    "data-dragging": C || void 0,
    "data-focused": H || void 0,
    "data-focus-visible": E || void 0,
    "data-disabled": R || void 0
  }, /* @__PURE__ */ i.createElement(G, null, /* @__PURE__ */ i.createElement("input", {
    ref: l,
    ...S(v, L)
  })), /* @__PURE__ */ i.createElement(T, {
    values: [
      [
        N,
        {
          ...c,
          ref: n
        }
      ]
    ]
  }, P.children));
});
export {
  oe as Slider,
  J as SliderContext,
  le as SliderOutput,
  I as SliderOutputContext,
  p as SliderStateContext,
  se as SliderThumb,
  ie as SliderTrack,
  D as SliderTrackContext
};
