import { useContextProps as L, useRenderProps as z, Provider as O } from "./ui-components-library119.js";
import T from "./ui-components-library151.js";
import { TextContext as V } from "./ui-components-library64.js";
import { useSlotId as Z } from "./ui-components-library122.js";
import { mergeProps as v } from "./ui-components-library123.js";
import { filterDOMProps as _ } from "./ui-components-library124.js";
import { useLabels as k } from "./ui-components-library152.js";
import { useObjectRef as I } from "./ui-components-library138.js";
import { isFocusable as M } from "./ui-components-library153.js";
import d, { forwardRef as j, createContext as w, useRef as S } from "react";
import { useDrop as N } from "./ui-components-library154.js";
import { useClipboard as q } from "./ui-components-library155.js";
import { useButton as A } from "./ui-components-library125.js";
import { useHover as G } from "./ui-components-library127.js";
import { useFocusRing as J } from "./ui-components-library126.js";
import { useLocalizedStringFormatter as K } from "./ui-components-library156.js";
import { VisuallyHidden as Q } from "./ui-components-library135.js";
function U(t) {
  return t && t.__esModule ? t.default : t;
}
const W = /* @__PURE__ */ w(null), ue = /* @__PURE__ */ j(function(e, s) {
  let { isDisabled: i = !1 } = e;
  [e, s] = L(e, s, W);
  let l = I(s), a = S(null), { dropProps: P, dropButtonProps: D, isDropTarget: n } = N({
    ...e,
    ref: a,
    hasDropButton: !0
  }), { buttonProps: g } = A(D || {}, a), { hoverProps: F, isHovered: b } = G(e), { focusProps: y, isFocused: p, isFocusVisible: $ } = J(), C = K(U(T), "react-aria-components"), u = Z(), R = e["aria-label"] || C.format("dropzoneLabel"), h = e["aria-labelledby"], B = [
    u,
    h
  ].filter(Boolean).join(" "), E = k({
    "aria-label": R,
    "aria-labelledby": B
  }), { clipboardProps: H } = q({
    isDisabled: i,
    onPaste: (f) => {
      var o;
      return (o = e.onDrop) === null || o === void 0 ? void 0 : o.call(e, {
        type: "drop",
        items: f,
        x: 0,
        y: 0,
        dropOperation: "copy"
      });
    }
  }), m = z({
    ...e,
    values: {
      isHovered: b,
      isFocused: p,
      isFocusVisible: $,
      isDropTarget: n,
      isDisabled: i
    },
    defaultClassName: "react-aria-DropZone"
  }), x = _(e);
  return delete x.id, /* @__PURE__ */ d.createElement(O, {
    values: [
      [
        V,
        {
          id: u,
          slot: "label"
        }
      ]
    ]
  }, /* @__PURE__ */ d.createElement("div", {
    ...v(P, F, x),
    ...m,
    slot: e.slot || void 0,
    ref: l,
    onClick: (f) => {
      var o;
      let r = f.target;
      for (; r && (!((o = l.current) === null || o === void 0) && o.contains(r)) && !M(r); ) {
        if (r === l.current) {
          var c;
          (c = a.current) === null || c === void 0 || c.focus();
          break;
        }
        r = r.parentElement;
      }
    },
    "data-hovered": b || void 0,
    "data-focused": p || void 0,
    "data-focus-visible": $ || void 0,
    "data-drop-target": n || void 0,
    "data-disabled": i || void 0
  }, /* @__PURE__ */ d.createElement(Q, null, /* @__PURE__ */ d.createElement("button", {
    ...v(g, y, H, E),
    ref: a
  })), m.children));
});
export {
  ue as DropZone,
  W as DropZoneContext
};
