import { ButtonContext as S } from "./ui-components-library42.js";
import { CalendarContext as I } from "./ui-components-library128.js";
import { useContextProps as M, useSlottedContext as _, useSlot as w, removeDataAttributes as y, useRenderProps as V, Provider as W } from "./ui-components-library119.js";
import { DateFieldContext as z } from "./ui-components-library143.js";
import { OverlayTriggerStateContext as E, DialogContext as T } from "./ui-components-library75.js";
import { FieldErrorContext as G } from "./ui-components-library48.js";
import { FormContext as A } from "./ui-components-library136.js";
import { GroupContext as L } from "./ui-components-library61.js";
import { LabelContext as N } from "./ui-components-library46.js";
import { PopoverContext as j } from "./ui-components-library76.js";
import { TextContext as q } from "./ui-components-library64.js";
import { filterDOMProps as H } from "./ui-components-library124.js";
import { useResizeObserver as J } from "./ui-components-library147.js";
import c, { forwardRef as K, createContext as n, useRef as Q, useState as U, useCallback as X } from "react";
import { useDatePickerState as Y } from "./ui-components-library148.js";
import { useDatePicker as Z } from "./ui-components-library149.js";
import { useFocusRing as ee } from "./ui-components-library126.js";
const te = /* @__PURE__ */ n(null), ae = /* @__PURE__ */ n(null), Ce = /* @__PURE__ */ K(function(e, o) {
  [e, o] = M(e, o, te);
  let { validationBehavior: $ } = _(A) || {};
  var r, i;
  let d = (i = (r = e.validationBehavior) !== null && r !== void 0 ? r : $) !== null && i !== void 0 ? i : "native", t = Y({
    ...e,
    validationBehavior: d
  }), a = Q(null), [b, p] = w(!e["aria-label"] && !e["aria-labelledby"]), { groupProps: u, labelProps: x, fieldProps: m, buttonProps: P, dialogProps: v, calendarProps: g, descriptionProps: C, errorMessageProps: D, ...h } = Z({
    ...y(e),
    label: p,
    validationBehavior: d
  }, t, a), [R, F] = U(null), k = X(() => {
    a.current && F(a.current.offsetWidth + "px");
  }, []);
  J({
    ref: a,
    onResize: k
  });
  let { focusProps: B, isFocused: s, isFocusVisible: f } = ee({
    within: !0
  }), O = V({
    ...e,
    values: {
      state: t,
      isFocusWithin: s,
      isFocusVisible: f,
      isDisabled: e.isDisabled || !1,
      isInvalid: t.isInvalid,
      isOpen: t.isOpen
    },
    defaultClassName: "react-aria-DatePicker"
  }), l = H(e);
  return delete l.id, /* @__PURE__ */ c.createElement(W, {
    values: [
      [
        ae,
        t
      ],
      [
        L,
        {
          ...u,
          ref: a,
          isInvalid: t.isInvalid
        }
      ],
      [
        z,
        m
      ],
      [
        S,
        {
          ...P,
          isPressed: t.isOpen
        }
      ],
      [
        N,
        {
          ...x,
          ref: b,
          elementType: "span"
        }
      ],
      [
        I,
        g
      ],
      [
        E,
        t
      ],
      [
        j,
        {
          trigger: "DatePicker",
          triggerRef: a,
          placement: "bottom start",
          style: {
            "--trigger-width": R
          }
        }
      ],
      [
        T,
        v
      ],
      [
        q,
        {
          slots: {
            description: C,
            errorMessage: D
          }
        }
      ],
      [
        G,
        h
      ]
    ]
  }, /* @__PURE__ */ c.createElement("div", {
    ...B,
    ...l,
    ...O,
    ref: o,
    slot: e.slot || void 0,
    "data-focus-within": s || void 0,
    "data-invalid": t.isInvalid || void 0,
    "data-focus-visible": f || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-open": t.isOpen || void 0
  }));
});
export {
  Ce as DatePicker,
  te as DatePickerContext,
  ae as DatePickerStateContext
};
