import { j as e } from "./ui-components-library39.js";
import { clsx as t } from "./ui-components-library47.js";
import { Button as n } from "./ui-components-library42.js";
import { Calendar as f, CalendarGrid as m, CalendarGridHeader as c, CalendarHeaderCell as p, CalendarGridBody as x, CalendarCell as u } from "./ui-components-library128.js";
import { Heading as b } from "./ui-components-library159.js";
import l from "./ui-components-library254.js";
import { cn as r } from "./ui-components-library41.js";
const j = () => /* @__PURE__ */ e.jsxs(
  f,
  {
    className: "flex w-82.5 flex-col items-center",
    firstDayOfWeek: "mon",
    children: [
      /* @__PURE__ */ e.jsxs(
        "header",
        {
          className: t(
            "flex h-16 w-full items-center justify-between p-6",
            "border-b-klerosUIComponentsStroke border-b"
          ),
          children: [
            /* @__PURE__ */ e.jsx(
              n,
              {
                slot: "previous",
                className: t(
                  "focus:outline-klerosUIComponentsPrimaryBlue rounded-base focus:outline-offset-2",
                  "cursor-pointer disabled:cursor-default"
                ),
                children: ({ isDisabled: o, isHovered: s }) => /* @__PURE__ */ e.jsx(
                  l,
                  {
                    className: r(
                      "fill-klerosUIComponentsPrimaryBlue ease-ease size-4 transition",
                      o && "fill-klerosUIComponentsStroke",
                      s && "fill-klerosUIComponentsSecondaryBlue"
                    )
                  }
                )
              }
            ),
            /* @__PURE__ */ e.jsx(b, { className: "text-klerosUIComponentsPrimaryText text-base font-semibold select-none" }),
            /* @__PURE__ */ e.jsx(
              n,
              {
                slot: "next",
                className: "focus:outline-klerosUIComponentsPrimaryBlue rounded-base cursor-pointer focus:outline-offset-2",
                children: ({ isHovered: o }) => /* @__PURE__ */ e.jsx(
                  l,
                  {
                    className: r(
                      "ease-ease size-4 rotate-180 transition",
                      "fill-klerosUIComponentsPrimaryBlue",
                      o && "fill-klerosUIComponentsSecondaryBlue"
                    )
                  }
                )
              }
            )
          ]
        }
      ),
      /* @__PURE__ */ e.jsxs(
        m,
        {
          className: r(
            "mt-4 mb-6",
            "border-separate border-spacing-x-1.75 border-spacing-y-0.5"
          ),
          weekdayStyle: "short",
          children: [
            /* @__PURE__ */ e.jsx(c, { children: (o) => /* @__PURE__ */ e.jsx(
              p,
              {
                className: t(
                  "size-6 cursor-pointer pb-1",
                  "text-klerosUIComponentsPrimaryText text-center text-sm font-semibold"
                ),
                children: o.substring(0, 2)
              }
            ) }),
            /* @__PURE__ */ e.jsx(x, { children: (o) => /* @__PURE__ */ e.jsx(
              u,
              {
                date: o,
                className: ({ isFocused: s, isUnavailable: a, isDisabled: d, isSelected: i }) => r(
                  "flex size-6 cursor-pointer items-center justify-center rounded-full",
                  "text-klerosUIComponentsSecondaryText text-center text-sm font-semibold",
                  "hover:bg-klerosUIComponentsSecondaryBlue hover:text-klerosUIComponentsWhiteBackground",
                  "outside-month:hidden",
                  i && [
                    "bg-klerosUIComponentsPrimaryBlue text-klerosUIComponentsWhiteBackground",
                    "hover:bg-klerosUIComponentsPrimaryBlue"
                  ],
                  (d || a) && "text-klerosUIComponentsStroke cursor-not-allowed",
                  s && [
                    "outline-klerosUIComponentsPrimaryBlue outline-2"
                  ]
                ),
                children: o.day.toString().length === 1 ? `0${o.day}` : o.day
              }
            ) })
          ]
        }
      )
    ]
  }
);
export {
  j as default
};
