import { useContextProps as D, removeDataAttributes as S, useRenderProps as y } from "./ui-components-library119.js";
import { mergeProps as b } from "./ui-components-library123.js";
import { mergeRefs as F } from "./ui-components-library137.js";
import { filterDOMProps as O } from "./ui-components-library124.js";
import { useObjectRef as w } from "./ui-components-library138.js";
import d, { forwardRef as g, createContext as H } from "react";
import { useToggleState as C } from "./ui-components-library141.js";
import { useSwitch as V } from "./ui-components-library194.js";
import { useFocusRing as E } from "./ui-components-library126.js";
import { useHover as I } from "./ui-components-library127.js";
import { VisuallyHidden as M } from "./ui-components-library135.js";
const T = /* @__PURE__ */ H(null), Q = /* @__PURE__ */ g(function(e, t) {
  let { inputRef: m = null, ...p } = e;
  [e, t] = D(p, t, T);
  let s = w(F(m, e.inputRef !== void 0 ? e.inputRef : null)), i = C(e), { labelProps: P, inputProps: x, isSelected: a, isDisabled: r, isReadOnly: o, isPressed: f } = V({
    ...S(e),
    // ReactNode type doesn't allow function children.
    children: typeof e.children == "function" ? !0 : e.children
  }, i, s), { isFocused: l, isFocusVisible: n, focusProps: R } = E(), h = e.isDisabled || e.isReadOnly, { hoverProps: v, isHovered: c } = I({
    ...e,
    isDisabled: h
  }), u = y({
    ...e,
    defaultClassName: "react-aria-Switch",
    values: {
      isSelected: a,
      isPressed: f,
      isHovered: c,
      isFocused: l,
      isFocusVisible: n,
      isDisabled: r,
      isReadOnly: o,
      state: i
    }
  }), $ = O(e);
  return delete $.id, /* @__PURE__ */ d.createElement("label", {
    ...b($, P, v, u),
    ref: t,
    slot: e.slot || void 0,
    "data-selected": a || void 0,
    "data-pressed": f || void 0,
    "data-hovered": c || void 0,
    "data-focused": l || void 0,
    "data-focus-visible": n || void 0,
    "data-disabled": r || void 0,
    "data-readonly": o || void 0
  }, /* @__PURE__ */ d.createElement(M, {
    elementType: "span"
  }, /* @__PURE__ */ d.createElement("input", {
    ...b(x, R),
    ref: s
  })), u.children);
});
export {
  Q as Switch,
  T as SwitchContext
};
