import { default as React, ReactNode } from 'react';
import { default as AccordionItem } from './accordion-item';
interface AccordionItem {
    title: string;
    body: ReactNode;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    icon?: ReactNode;
}
interface AccordionProps {
    items: AccordionItem[];
    defaultExpanded?: number;
    className?: string;
}
declare const Accordion: React.FC<AccordionProps>;
export default Accordion;
