import { default as React } from 'react';
interface BreadcrumbProps {
    items: {
        text: string;
        value: any;
    }[];
    callback?: Function;
    clickable?: boolean;
    className?: string;
    variant?: "primary" | "secondary";
}
declare function Breadcrumb({ items, callback, clickable, className, variant, }: Readonly<BreadcrumbProps>): React.JSX.Element;
export default Breadcrumb;
