import { default as React } from 'react';
import { TooltipBaseProps } from '../tooltip';
interface CopiableBaseProps {
    copiableContent: string;
    info?: string;
    iconPlacement?: "left" | "right";
}
interface CopiableProps extends CopiableBaseProps {
    children?: React.ReactNode;
    tooltipProps?: Omit<TooltipBaseProps, "children">;
    className?: string;
}
declare function Copiable({ copiableContent, info, children, tooltipProps, iconPlacement, className, ...props }: Readonly<CopiableProps>): React.JSX.Element;
export default Copiable;
