import { default as React } from 'react';
import { SelectProps as AriaSelectProps } from 'react-aria-components';
import { IItem } from './item';
interface SelectProps extends AriaSelectProps {
    items: IItem[];
    callback: (value: IItem) => void;
    simpleButton?: boolean;
    smallButton?: boolean;
    label?: string;
}
declare function DropdownSelect({ label, smallButton, simpleButton, items, callback, placeholder, className, ...props }: Readonly<SelectProps>): React.JSX.Element;
export default DropdownSelect;
