import { default as React } from 'react';
import { ButtonProps, DatePickerProps, DateValue } from 'react-aria-components';
export interface ArrowButtonProps extends ButtonProps {
    arrowType: "hour-increment" | "hour-decrement" | "minute-increment" | "minute-decrement";
    minValue: DatePickerProps<DateValue>["minValue"];
}
declare const ArrowButton: React.FC<ArrowButtonProps>;
export default ArrowButton;
