import { default as React } from 'react';
import { DatePickerProps as AriaDatePickerProps, DateValue } from 'react-aria-components';
interface DatePickerProps extends Omit<AriaDatePickerProps<DateValue>, "granularity" | "hourCycle" | "firstDayOfWeek"> {
    time?: boolean;
    label?: string;
}
declare function DatePicker({ label, time, minValue, defaultValue, shouldCloseOnSelect, ...props }: Readonly<DatePickerProps>): React.JSX.Element;
export default DatePicker;
