import { default as React } from 'react';
import { FileTriggerProps } from 'react-aria-components';
interface FileUploaderProps {
    callback: (file: File) => void;
    msg?: string;
    variant?: "success" | "warning" | "error" | "info";
    acceptedFileTypes?: FileTriggerProps["acceptedFileTypes"];
    fileTriggerProps?: Omit<FileTriggerProps, "acceptedFileTypes | onSelect">;
    isDisabled?: boolean;
    className?: string;
}
declare function FileUploader({ callback, msg, variant, className, acceptedFileTypes, fileTriggerProps, isDisabled, }: Readonly<FileUploaderProps>): React.JSX.Element;
export default FileUploader;
