import { default as React } from 'react';
import { FieldErrorProps, RadioGroupProps as AriaRadioGroupProps, RadioProps as AriaRadioProps } from 'react-aria-components';
interface RadioOption extends AriaRadioProps {
    label: string;
}
interface RadioGroupProps extends AriaRadioGroupProps {
    groupLabel?: string;
    small?: boolean;
    options: RadioOption[];
    fieldErrorProps?: FieldErrorProps;
}
declare function RadioGroup({ small, groupLabel, options, className, fieldErrorProps, ...props }: Readonly<RadioGroupProps>): React.JSX.Element;
export default RadioGroup;
