import { default as React } from 'react';
import { SliderProps as AriaSliderProps } from 'react-aria-components';
interface SliderProps extends Omit<AriaSliderProps, "orientation" | "formatOptions"> {
    leftLabel: string;
    rightLabel: string;
    formatter?: (value: number) => string;
    callback: (value: number) => void;
}
declare function Slider({ leftLabel, rightLabel, formatter, callback, ...props }: Readonly<SliderProps>): React.JSX.Element;
export default Slider;
