import { default as React } from 'react';
import { InputProps, TextFieldProps, TextAreaProps as AriaTextAreaProps } from 'react-aria-components';
interface TextAreaProps extends TextFieldProps {
    variant?: "success" | "warning" | "error" | "info";
    message?: string;
    placeholder?: InputProps["placeholder"];
    inputProps?: AriaTextAreaProps;
    label?: string;
    resizeX?: boolean;
    resizeY?: boolean;
}
declare function TextArea({ message, variant, className, label, placeholder, resizeX, resizeY, ...props }: Readonly<TextAreaProps>): React.JSX.Element;
export default TextArea;
