import { default as React } from 'react';
import { InputProps, TextFieldProps as AriaTextFieldProps } from 'react-aria-components';
interface TextFieldProps extends AriaTextFieldProps {
    variant?: "success" | "warning" | "error" | "info";
    message?: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    placeholder?: InputProps["placeholder"];
    inputProps?: InputProps;
    label?: string;
}
declare function TextField({ variant, message, Icon, className, placeholder, label, ...props }: Readonly<TextFieldProps>): React.JSX.Element;
export default TextField;
