import { default as React } from 'react';
type SmallProp = {
    small?: boolean;
};
type VariantProp = {
    variant: "success" | "error" | "sync";
};
interface PushProps extends SmallProp, VariantProp {
    title: string;
    msg?: string;
    callback: Function;
    className?: string;
}
declare function Push({ variant, title, msg, callback, small, className, ...props }: Readonly<PushProps>): React.JSX.Element;
export default Push;
