import { default as React } from 'react';
import { SideProp, VariantProp } from './bullet';
interface TimelineItem extends SideProp, VariantProp {
    title: string;
    party: string;
    subtitle: string;
}
interface TimelineProps {
    items: [TimelineItem, ...TimelineItem[]];
    className?: string;
}
declare function Timeline({ items, className, ...props }: Readonly<TimelineProps>): React.JSX.Element;
export default Timeline;
