import { default as React } from 'react';
import { ButtonProps } from 'react-aria-components';
interface BaseTagProps extends ButtonProps {
    active?: boolean;
}
interface TagProps extends BaseTagProps {
    text: string;
}
declare function Tag({ text, active, className, ...props }: Readonly<TagProps>): React.JSX.Element;
export default Tag;
